#include "ccx.h"
#include <stdlib.h>
#include <malloc.h>
#include <signal.h>
#include <stdio.h>

#ifndef NULL
#define NULL 0
#endif

//
// come from atexit.c
//

void  p_exit(n)
int n;
{
    fatalError=n;
	return ;
}

//
// come from ccdata.c
//


/*
 * parser suite - and / or / nothing / something  parsers
 *
 * parser = [token] -> ([token],status)
 *
 * implemented as sideeffecting on [token], returns status.
 */


/* globals */

int             p_argc;
char          **p_argv;
TOKEN          *buffer;        /* where the pstr points to */
TOKEN          *yybuffer;      /* internal name for buffer */
VALUE          *lvbuff;        /* the parallel stack of yylvals */

int             fatalError = 0;         // flow control
int             errorcount = 0;         // to use counting errors
int             dummy;

INSTRUCTION    *program;
STACKVALUE     *stack;        /* the evaluation stack - either values or
                               * tokens */
STACKVALUE     *value;
FRAME           p_frame;      /* all one needs to know for a rewind */
FRAME          *fstack;
FRAME          *fptr;

 /* this IS a frame */

TOKEN          *pstr;         /* parsed stream */
int             pc;           /* program counter - counts up from 0 */
int             passcount=0;    /* input lines counted here */

 /* end of frame */

INSTRUCTION     instr;        /* instruction cache */
TOKEN          *maxp;        /* maximum number parsed so far */
int             call_mode = 0;    /* flag for call convention. 1 = pascal
                              * (manual), 0 = C (auto) */
int             optimize = 0;    /* flag for flying program optimization */
PARSER         *p_entry;    /* entry point set by p_run & btck_error */
int             p_enargs;
PARAM           p_eargv[MAXARGS];

PRECC_DATA      precc_data;

static VOID mkgen(void**, void**, int, int);
static VOID freegen(void**);

static VOID mkgen (s,v,n,m)
void **s, **v;
int n;
int m;
/* if *s, make a generic item of size n*m and put it in *v and *s */
{
    if (*s != NULL)
      return;
    *s = (void *) p_calloc (n, m);
    *v = *s;
}


VOID mkstack ()
/* make the attribute stack of the right sizes and install it */
{
    mkgen ((void**)&stack, (void**)&value, precc_data.stacksize, sizeof(STACKVALUE));
}

static VOID freegen (s)
void **s;
{
    if (*s == NULL)
      return;
    p_free (*s);
    *s = NULL;        /* so that we don't try freeing it twice */
}

VOID freestack ()
{
    freegen ((void**)&stack);
}

VOID  p_creat_data ()
/* we think one of the stacks at least is NULL, and we try and alloc it */
{
    long            bytesfree;

   
    bytesfree = p_memleft ();
  
    /* but which stack is it? */

    /* compilation warnings for maybe losing digits from the args of
     * p_calloc should always be ignored. The numbers can't be that big! */

    mkgen ((void**)&buffer, (void**)&buffer, precc_data.readbuffersize,sizeof(TOKEN));

    mkgen ((void**)&lvbuff, (void**)&lvbuff, precc_data.readbuffersize,sizeof(VALUE)); 
   
    mkgen ((void**)&program, (void**)&program, precc_data.maxprogramsize,
                                           sizeof(INSTRUCTION));
										   
    mkgen ((void**)&stack, (void**)&value, precc_data.stacksize, sizeof(STACKVALUE));

    mkgen ((void**)&fstack, (void**)&fptr, precc_data.contextstacksize,sizeof(FRAME));

  
    if (buffer == NULL || lvbuff == NULL ||
       program == NULL || stack  == NULL || fstack == NULL)
    {
        //fprintf (stderr,
        //"error; not enough memory (%lu) for internal stacks\n", bytesfree);
        p_exit (11);
    }
    return;
}

VOID            p_destr_data ()
{
    freegen ((void**)&buffer);
    freegen ((void**)&lvbuff);
    freegen ((void**)&program);
    freegen ((void**)&stack);
    freegen ((void**)&fstack);
}





//
// come from common.c
//

STATUS   p_nothing0 ()
/*
p_parser succeeds without looking at any tokens from
the input stream.
*/
{

    pushINCR;

    return SUCCESS;
}

STATUS   p_anything0 ()
/*
Parser which takes any token at all - except 0 - and places it as
a constant on the program stack.  This p_parser only fails at EOS.
*/
{
    TOKEN c;
    VALUE v;

        c = *pstr;
        v = lvbuff[(int)(pstr-buffer)];
        /*if (c) */
		if (yytchar != EOF) /* need to be here by ..sang */
        {
           MOVEON;
        pushVALUE(v);
        return OK(v);    /* so CAN'T use attribute 0 */
        }
        return FAILURE;
}


STATUS   p_first0 ()
/*
This p_parser only succeeds at BOS and does nothing
*/
{    /* pstr CAN'T be < buffer. I am just being careful */
    if ((void*)pstr <= (void*)buffer || pstr[-1]==(TOKEN)0) {
        pushVALUE(SUCCESS);
        return SUCCESS;
        }
    /* doesnt move on */
    return FAILURE;
}


STATUS  p_uerror0  (p)  
/* return OK but set a frame boundary and an error handler parser p */
PARSER *p;
{
        pushEXIT;

        pc=0;
        pc=p_evaluate ();
        pc=0;   /* we have to write the next program in the right place */

        /* we can't reset the pstr at present. Only when we get a backtrack
           can we seem to be able to do it, perhaps because that's like an escape to top level, where
           we do reset the pstr every time. The problem is MAYBE that earlier
           sequents are holding frame info which points into the pstr as
           it is now. OK, we can't backtrack to them, but still ...
           -- hmm. this may be past history now.
         */


        /* why am I looking to skip the 0 token here? Surely it is
         * just like any other token?
         */
		
		/*printf("\n..");*/
       
        {
                realignbuffer();
        }

        passcount++;  /* that means that a backtrack error will be
                         signalled if we try and backtrack through here */

        p_enargs= 0;
        p_entry = p;  /* set the btck_error reentry pt */

        /* Uh, not at all sure about the next, folks! - we won't backtrack
         * but we are still inside various andparse things that will all
         * try and pop the frame stack as they exit!!
         */

        return (SUCCESS);

   /* and don't reset STACKVALUE *value because we may later backtrack
    * to earlier stack values  - hey, that's past history now too!
    * We don't have an attribute stack any more. */
}


STATUS  p_uniq0  ()
{
    return p_uerror0(0);
}



STATUS   p_last0 ()
/*									   ** character mode only **
This p_parser only succeeds at EOS.
*/
{
    if ((yytchar!=EOF) && (0 == *pstr))  /* does move on */
        {
            MOVEON;
            pushVALUE(EOF);

         /* the MOVEON did the pull of a token into the lookahead buff */
            
            return OK(EOF);
        }
    return FAILURE;
}


STATUS   p_exactly0 (c)
/*
this parser only succeeds when given token c.
It places the token's attribute as a literal on the program stack,
but not on the value stack. It gets put onto the latter at
runtime. It's also the return value, and a NULL attrib is changed
according to the OK macro to prevent a FAIL return in those cases.
*/
TOKEN   c;
{
    VALUE v;

    if (*pstr == c)
    {                     /* read the attribute value */
        v=lvbuff[(int)(pstr-buffer)];
        MOVEON;
        pushVALUE(v); /* save the attribute on the program stack */
        return OK(v);
    }
    return FAILURE;
}

STATUS   p_notexactly0 (c)
/*
this p_parser only succeds when given a TOKEN not equal to c.
It places the token's attribute as a literal on the program stack.
*/
TOKEN   c;
{
    VALUE v;
    if (*pstr != c)
    {
        c=*pstr;
        v=lvbuff[(int)(pstr-buffer)];
        MOVEON;
        pushVALUE(v);
        return OK(v);
    }
    return FAILURE;
}


STATUS  p_attach0 (p)
PARSER *p;
{
    return (*p) ();
}


STATUS  p_atch0 (v)
PARAM v;
/*
trivial parser which returns a fixed value
*/
{
    return OK((VALUE)v);
}


VOID  p_nop()
/*
a very trivial stack manipulation action
*/
{
}



/*
   parser suite - and / or / nothing / something  parsers

   parser = [token] -> ([token],status)
    
   implemented as sideeffecting on [token], returns status.
*/

//
// come from ccx.c
//

static PARAM a0[MAXARGS], *a=a0;        /* holds parameters */

STATUS p_errparse0 ()
/* I'm just here to help detect errors */
{
    //fprintf(stderr,"An unspecified parser has been called. Aborting.\n");
    p_exit(12);
        /* this is never called */
    return FAILURE;
}


STATUS p_andparse0n (PARSER *p, ...)
/*
Serial composition of parsers. Does
first p then q. Put p's instructions on the
top of the program stack, then layer q's above
it.
This version has full rewind of the input stream on
failure, but this can be altered to single token
lookahead by deleting the line of code marked.
*/
{
    static PARSER *q=p_errparse0;
    va_list ap;

    static int m;
    static status  tok;

    MARK;

    va_start(ap,p);

    m=va_arg(ap,int);
    a=(PARAM*)ap; /* very NON-PORTABLE, but it's fast */
    ap=(va_list)&a[m];
    m++;
    switch(m-1) {
    case 0: tok=(*p)();break;
    case 1: tok=(*p)(a[0]);break;
    case 2: tok=(*p)(a[0],a[1]);break;
    case 3: tok=(*p)(a[0],a[1],a[2]);break;
    case 4: tok=(*p)(a[0],a[1],a[2],a[3]);break;
    case 5: tok=(*p)(a[0],a[1],a[2],a[3],a[4]);break;
    case 6: tok=(*p)(a[0],a[1],a[2],a[3],a[4],a[5]);break;
    case 7: tok=(*p)(a[0],a[1],a[2],a[3],a[4],a[5],a[6]);break;
    case 8: tok=(*p)(a[0],a[1],a[2],a[3],a[4],a[5],a[6],a[7]);break;
    case 9: tok=(*p)(a[0],a[1],a[2],a[3],a[4],a[5],a[6],a[7],a[8]);break;
    case 10: tok=(*p)(a[0],a[1],a[2],a[3],a[4],a[5],a[6],a[7],a[8],a[9]);break;
    case 11: tok=(*p)(a[0],a[1],a[2],a[3],a[4],a[5],a[6],a[7],a[8],a[9],a[10]);break;
    case 12: tok=(*p)(a[0],a[1],a[2],a[3],a[4],a[5],a[6],a[7],a[8],a[9],a[10],a[11]);
             break;
    case 13: tok=(*p)(a[0],a[1],a[2],a[3],a[4],a[5],a[6],a[7],a[8],a[9],a[10],a[11],
             a[12]);break;
    case 14: tok=(*p)(a[0],a[1],a[2],a[3],a[4],a[5],a[6],a[7],a[8],a[9],a[10],a[11],
             a[12],a[13]);break;
    case 15: tok=(*p)(a[0],a[1],a[2],a[3],a[4],a[5],a[6],a[7],a[8],a[9],a[10],a[11],
             a[12],a[13],a[14]);break;
    case 16: tok=(*p)(a[0],a[1],a[2],a[3],a[4],a[5],a[6],a[7],a[8],a[9],a[10],a[11],
             a[12],a[13],a[14],a[15]);break;
    default: p_exit(13);
    }


    if (BADSTATUS (tok)) {
        va_end(ap);
        RELEASE;
        return tok;
    }

    q = va_arg(ap,PARSER*);

     CALL(tok=(*q),m,a,52);

    va_end(ap);

    if (BADSTATUS (tok))    /* error */
    {
        REWIND;        /* remove this line for 1-token LA parsing */
        return tok;    /* fail */
    }

    pushDECR;
    RELEASE;

    return tok;        /* succeed */
}

STATUS p_starparse0n (VALUE *x,PARSER *p, ...)
/*
Monadic composition of parsers. Does
first p then q, where q can use x, which is the address of p's result.

Assume that q knows that x is an address!

Put p's instructions on the
top of the program stack, then layer q's above it.

This version has full rewind of the input stream on
failure, but this can be altered to single token
lookahead by deleting the line of code marked.
*/
{
    static PARSER *q=p_errparse0;
    va_list ap;

    static int m;
    static PARAM *a;
    static status  tok;

    MARK;

    va_start(ap,p);

    CALL(tok=(*p),m,a,53);
    
    if (BADSTATUS(tok)) {
        va_end(ap);
        RELEASE;
        return tok;
    }

    /* I intend that x be local so that if we later fail, this
     * value will disappear */

    *x = (VALUE)INSTATUS(tok);

    q = va_arg(ap,PARSER*);

        CALL(tok=(*q),m,a,54);

        va_end(ap);

        if (BADSTATUS (tok))    /* error */
        {
            REWIND;        /* remove this line for 1-token LA parsing */
            return tok;    /* fail */
        }
    
        pushDECR;
        RELEASE;
        return tok;        /* succeed */
}


STATUS   p_until0n(PARSER *p, ...)
/* skip until p succeeds. This should be the same as 
   foo = p | ? foo .		   ***** character mode only **********
 */
{
    va_list ap;
    static STATUS tok; 
    static int m;

    while (*pstr) {
        va_start(ap,p);
        CALL(tok=(*p),m,a,55);
        va_end(ap);

        if GOODSTATUS (tok)
            return tok;
        MOVEON;
    }
    return FAILURE;
}

STATUS p_orparse0n (PARSER *p, ...)
/*
alternate composition of parsers. Tries p first,
and if it doesnt work, tries q. Code corresponding
to the successful parse is placed on the program stack.
If both fail, the routine relies on p and q's auto-rewind
mechanisms to do the rewind for it.
*/
{
    va_list ap;

    static PARSER *q=p_errparse0;
    static int m;
    static status  tok;

    va_start(ap,p);

    
    CALL(tok=(*p),m,a,56);

    if (BADSTATUS (tok))    /* error */
    {
        q = va_arg(ap,PARSER*);
    
        CALL(tok=(*q),m,a,57);

    }

    va_end(ap);
    return tok;        /* succeed */
}

STATUS  p_hidden0n (PARSER *p, ...)
/*
parser which tries p, but doesnt moveon, just reports the result
of p.
*/
{
    static va_list ap;

    static int m;
    static status tok;
    MARK;

    va_start(ap,p);

    CALL(tok=(*p),m,a,58);

    va_end(ap);
        
    REWIND;
    if (GOODSTATUS(tok)) {
       pushVALUE(p_hidden0n);
    }

    return tok;
}


STATUS  p_option0n (PARSER *p, ...)
/*
parser which tries p, but doesnt worry if p fails,
just rewinds and considers itself happy with nothing at all.
*/
{
    static va_list ap;

    static int m;
    static status tok;

    va_start(ap,p);

    CALL(tok=(*p),m,a,59);

    va_end(ap);

    if (GOODSTATUS(tok))
        return tok;


    pushINCR;

    return(SUCCESS);

}


STATUS  p_many0n (PARSER *p, ...)
{
    static    va_list(ap);
    static status tok;
    int repeat=0;
    static int m;

/* to use this from a function which has parameters foo,m,a1,...,am
   use va_start(ap,foo) and call us */

loop:
    va_start(ap,p);

    CALL(tok=(*p),m,a,60);

    va_end(ap);

    if (GOODSTATUS(tok)) {
        repeat++;
        goto loop;
    }
    return SUCCESS;
}


STATUS p_uerror0n (PARSER *p, ...)
{
    static va_list(ap);

    static int m;

        va_start(ap,p);
        m=va_arg(ap,int);
        a=(PARAM*)ap;
        ap=(va_list)&a[m];

        /*m++; ?*/

        p_entry = p;  /* set the btck_error reentry pt */
        p_enargs= m;
        memcpy(p_eargv, a, m * sizeof(PARAM));

        va_end(ap);

        pushEXIT;
        pc=0;
        pc=p_evaluate ();
        pc=0;   /* we have to write the next program in the right place */

        if (yytchar!=EOF) /* then we can ask */
          
            {
                /* now we restart */
                realignbuffer();
            }

        passcount++;

        return SUCCESS;
}

STATUS  p_iter0n (int repeat, PARSER *p, ...)
{
    static va_list(ap);

    static int m;
    static status tok;
    static int k;
    MARK;

    k = repeat;

    while(k-->0){
        va_start(ap,p);
        CALL(tok=(*p),m,a,61);
        va_end(ap);

        if (BADSTATUS(tok)) {
            REWIND;
            return FAILURE;
        }
    }
    RELEASE;
    return SUCCESS;
}


STATUS p_prepend0n (ACTION *f, ...)
{
    static PARSER *p;
    static status tok;
    static int m;

    va_list(ap);
    MARK;

    va_start(ap,f);

        m=va_arg(ap,int);
        a=(PARAM*)ap;
        ap=(va_list)&a[m];
        m++;


    while(--m>0)
           pushPARAM(a[m-1]);

    pushACTION(f);

    p = va_arg(ap,PARSER *);

    CALL(tok=(*p),m,a,62);

    va_end(ap);

    if (GOODSTATUS(tok)){
        RELEASE;
        return tok;
    }

    REWIND;

    return tok;
}




STATUS  p_some0n (PARSER *p, ...)
/*
At least one repetition of parser p
*/
{
    static va_list(ap);

    int m;
    status  tok;

    va_start(ap,p);

    /* this should really be a call of p_many0v(p,ap) */

    CALL(tok=(*p),m,a,63);

    va_end(ap);
            
    if (GOODSTATUS(tok)) {
        switch(m-1){
        case 0: tok = p_many0n (p,0); break;
        case 1: tok = p_many0n (p,1,a[0]); break;
        case 2: tok = p_many0n (p,2,a[0],a[1]); break;
        case 3: tok = p_many0n (p,3,a[0],a[1],a[2]); break;
        case 4: tok = p_many0n (p,4,a[0],a[1],a[2],a[3]); break;
        case 5: tok = p_many0n (p,5,a[0],a[1],a[2],a[3],a[4]); break;
        case 6: tok = p_many0n (p,6,a[0],a[1],a[2],a[3],a[4],a[5]); break;
        case 7: tok = p_many0n (p,7,a[0],a[1],a[2],a[3],a[4],a[5],a[6]); break;
        case 8: tok = p_many0n (p,8,a[0],a[1],a[2],a[3],a[4],a[5],a[6],a[7]);
                break;
        case 9: tok = p_many0n (p,9,a[0],a[1],a[2],a[3],a[4],a[5],a[6],a[7],
                a[8]); break;
        case 10:tok = p_many0n (p,10,a[0],a[1],a[2],a[3],a[4],a[5],a[6],a[7],
                a[8],a[9]); break;
        case 11:tok = p_many0n (p,11,a[0],a[1],a[2],a[3],a[4],a[5],a[6],a[7],
                a[8],a[9],a[10]); break;
        case 12:tok = p_many0n (p,12,a[0],a[1],a[2],a[3],a[4],a[5],a[6],a[7],
                a[8],a[9],a[10],a[11]); break;
        case 13:tok = p_many0n (p,13,a[0],a[1],a[2],a[3],a[4],a[5],a[6],a[7],
                a[8],a[9],a[10],a[11],a[12]); break;
        case 14:tok = p_many0n (p,14,a[0],a[1],a[2],a[3],a[4],a[5],a[6],a[7],
                a[8],a[9],a[10],a[11],a[12],a[13]); break;
        case 15:tok = p_many0n (p,15,a[0],a[1],a[2],a[3],a[4],a[5],a[6],a[7],
                a[8],a[9],a[10],a[11],a[12],a[13],a[14]); break;
        case 16:tok = p_many0n (p,16,a[0],a[1],a[2],a[3],a[4],a[5],a[6],a[7],
                a[8],a[9],a[10],a[11],a[12],a[13],a[14],a[15]); break;
        default://printf("error: too many (%d) args in CALL\n",m-1);\
                p_exit(14); break;
        }

        pushDECR;
    }
    return tok;
}


STATUS  p_test0 (x)
/* succeed if x is 1, fail if x is 0 */
int x;
{
    if (x){
        pushVALUE((VALUE)x);
        return OK(x);
    }
    return FAILURE;
}


STATUS p_attach0n (PARSER *p, ...)
/*
attach an action to a parse.
*/
{
    va_list(ap);

    status tok;
    static int m;
    static ACTION *f;

    va_start(ap,p);
    
    CALL(tok=(*p),m,a,51);

    f=va_arg(ap,ACTION*);

    m=va_arg(ap,int);

    a=(PARAM*)ap;
    ap=(va_list)&a[m];
    m++;

    va_end(ap);

    if (GOODSTATUS(tok)){
        while(--m>0){
            pushPARAM(a[m-1]);
        }
        pushACTION(f);
    }
    return tok;
}

STATUS p_range0n (PREDICATE *p, ...)
{
    static va_list(ap);

    boolean tok;    /* could make this static, but range is always a leaf */
    static int m;        /* so it's hardly worth the bother. */
    
    TOKEN c; VALUE v;

    va_start(ap,p);

    m=va_arg(ap,int);
    a=(PARAM*)ap;
    ap=(va_list)&a[m];
    m++;

    va_end(ap);
        
    c = *pstr;
    v = lvbuff[(int)(pstr-buffer)];

    switch(m-1) {
    case 0: tok = (*p)(c); break;
    case 1: tok = (*p)(a[0],c); break;
    case 2: tok = (*p)(a[0],a[1],c); break;
    case 3: tok = (*p)(a[0],a[1],a[2],c); break;
    case 4: tok = (*p)(a[0],a[1],a[2],a[3],c); break;
    case 5: tok = (*p)(a[0],a[1],a[2],a[3],a[4],c); break;
    case 6: tok = (*p)(a[0],a[1],a[2],a[3],a[4],a[5],c); break;
    case 7: tok = (*p)(a[0],a[1],a[2],a[3],a[4],a[5],a[6],c); break;
    case 8: tok = (*p)(a[0],a[1],a[2],a[3],a[4],a[5],a[6],a[7]);
            break;
    case 9: tok = (*p)(a[0],a[1],a[2],a[3],a[4],a[5],a[6],a[7],
            a[8]); break;
    case 10:tok = (*p)(a[0],a[1],a[2],a[3],a[4],a[5],a[6],a[7],
            a[8],a[9]); break;
    case 11:tok = (*p)(a[0],a[1],a[2],a[3],a[4],a[5],a[6],a[7],
            a[8],a[9],a[10]); break;
    case 12:tok = (*p)(a[0],a[1],a[2],a[3],a[4],a[5],a[6],a[7],
            a[8],a[9],a[10],a[11]); break;
    case 13:tok = (*p)(a[0],a[1],a[2],a[3],a[4],a[5],a[6],a[7],
            a[8],a[9],a[10],a[11],a[12]); break;
    case 14:tok = (*p)(a[0],a[1],a[2],a[3],a[4],a[5],a[6],a[7],
            a[8],a[9],a[10],a[11],a[12],a[13]); break;
    case 15:tok = (*p)(a[0],a[1],a[2],a[3],a[4],a[5],a[6],a[7],
            a[8],a[9],a[10],a[11],a[12],a[13],a[14]); break;
    default: //printf("error: too many (%d) args in predicate\n",m-1);
             p_exit(15);
    }


    if (GOODSTATUS(tok))
    {
        MOVEON;
        pushVALUE(v);
        return OK(v);
    }
    return FAILURE;
}



//
// come from engine.c
//

/*
   parser suite - and / or / nothing / something  parsers

   parser = [token] -> ([token],status)
    
   implemented as sideeffecting on [token], returns status.
*/


/* for debugging: allow some error codes to be listed out by evaluate()
 * before terminating
 */

# define MAXERRS 10


int p_evaluate ()
/*
 * This is the interpreter. It runs the instruction block
 * starting at the (global) pc point with the evaluation stack pointer
 * at (global) value, and returns the address of the next block of code when
 * it exits.
 */
{
        static ACTION *a;
        static OPCODE n;
        static int nargs=0;         /* counting args of an action */
        static int nerrs=0;         /* how many times we've blown it */

        static PARAM args[MAXARGS]; /* local stack for action args */

                                      /* reset the evaluation stack */
    value = &stack[0];

loop:

    /* place a stop at the end of program space for safety if worried */
    /* pcode(program[maxprogramsize-1])=EXIT; */

        switch (n = Opcode(instr=program[pc++]))
        {
        case CNST:      /* this is a literal */
            /* there is no need to do this now! Actions don't read the
               attribute stack any more */

            if (precc_data.stacktokens)
                 pushvalue(Value(instr));
            break;
        case NOP:       /* treat it as a exit */
             /* fallthrough*/
        case EXIT:      /* end of code block */
            return (pc);

        case INCR:      /* increment stack pointer */
            /* this instruction should never be generated any more */
            /* value+=(int)Param(instr); */
            break;

        case PARM:        /* we want to try using our own local stack ..
                         */
            args[nargs++] = Param(instr);

                        /* PARMs always come together before a FUNC. */
                        /* The rightmost arg is first to appear. */
            break;

        case FUNC:      /*  we are using our own local arg stack:
                         */
# define ARG(N) (args[N])
# define PREPARE(N)

            a = Action(instr);
            if (a)
                switch(nargs)
                {   /* I ASSUME args are evaluated left to right */
                        case 16: PREPARE(16);
                                 (*a) (ARG(15),ARG(14),ARG(13),ARG(12),
                                    ARG(11),ARG(10),ARG(9),ARG(8),
                                    ARG(7),ARG(6),ARG(5),ARG(4),
                                    ARG(3),ARG(2),ARG(1),ARG(0));
                                break;
                        case 15: PREPARE(15);
                                 (*a) (ARG(14),ARG(13),ARG(12),
                                    ARG(11),ARG(10),ARG(9),ARG(8),
                                    ARG(7),ARG(6),ARG(5),ARG(4),
                                    ARG(3),ARG(2),ARG(1),ARG(0));
                                break;
                        case 14: PREPARE(14);
                                 (*a) (ARG(13),ARG(12),
                                    ARG(11),ARG(10),ARG(9),ARG(8),
                                    ARG(7),ARG(6),ARG(5),ARG(4),
                                    ARG(3),ARG(2),ARG(1),ARG(0));
                                break;
                        case 13: PREPARE(13);
                                 (*a) (ARG(12),
                                    ARG(11),ARG(10),ARG(9),ARG(8),
                                    ARG(7),ARG(6),ARG(5),ARG(4),
                                    ARG(3),ARG(2),ARG(1),ARG(0));
                                break;
                        case 12: PREPARE(12);
                                 (*a) (ARG(11),ARG(10),ARG(9),ARG(8),
                                    ARG(7),ARG(6),ARG(5),ARG(4),
                                    ARG(3),ARG(2),ARG(1),ARG(0));
                                break;
                        case 11: PREPARE(11);
                                 (*a) (ARG(10),ARG(9),ARG(8),
                                    ARG(7),ARG(6),ARG(5),ARG(4),
                                    ARG(3),ARG(2),ARG(1),ARG(0));
                                break;
                        case 10: PREPARE(10);
                                 (*a) (ARG(9),ARG(8),
                                    ARG(7),ARG(6),ARG(5),ARG(4),
                                    ARG(3),ARG(2),ARG(1),ARG(0));
                                break;
                        case 9:  PREPARE(9);
                                 (*a) (ARG(8),
                                    ARG(7),ARG(6),ARG(5),ARG(4),
                                    ARG(3),ARG(2),ARG(1),ARG(0));
                                break;
                        case 8:  PREPARE(8);
                                 (*a) (ARG(7),ARG(6),ARG(5),ARG(4),
                                    ARG(3),ARG(2),ARG(1),ARG(0));
                                break;
                        case 7:  PREPARE(7);
                                 (*a) (ARG(6),ARG(5),ARG(4),
                                    ARG(3),ARG(2),ARG(1),ARG(0));
                                break;
                        case 6:  PREPARE(6);
                                 (*a) (ARG(5),ARG(4),
                                    ARG(3),ARG(2),ARG(1),ARG(0));
                                break;
                        case 5:  PREPARE(5);
                                 (*a) (ARG(4),
                                    ARG(3),ARG(2),ARG(1),ARG(0));
                                break;
                        case 4:  PREPARE(4);
                                 (*a) (ARG(3),ARG(2),ARG(1),ARG(0));
                                break;
                        case 3:  PREPARE(3);
                                 (*a) (ARG(2),ARG(1),ARG(0));
                                break;
                        case 2:  PREPARE(2);
                                 (*a) (ARG(1),ARG(0));
                                break;
                        case 1:  PREPARE(1);
                                 (*a) (ARG(0));
                                break;
                        case 0:  PREPARE(0);
                                (*a) ();
                                break;
                        default:
                //fprintf(stderr,
                //"error: too many args (%d) in action call\n", nargs);
                //fprintf(stderr,"     : program counter: %d\n",pc);
                //fprintf(stderr,"     : line number    : %d\n",yylineno);
                p_exit(16);
                }
# undef PREPARE
# undef ARG
                nargs=0;         /*  used up all the args */
                break;
        default:
            //fprintf(stderr,"\"engine\" module reports a client has overwritten the\n");
            //fprintf(stderr,"program area it is interpreting. This foreign code will be\n");
            //fprintf(stderr,"skipped for now but other insertions may not be detected\n");
            //fprintf(stderr,"and could cause a program crash. The following may be\n");
            //fprintf(stderr,"useful for debugging purposes:\n\n");
            //fprintf(stderr,"error: illegal opcode (%d)\n",n);
            //fprintf(stderr,"     : program counter(%d)\n",pc);
            //fprintf(stderr,"     : line number    (%d)\n",yylineno);
            //if (nerrs++ < MAXERRS)
            //   break;             /* allow a retry */
            //fprintf(stderr,"engine: Too many errors (%u)\n",MAXERRS);
            p_exit(17);
            return (pc);
        }
        goto loop;
}

void readerror(n)
/* raise an error because the read buffer has overflowed */
int n;
{
    //fprintf(stderr,
    //"\"engine\" module reports that the read buffer has overflowed.\n");
    //fprintf(stderr,
    //"It is currently set at %d tokens and it has read %d tokens.\n",
    //precc_data.readbuffersize, n);
    //fprintf(stderr,"To prevent a reoccurrence, insert more cut marks (!) in the definition\n");
    //fprintf(stderr,"script or increase the READBUFFERSIZE macro definition.\n");
    p_exit(18);
}

/* get1token() is the ONLY place I call yylex() - it is the
 * interface with the lexer and I am trying to give it most
 * rights over pstr and maxp too.
 */

TOKEN    get1token()
/* Yylex() a token into the NEXT position for pstr if we are currently
   at pstr=maxp, and increment pstr. Otherwise just increment pstr
   and return the token we see.

   Also get the matching attribute into the lvbuff, increase maxp if
   needed.

   Return EOF for fail and the token otherwise. Note that pstr is always
   incremented by this call.
 */
{
    extern int yytchar;

    if (++pstr <= maxp)
        return *pstr;    /* there was a read ahead token available */

    if (yytchar==EOF)    /* we got EOF before already */
       return (TOKEN)EOF;
                         /* a check that I never used to do, for speed,
                          * but which seemed to be the cause of most bangs.
                          */
    if (pstr - buffer >= precc_data.readbuffersize)
        readerror(pstr - buffer);

    yybuffer=pstr;       /* we give yylex its buffer */
    *pstr = yylex();     /* we read yylex's return token */
                         /* just in case yylex forgot to tell us */
    if (yytchar==EOF)
            return (TOKEN)EOF;
                         /* we read yylex's stashed attribute */
    lvbuff[(int)(pstr - buffer)] = yylval;

    maxp=pstr;           /* we're only here because we had maxp < pstr */

    return *pstr;        /* everybody happy */
}

void realignbuffer()
/* set pstr back to buffer so that the token we have just read now
 * seems to be in the first buffer position.
 */
{
     int n; /* the number of readahead tokens */
     n = (int)(maxp - pstr);

     /* get the first token */
     *buffer = *pstr;
     *lvbuff = lvbuff[(int)(pstr - buffer)];

     /* now get the rest */
     if (n>0)
     {
         memcpy(buffer+1,pstr+1,n*sizeof(TOKEN));
         memcpy(lvbuff+1,lvbuff+(int)(pstr - buffer) + 1,n*sizeof(VALUE));
     }

	 NumberOfBytesProcessed += pstr - buffer;
     pstr = buffer;
     maxp = pstr + n;
}


VOID    p_runline (p)
/* discharge actions and run parser p */
PARSER *p;
{
        static STATUS tok;

        /* maxp = pstr
                = buffer;    * - is now set by our caller */

        pc = 0;             /* program start address */
        fptr  = fstack+1;   /* frame stack zeroed -- hooray ! */
        tok   = (*p) ();    /* call the parser designated as entry point */

        if (GOODSTATUS(tok))
        {                   /* same as p_uniq0() */
            pushEXIT;
            pc = 0;         /* program start address */
			
            pc = p_evaluate (); /* evaluate starts with (pc=0) */
			
            pc=0;
            passcount++;
                            /* if an error occurred, you might
                             * want to look at program[pc-1] now */
            if (*pstr)
                zer_error();/* incomplete parse */
        }
        else
            bad_error() ;   /* failed parse */
}

VOID  p_run (p)
/*
  Read lines from terminal, parse them, and if they are good according to p,
  execute the program that p built up. If the line is bad, re-echo it -
  thats the default error action, anyhow.
*/
PARSER *p;
{
     precc_begin ();  /* user defined setup stuff */

     if(!pstr)        /* not set yet! It's the */
     {                /* first time through */
         pstr = maxp
              = buffer; /* or - 1 ? */
         get1token();   /* establish canonical situation */
					   // modified by sang cho
     }
    /* now we have a genuine token, make it first */
	// modified by sang cho
    realignbuffer();
    p_runline (p);
}



//
//  come from yystuff.c
//                        modified by sang cho
//

/* this avoids warnings about implicitly declaring filbuf in
   some installations, but it also shifts to functions from
   macros, which may not be as fast unless your optimizer magics
   it all away again.
 */

int             goteof=0;
int             yyfirsttime=1;
int             yytchar;    /* the last char read */
unsigned char   c;

int             yylineno = 0;    /* line count */
int             yylen;        /* eventually, the length of the token we
                               * caught */
VALUE           yylval;
PBYTE           yyfp, yypmax;

int
yylex()
/*
 * I should have yylen as 1 always.
 */
{
    
	if (yyfirsttime)
	{
	    yyfirsttime=0; goteof=0; 
	    yyfp   = (PBYTE)((int)lpFile + vCodeOffset);
		yypmax = (PBYTE)((int)lpFile + vCodeOffset + vCodeSize + 2);
	}											// dirty trick here ....		   
	if (goteof) {yytchar = EOF; return yytchar;}
	c = *yyfp++;
	yytchar = c;
	yylval = (VALUE)yytchar;
	if (yyfp >= yypmax ) { yytchar = EOF; }
	if (yytchar == EOF) goteof = 1;
	yylen = 1;
	yylineno++;
	return yytchar;
   
}

