# define PREFIX 99
# define max_col 12

# include "ccx.h"

# include <ctype.h>


/* *********************************************************************** */
/* Original Part of grammar control data                                   */
/* *********************************************************************** */

int opcodeTable[] = {
/*        0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F   */
/* -----------------------------------------------------------------------*/
/*00*/    6,  6,  6,  6,  1,  4,  0,  0,  6,  6,  6,  6,  1,  4,  0, -1,	
/*10*/    6,  6,  6,  6,  1,  4,  0,  0,  6,  6,  6,  6,  1,  4,  0,  0,	
/*20*/    6,  6,  6,  6,  1,  4, 99,  0,  6,  6,  6,  6,  1,  4, 99,  0,	
/*30*/    6,  6,  6,  6,  1,  4, 99,  0,  6,  6,  6,  6,  1,  4, 99,  0,	
/*40*/    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,	
/*50*/    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,	
/*60*/    0,  0,  6,  6, 99, 99, 99, 99,  4,  8,  1,  7,  0,  0,  0,  0,	
/*70*/    1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,	
/*80*/   10, 11, -1, 10,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  9,	
/*90*/    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  5, 15,  0,  0,  0,  0,	
/*A0*/   44, 44, 44, 44,  0,  0,  0,  0,  1,  4,  0,  0,  0,  0,  0,  0,	
/*B0*/    1,  1,  1,  1,  1,  1,  1,  1,  4,  4,  4,  4,  4,  4,  4,  4,	
/*C0*/   10, 10,  2,  0,  6,  6, 10, 11,  3,  0,  2,  0,  0,  1,  0,  0,	
/*D0*/    9,  9,  9,  9,  1,  1, -1,  0, 12, 12, 12, 12, 12, 12, 12, 12,	
/*E0*/    1,  1,  1,  1,  1,  1,  1,  1,  4,  4,  5,  1,  0,  0,  0,  0,	
/*F0*/    0,  0, 16, 16,  0,  0, 14, 14,  0,  0,  0,  0,  0,  0,  9, 13};	
/* -----------------------------------------------------------------------*/

int opcode2Table[] = {
/*        0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F   */
/* -----------------------------------------------------------------------*/
/*00*/    4,  4,  2,  2, -1, -1,  0, -1,  0,  0, -1,  0, -1, -1, -1, -1,	
/*10*/   -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,	
/*20*/    2,  2,  2,  2, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,	
/*30*/    0,  0,  0,  0, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,	
/*40*/    2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,	
/*50*/   -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,	
/*60*/    2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, -1, -1,  2,  2,	
/*70*/   -1,  5,  5,  5,  2,  2,  2,  0, -1, -1, -1, -1, -1, -1,  2,  2,	
/*80*/    1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,	
/*90*/    2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,	
/*A0*/    0,  0,  0,  2,  3,  2, -1, -1,  0,  0,  0,  2,  3,  2, -1,  2,	
/*B0*/    2,  2,  2,  2,  2,  2,  2,  2, -1, -1,  5,  2,  2,  2,  2,  2,	
/*C0*/    2,  2, -1, -1, -1, -1, -1,  4,  0,  0,  0,  0,  0,  0,  0,  0,	
/*D0*/   -1,  2,  2,  2, -1,  2, -1, -1,  2,  2, -1,  2,  2,  2, -1,  2,	
/*E0*/   -1,  2,  2, -1, -1,  2, -1, -1,  2,  2, -1,  2,  2,  2, -1,  2,	
/*F0*/   -1,  2,  2,  2, -1,  2, -1, -1,  2,  2,  2, -1,  2,  2,  2, -1};
/* -----------------------------------------------------------------------*/

int repeatgroupTable[] = {
/*        0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F   */
/* -----------------------------------------------------------------------*/
/*00*/    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,	
/*10*/    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,	
/*20*/    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,	
/*30*/    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,	
/*40*/    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,	
/*50*/    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,	
/*60*/    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  2,  2,  2,  2,	
/*70*/    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,	
/*80*/    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,	
/*90*/    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,	
/*A0*/    0,  0,  0,  0,  2,  2,  1,  1,  0,  0,  2,  2,  2,  2,  1,  1,	
/*B0*/    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,	
/*C0*/    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,	
/*D0*/    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,	
/*E0*/    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,	
/*F0*/    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0};	
/* -----------------------------------------------------------------------*/

int modTable[] = {
/*        0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F   */
/* -----------------------------------------------------------------------*/
/*00*/    1,  1,  1,  1,  2,  3,  1,  1,  1,  1,  1,  1,  2,  3,  1,  1,	
/*10*/    1,  1,  1,  1,  2,  3,  1,  1,  1,  1,  1,  1,  2,  3,  1,  1,	
/*20*/    1,  1,  1,  1,  2,  3,  1,  1,  1,  1,  1,  1,  2,  3,  1,  1,	
/*30*/    1,  1,  1,  1,  2,  3,  1,  1,  1,  1,  1,  1,  2,  3,  1,  1,	
/*40*/    4,  4,  4,  4,  5,  4,  4,  4,  4,  4,  4,  4,  5,  4,  4,  4,	
/*50*/    4,  4,  4,  4,  5,  4,  4,  4,  4,  4,  4,  4,  5,  4,  4,  4,	
/*60*/    4,  4,  4,  4,  5,  4,  4,  4,  4,  4,  4,  4,  5,  4,  4,  4,	
/*70*/    4,  4,  4,  4,  5,  4,  4,  4,  4,  4,  4,  4,  5,  4,  4,  4,	
/*80*/    6,  6,  6,  6,  7,  6,  6,  6,  6,  6,  6,  6,  7,  6,  6,  6,	
/*90*/    6,  6,  6,  6,  7,  6,  6,  6,  6,  6,  6,  6,  7,  6,  6,  6,	
/*A0*/    6,  6,  6,  6,  7,  6,  6,  6,  6,  6,  6,  6,  7,  6,  6,  6,	
/*B0*/    6,  6,  6,  6,  7,  6,  6,  6,  6,  6,  6,  6,  7,  6,  6,  6,	
/*C0*/    8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,	
/*D0*/    8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,	
/*E0*/    8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,	
/*F0*/    8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8};	
/* -----------------------------------------------------------------------*/

int mod16Table[] = {
/*        0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F   */
/* -----------------------------------------------------------------------*/
/*00*/    1,  1,  1,  1,  1,  1,  2,  1,  1,  1,  1,  1,  1,  1,  2,  1,	
/*10*/    1,  1,  1,  1,  1,  1,  2,  1,  1,  1,  1,  1,  1,  1,  2,  1,	
/*20*/    1,  1,  1,  1,  1,  1,  2,  1,  1,  1,  1,  1,  1,  1,  2,  1,	
/*30*/    1,  1,  1,  1,  1,  1,  2,  1,  1,  1,  1,  1,  1,  1,  2,  1,	
/*40*/    3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,	
/*50*/    3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,	
/*60*/    3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,	
/*70*/    3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,	
/*80*/    4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,	
/*90*/    4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,	
/*A0*/    4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,	
/*B0*/    4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,	
/*C0*/    5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,	
/*D0*/    5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,	
/*E0*/    5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,	
/*F0*/    5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5};	
/* -----------------------------------------------------------------------*/


int sibTable[] = {
/*        0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F   */
/* -----------------------------------------------------------------------*/
/*00*/    2,  2,  2,  2,  2,  1,  2,  2,  2,  2,  2,  2,  2,  1,  2,  2,	
/*10*/    2,  2,  2,  2,  2,  1,  2,  2,  2,  2,  2,  2,  2,  1,  2,  2,	
/*20*/    2,  2,  2,  2,  2,  1,  2,  2,  2,  2,  2,  2,  2,  1,  2,  2,	
/*30*/    2,  2,  2,  2,  2,  1,  2,  2,  2,  2,  2,  2,  2,  1,  2,  2,	
/*40*/    2,  2,  2,  2,  2,  1,  2,  2,  2,  2,  2,  2,  2,  1,  2,  2,	
/*50*/    2,  2,  2,  2,  2,  1,  2,  2,  2,  2,  2,  2,  2,  1,  2,  2,	
/*60*/    2,  2,  2,  2,  2,  1,  2,  2,  2,  2,  2,  2,  2,  1,  2,  2,	
/*70*/    2,  2,  2,  2,  2,  1,  2,  2,  2,  2,  2,  2,  2,  1,  2,  2,	
/*80*/    2,  2,  2,  2,  2,  1,  2,  2,  2,  2,  2,  2,  2,  1,  2,  2,	
/*90*/    2,  2,  2,  2,  2,  1,  2,  2,  2,  2,  2,  2,  2,  1,  2,  2,	
/*A0*/    2,  2,  2,  2,  2,  1,  2,  2,  2,  2,  2,  2,  2,  1,  2,  2,	
/*B0*/    2,  2,  2,  2,  2,  1,  2,  2,  2,  2,  2,  2,  2,  1,  2,  2,	
/*C0*/    2,  2,  2,  2,  2,  1,  2,  2,  2,  2,  2,  2,  2,  1,  2,  2,	
/*D0*/    2,  2,  2,  2,  2,  1,  2,  2,  2,  2,  2,  2,  2,  1,  2,  2,	
/*E0*/    2,  2,  2,  2,  2,  1,  2,  2,  2,  2,  2,  2,  2,  1,  2,  2,	
/*F0*/    2,  2,  2,  2,  2,  1,  2,  2,  2,  2,  2,  2,  2,  1,  2,  2};	
/* -----------------------------------------------------------------------*/

int regTable[] = {
/*        0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F   */
/* -----------------------------------------------------------------------*/
/*00*/    0,  0,  0,  0,  0,  0,  0,  0,  1,  1,  1,  1,  1,  1,  1,  1,	
/*10*/    2,  2,  2,  2,  2,  2,  2,  2,  3,  3,  3,  3,  3,  3,  3,  3,	
/*20*/    4,  4,  4,  4,  4,  4,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,	
/*30*/    6,  6,  6,  6,  6,  6,  6,  6,  7,  7,  7,  7,  7,  7,  7,  7,	
/*40*/    0,  0,  0,  0,  0,  0,  0,  0,  1,  1,  1,  1,  1,  1,  1,  1,	
/*50*/    2,  2,  2,  2,  2,  2,  2,  2,  3,  3,  3,  3,  3,  3,  3,  3,	
/*60*/    4,  4,  4,  4,  4,  4,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,	
/*70*/    6,  6,  6,  6,  6,  6,  6,  6,  7,  7,  7,  7,  7,  7,  7,  7,	
/*80*/    0,  0,  0,  0,  0,  0,  0,  0,  1,  1,  1,  1,  1,  1,  1,  1,	
/*90*/    2,  2,  2,  2,  2,  2,  2,  2,  3,  3,  3,  3,  3,  3,  3,  3,	
/*A0*/    4,  4,  4,  4,  4,  4,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,	
/*B0*/    6,  6,  6,  6,  6,  6,  6,  6,  7,  7,  7,  7,  7,  7,  7,  7,	
/*C0*/    0,  0,  0,  0,  0,  0,  0,  0,  1,  1,  1,  1,  1,  1,  1,  1,	
/*D0*/    2,  2,  2,  2,  2,  2,  2,  2,  3,  3,  3,  3,  3,  3,  3,  3,	
/*E0*/    4,  4,  4,  4,  4,  4,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,	
/*F0*/    6,  6,  6,  6,  6,  6,  6,  6,  7,  7,  7,  7,  7,  7,  7,  7};	
/* -----------------------------------------------------------------------*/

int rmTable[] = {
/*        0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F   */
/* -----------------------------------------------------------------------*/
/*00*/    0,  1,  2,  3,  4,  5,  6,  7,  0,  1,  2,  3,  4,  5,  6,  7,	
/*10*/    0,  1,  2,  3,  4,  5,  6,  7,  0,  1,  2,  3,  4,  5,  6,  7,	
/*20*/    0,  1,  2,  3,  4,  5,  6,  7,  0,  1,  2,  3,  4,  5,  6,  7,	
/*30*/    0,  1,  2,  3,  4,  5,  6,  7,  0,  1,  2,  3,  4,  5,  6,  7,	
/*40*/    0,  1,  2,  3,  4,  5,  6,  7,  0,  1,  2,  3,  4,  5,  6,  7,	
/*50*/    0,  1,  2,  3,  4,  5,  6,  7,  0,  1,  2,  3,  4,  5,  6,  7,	
/*60*/    0,  1,  2,  3,  4,  5,  6,  7,  0,  1,  2,  3,  4,  5,  6,  7,	
/*70*/    0,  1,  2,  3,  4,  5,  6,  7,  0,  1,  2,  3,  4,  5,  6,  7,	
/*80*/    0,  1,  2,  3,  4,  5,  6,  7,  0,  1,  2,  3,  4,  5,  6,  7,	
/*90*/    0,  1,  2,  3,  4,  5,  6,  7,  0,  1,  2,  3,  4,  5,  6,  7,	
/*A0*/    0,  1,  2,  3,  4,  5,  6,  7,  0,  1,  2,  3,  4,  5,  6,  7,	
/*B0*/    0,  1,  2,  3,  4,  5,  6,  7,  0,  1,  2,  3,  4,  5,  6,  7,	
/*C0*/    0,  1,  2,  3,  4,  5,  6,  7,  0,  1,  2,  3,  4,  5,  6,  7,	
/*D0*/    0,  1,  2,  3,  4,  5,  6,  7,  0,  1,  2,  3,  4,  5,  6,  7,	
/*E0*/    0,  1,  2,  3,  4,  5,  6,  7,  0,  1,  2,  3,  4,  5,  6,  7,	
/*F0*/    0,  1,  2,  3,  4,  5,  6,  7,  0,  1,  2,  3,  4,  5,  6,  7};	
/* -----------------------------------------------------------------------*/

/* *********************************************************************** */
/* hooks between disassembler and printing                                 */
/* *********************************************************************** */
int a_loc=0;
int a_loc_save=0;
int i_col=0;
int i_col_save=0;
int i_psp=0;
int prefixStack[8];
int opclass;
int modclass;
int i_opclass;        
int i_opcode;
int i_mod;
int i_sib;
int i_byte;
int i_word;
int i_dword;
int m_byte;
int m_dword;
int needspacing=0;
int byteaddress=0;
int imb=0;
int mbytes[64];
int NumberOfBytesProcessed=-1;  // we need to keep track of bytes processed.
                              // I don't know why I need to start from -1.... but anyway
							 // this is needed to process
int addressOveride=0;       // prefix 0x64
int operandOveride=0;      // this is needed to process
                          // prefix 0x66: operand size overide

int label_start_pos;     /* labe start position of case jump block */
int min_label; 
int cur_position;
int labelClass;
int finished;
int lastAnchor=0;
int leaveFlag=0;
int delta=0;

extern int (*prxntf)(const char *,...);  // for printing contol

/* *********************************************************************** */
/* Original Part of grammar generated sources                              */
/* *********************************************************************** */

//win32program       =  translationunit

//translationunit    =  {instruction}*

static STATUS hid0(PARAM c){
return p_test0(c==0);
}
static STATUS hid1(PARAM c){
PARSER prefixes;
return p_many0n(TOPARSER prefixes,0);
}
static STATUS hid2(PARAM c){
PARSER instructionbody, p_uniq0;
return p_andparse0n (TOPARSER instructionbody,0,TOPARSER p_uniq0,0);
}
static STATUS hid3(PARAM c){
PARSER p_uniq0, hid2;
return p_andparse0n (TOPARSER p_uniq0,0,TOPARSER hid2,1,c);
}
static STATUS hid4(PARAM c){
PARSER hid1, hid3;
return p_andparse0n (TOPARSER hid1,1,c,TOPARSER hid3,1,c);
}
static STATUS hid5(PARAM c){
PARSER hid0, hid4;
return p_andparse0n (TOPARSER hid0,1,c,TOPARSER hid4,1,c);
}
static STATUS hid6(PARAM c){
PARSER databody, p_uniq0;
return p_andparse0n (TOPARSER databody,1,c,TOPARSER p_uniq0,0);
}
static STATUS hid7 (PARAM c){
PARSER hid5, hid6;
static STATUS p_tok;
p_tok = (TOPARSER hid5) (c);
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid6) (c);
}
STATUS instruction(PARAM c){
PARSER hid7;
return((TOPARSER hid7)(c));
}

static STATUS hid8(PARAM c){
return p_test0(c==1);
}
static STATUS hid9(PARAM c){
PARSER hid8, labeldata;
return p_andparse0n (TOPARSER hid8,1,c,TOPARSER labeldata,0);
}
static STATUS hid10(PARAM c){
return p_test0(c==2);
}
static STATUS hid11(PARAM c){
PARSER hid10, bytex;
return p_andparse0n (TOPARSER hid10,1,c,TOPARSER bytex,0);
}
static STATUS hid12(PARAM c){
return p_test0(c==3);
}
static STATUS hid13(PARAM c){
PARSER hid12, byte;
return p_andparse0n (TOPARSER hid12,1,c,TOPARSER byte,0);
}
static STATUS hid14 (PARAM c){
PARSER hid11, hid13;
static STATUS p_tok;
p_tok = (TOPARSER hid11) (c);
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid13) (c);
}
static STATUS hid15 (PARAM c){
PARSER hid9, hid14;
static STATUS p_tok;
p_tok = (TOPARSER hid9) (c);
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid14) (c);
}
STATUS databody(PARAM c){
PARSER hid15;
return((TOPARSER hid15)(c));
}

static VOID hid16(PARAM x){
 m_dword=x; 
}
static STATUS hid17(PARAM x){
PARSER p_nothing0;ACTION hid16;
return p_attach0n(TOPARSER p_nothing0,0,hid16,1,x);
}
static STATUS hid18(){
PARSER dword, hid17; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER dword)(),(TOPARSER hid17)(x));
return p_tok;
}
STATUS labeldata(){
PARSER hid18;
return((TOPARSER hid18)());
}

static VOID hid19(){
 opclass=1; 
}
static STATUS hid20(){
PARSER p_nothing0;ACTION hid19;
return p_attach0n(TOPARSER p_nothing0,0,hid19,0);
}
static STATUS hid21(){
PARSER onebyteinstr, hid20;
return p_andparse0n (TOPARSER onebyteinstr,0,TOPARSER hid20,0);
}
static STATUS hid22(PARAM x){
return p_test0(x==15);
}
static VOID hid23(PARAM x){
 opclass=2; 
}
static STATUS hid24(PARAM x){
PARSER p_nothing0;ACTION hid23;
return p_attach0n(TOPARSER p_nothing0,0,hid23,1,x);
}
static STATUS hid25(PARAM x){
PARSER twobyteinstr, hid24;
return p_andparse0n (TOPARSER twobyteinstr,0,TOPARSER hid24,1,x);
}
static STATUS hid26(PARAM x){
PARSER hid22, hid25;
return p_andparse0n (TOPARSER hid22,1,x,TOPARSER hid25,1,x);
}
static STATUS hid27(){
PARSER byte, hid26; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER byte)(),(TOPARSER hid26)(x));
return p_tok;
}
static STATUS hid28 (){
PARSER hid21, hid27;
static STATUS p_tok;
p_tok = (TOPARSER hid21) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid27) ();
}
STATUS instructionbody(){
PARSER hid28;
return((TOPARSER hid28)());
}

static VOID hid29(PARAM x){
 prxntf("%02X",x);a_loc++;i_col++; 
}
static STATUS hid30(PARAM x){
PARSER p_nothing0;ACTION hid29;
return p_attach0n(TOPARSER p_nothing0,0,hid29,1,x);
}
static STATUS hid31(PARAM x){
return p_atch0((PARAM)(x));
}
static STATUS hid32(PARAM x){
PARSER hid30, hid31;
return p_andparse0n (TOPARSER hid30,1,x,TOPARSER hid31,1,x);
}
static STATUS hid33(){
PARSER p_anything0, hid32; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER p_anything0)(),(TOPARSER hid32)(x));
return p_tok;
}
STATUS byte(){
PARSER hid33;
return((TOPARSER hid33)());
}

static VOID hid34(PARAM x){
 m_byte=x; a_loc++; i_col++; 
}
static STATUS hid35(PARAM x){
PARSER p_nothing0;ACTION hid34;
return p_attach0n(TOPARSER p_nothing0,0,hid34,1,x);
}
static STATUS hid36(PARAM x){
return p_atch0((PARAM)(x));
}
static STATUS hid37(PARAM x){
PARSER hid35, hid36;
return p_andparse0n (TOPARSER hid35,1,x,TOPARSER hid36,1,x);
}
static STATUS hid38(){
PARSER p_anything0, hid37; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER p_anything0)(),(TOPARSER hid37)(x));
return p_tok;
}
STATUS bytex(){
PARSER hid38;
return((TOPARSER hid38)());
}

static VOID hid39(PARAM x){
 prxntf("%02X",x);a_loc++;i_col++; 
}
static STATUS hid40(PARAM x){
PARSER p_nothing0;ACTION hid39;
return p_attach0n(TOPARSER p_nothing0,0,hid39,1,x);
}
static STATUS hid41(PARAM x){
return p_atch0((PARAM)(x));
}
static STATUS hid42(PARAM x){
PARSER hid40, hid41;
return p_andparse0n (TOPARSER hid40,1,x,TOPARSER hid41,1,x);
}
static STATUS hid43(){
PARSER p_anything0, hid42; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER p_anything0)(),(TOPARSER hid42)(x));
return p_tok;
}
STATUS op(){
PARSER hid43;
return((TOPARSER hid43)());
}

static STATUS hid44(PARAM x,PARAM y){
return p_atch0((PARAM)(y*256+x));
}
static STATUS hid45(PARAM x){
PARSER byte, hid44; PARAM y;
static STATUS p_tok;
P_PSTAR(y,(TOPARSER byte)(),(TOPARSER hid44)(x,y));
return p_tok;
}
static STATUS hid46(){
PARSER byte, hid45; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER byte)(),(TOPARSER hid45)(x));
return p_tok;
}
STATUS word(){
PARSER hid46;
return((TOPARSER hid46)());
}

static STATUS hid47(PARAM x1,PARAM x2,PARAM x3,PARAM x4){
return p_atch0((PARAM)(((x4*256+x3)*256+x2)*256+x1));
}
static STATUS hid48(PARAM x1,PARAM x2,PARAM x3){
PARSER byte, hid47; PARAM x4;
static STATUS p_tok;
P_PSTAR(x4,(TOPARSER byte)(),(TOPARSER hid47)(x1,x2,x3,x4));
return p_tok;
}
static STATUS hid49(PARAM x1,PARAM x2){
PARSER byte, hid48; PARAM x3;
static STATUS p_tok;
P_PSTAR(x3,(TOPARSER byte)(),(TOPARSER hid48)(x1,x2,x3));
return p_tok;
}
static STATUS hid50(PARAM x1){
PARSER byte, hid49; PARAM x2;
static STATUS p_tok;
P_PSTAR(x2,(TOPARSER byte)(),(TOPARSER hid49)(x1,x2));
return p_tok;
}
static STATUS hid51(){
PARSER byte, hid50; PARAM x1;
static STATUS p_tok;
P_PSTAR(x1,(TOPARSER byte)(),(TOPARSER hid50)(x1));
return p_tok;
}
STATUS dword(){
PARSER hid51;
return((TOPARSER hid51)());
}

static STATUS hid52(){
return p_test0(addressOveride==1);
}
static STATUS hid53(){
PARSER hid52, word;
return p_andparse0n (TOPARSER hid52,0,TOPARSER word,0);
}
static STATUS hid54 (){
PARSER hid53, dword;
static STATUS p_tok;
p_tok = (TOPARSER hid53) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER dword) ();
}
STATUS adword(){
PARSER hid54;
return((TOPARSER hid54)());
}

static STATUS hid55(){
return p_test0(operandOveride==1);
}
static STATUS hid56(){
PARSER hid55, word;
return p_andparse0n (TOPARSER hid55,0,TOPARSER word,0);
}
static STATUS hid57 (){
PARSER hid56, dword;
static STATUS p_tok;
p_tok = (TOPARSER hid56) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER dword) ();
}
STATUS wdword(){
PARSER hid57;
return((TOPARSER hid57)());
}

static VOID hid58(PARAM x,PARAM y){
 i_word=x; i_dword=y; 
}
static STATUS hid59(PARAM x,PARAM y){
PARSER p_nothing0;ACTION hid58;
return p_attach0n(TOPARSER p_nothing0,0,hid58,2,x,y);
}
static STATUS hid60(PARAM x){
PARSER adword, hid59; PARAM y;
static STATUS p_tok;
P_PSTAR(y,(TOPARSER adword)(),(TOPARSER hid59)(x,y));
return p_tok;
}
static STATUS hid61(){
PARSER word, hid60; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER word)(),(TOPARSER hid60)(x));
return p_tok;
}
STATUS pword(){
PARSER hid61;
return((TOPARSER hid61)());
}

static STATUS hid62(PARAM x){
return p_test0(opcodeTable[x]==PREFIX);
}
static VOID hid63(PARAM x){
 prefixStack[i_psp++]=x; if (x==102) operandOveride=1; 							 if (x==103) addressOveride=1; 
}
static STATUS hid64(PARAM x){
PARSER p_nothing0;ACTION hid63;
return p_attach0n(TOPARSER p_nothing0,0,hid63,1,x);
}
static STATUS hid65(PARAM x){
PARSER hid62, hid64;
return p_andparse0n (TOPARSER hid62,1,x,TOPARSER hid64,1,x);
}
static STATUS hid66(){
PARSER op, hid65; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid65)(x));
return p_tok;
}
STATUS prefixes(){
PARSER hid66;
return((TOPARSER hid66)());
}

static STATUS hid67(PARAM x){
return p_test0(opcodeTable[x]==0);
}
static VOID hid68(PARAM x){
 i_opclass=0; i_opcode=x; 
}
static STATUS hid69(PARAM x){
PARSER p_nothing0;ACTION hid68;
return p_attach0n(TOPARSER p_nothing0,0,hid68,1,x);
}
static STATUS hid70(PARAM x){
PARSER hid67, hid69;
return p_andparse0n (TOPARSER hid67,1,x,TOPARSER hid69,1,x);
}
static STATUS hid71(){
PARSER op, hid70; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid70)(x));
return p_tok;
}
static STATUS hid72(PARAM x){
return p_test0(opcodeTable[x]==1);
}
static VOID hid73(PARAM x,PARAM y){
 i_opclass=1; i_opcode=x; i_byte=y; 
}
static STATUS hid74(PARAM x,PARAM y){
PARSER p_nothing0;ACTION hid73;
return p_attach0n(TOPARSER p_nothing0,0,hid73,2,x,y);
}
static STATUS hid75(PARAM x){
PARSER byte, hid74; PARAM y;
static STATUS p_tok;
P_PSTAR(y,(TOPARSER byte)(),(TOPARSER hid74)(x,y));
return p_tok;
}
static STATUS hid76(PARAM x){
PARSER hid72, hid75;
return p_andparse0n (TOPARSER hid72,1,x,TOPARSER hid75,1,x);
}
static STATUS hid77(){
PARSER op, hid76; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid76)(x));
return p_tok;
}
static STATUS hid78(PARAM x){
return p_test0(opcodeTable[x]==2);
}
static VOID hid79(PARAM x,PARAM y){
 i_opclass=2; i_opcode=x; i_word=y; 
}
static STATUS hid80(PARAM x,PARAM y){
PARSER p_nothing0;ACTION hid79;
return p_attach0n(TOPARSER p_nothing0,0,hid79,2,x,y);
}
static STATUS hid81(PARAM x){
PARSER word, hid80; PARAM y;
static STATUS p_tok;
P_PSTAR(y,(TOPARSER word)(),(TOPARSER hid80)(x,y));
return p_tok;
}
static STATUS hid82(PARAM x){
PARSER hid78, hid81;
return p_andparse0n (TOPARSER hid78,1,x,TOPARSER hid81,1,x);
}
static STATUS hid83(){
PARSER op, hid82; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid82)(x));
return p_tok;
}
static STATUS hid84(PARAM x){
return p_test0(opcodeTable[x]==3);
}
static VOID hid85(PARAM x,PARAM y1,PARAM y2){
 i_opclass=3; i_opcode=x; i_word=y1; i_byte=y2; 
}
static STATUS hid86(PARAM x,PARAM y1,PARAM y2){
PARSER p_nothing0;ACTION hid85;
return p_attach0n(TOPARSER p_nothing0,0,hid85,3,x,y1,y2);
}
static STATUS hid87(PARAM x,PARAM y1){
PARSER byte, hid86; PARAM y2;
static STATUS p_tok;
P_PSTAR(y2,(TOPARSER byte)(),(TOPARSER hid86)(x,y1,y2));
return p_tok;
}
static STATUS hid88(PARAM x){
PARSER word, hid87; PARAM y1;
static STATUS p_tok;
P_PSTAR(y1,(TOPARSER word)(),(TOPARSER hid87)(x,y1));
return p_tok;
}
static STATUS hid89(PARAM x){
PARSER hid84, hid88;
return p_andparse0n (TOPARSER hid84,1,x,TOPARSER hid88,1,x);
}
static STATUS hid90(){
PARSER op, hid89; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid89)(x));
return p_tok;
}
static STATUS hid91(PARAM x){
return p_test0(opcodeTable[x]==4);
}
static VOID hid92(PARAM x,PARAM y){
 i_opclass=4; i_opcode=x; i_dword=y; 
}
static STATUS hid93(PARAM x,PARAM y){
PARSER p_nothing0;ACTION hid92;
return p_attach0n(TOPARSER p_nothing0,0,hid92,2,x,y);
}
static STATUS hid94(PARAM x){
PARSER wdword, hid93; PARAM y;
static STATUS p_tok;
P_PSTAR(y,(TOPARSER wdword)(),(TOPARSER hid93)(x,y));
return p_tok;
}
static STATUS hid95(PARAM x){
PARSER hid91, hid94;
return p_andparse0n (TOPARSER hid91,1,x,TOPARSER hid94,1,x);
}
static STATUS hid96(){
PARSER op, hid95; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid95)(x));
return p_tok;
}
static STATUS hid97(PARAM x){
return p_test0(opcodeTable[x]==44);
}
static VOID hid98(PARAM x,PARAM y){
 i_opclass=4; i_opcode=x; i_dword=y; 
}
static STATUS hid99(PARAM x,PARAM y){
PARSER p_nothing0;ACTION hid98;
return p_attach0n(TOPARSER p_nothing0,0,hid98,2,x,y);
}
static STATUS hid100(PARAM x){
PARSER adword, hid99; PARAM y;
static STATUS p_tok;
P_PSTAR(y,(TOPARSER adword)(),(TOPARSER hid99)(x,y));
return p_tok;
}
static STATUS hid101(PARAM x){
PARSER hid97, hid100;
return p_andparse0n (TOPARSER hid97,1,x,TOPARSER hid100,1,x);
}
static STATUS hid102(){
PARSER op, hid101; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid101)(x));
return p_tok;
}
static STATUS hid103(PARAM x){
return p_test0(opcodeTable[x]==5);
}
static VOID hid104(PARAM x){
 i_opclass=5; i_opcode=x; 
}
static STATUS hid105(PARAM x){
PARSER p_nothing0;ACTION hid104;
return p_attach0n(TOPARSER p_nothing0,0,hid104,1,x);
}
static STATUS hid106(PARAM x){
PARSER pword, hid105;
return p_andparse0n (TOPARSER pword,0,TOPARSER hid105,1,x);
}
static STATUS hid107(PARAM x){
PARSER hid103, hid106;
return p_andparse0n (TOPARSER hid103,1,x,TOPARSER hid106,1,x);
}
static STATUS hid108(){
PARSER op, hid107; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid107)(x));
return p_tok;
}
static STATUS hid109(PARAM x){
return p_test0(opcodeTable[x]==6);
}
static VOID hid110(PARAM x){
 i_opclass=6; i_opcode=x; 
}
static STATUS hid111(PARAM x){
PARSER p_nothing0;ACTION hid110;
return p_attach0n(TOPARSER p_nothing0,0,hid110,1,x);
}
static STATUS hid112(PARAM x){
PARSER modrm, hid111;
return p_andparse0n (TOPARSER modrm,0,TOPARSER hid111,1,x);
}
static STATUS hid113(PARAM x){
PARSER hid109, hid112;
return p_andparse0n (TOPARSER hid109,1,x,TOPARSER hid112,1,x);
}
static STATUS hid114(){
PARSER op, hid113; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid113)(x));
return p_tok;
}
static STATUS hid115(PARAM x){
return p_test0(opcodeTable[x]==7);
}
static VOID hid116(PARAM x,PARAM y){
 i_opclass=7; i_opcode=x; i_byte=y; 
}
static STATUS hid117(PARAM x,PARAM y){
PARSER p_nothing0;ACTION hid116;
return p_attach0n(TOPARSER p_nothing0,0,hid116,2,x,y);
}
static STATUS hid118(PARAM x){
PARSER byte, hid117; PARAM y;
static STATUS p_tok;
P_PSTAR(y,(TOPARSER byte)(),(TOPARSER hid117)(x,y));
return p_tok;
}
static STATUS hid119(PARAM x){
PARSER modrm, hid118;
return p_andparse0n (TOPARSER modrm,0,TOPARSER hid118,1,x);
}
static STATUS hid120(PARAM x){
PARSER hid115, hid119;
return p_andparse0n (TOPARSER hid115,1,x,TOPARSER hid119,1,x);
}
static STATUS hid121(){
PARSER op, hid120; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid120)(x));
return p_tok;
}
static STATUS hid122 (){
PARSER hid121, onecontinue;
static STATUS p_tok;
p_tok = (TOPARSER hid121) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER onecontinue) ();
}
static STATUS hid123 (){
PARSER hid114, hid122;
static STATUS p_tok;
p_tok = (TOPARSER hid114) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid122) ();
}
static STATUS hid124 (){
PARSER hid108, hid123;
static STATUS p_tok;
p_tok = (TOPARSER hid108) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid123) ();
}
static STATUS hid125 (){
PARSER hid102, hid124;
static STATUS p_tok;
p_tok = (TOPARSER hid102) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid124) ();
}
static STATUS hid126 (){
PARSER hid96, hid125;
static STATUS p_tok;
p_tok = (TOPARSER hid96) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid125) ();
}
static STATUS hid127 (){
PARSER hid90, hid126;
static STATUS p_tok;
p_tok = (TOPARSER hid90) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid126) ();
}
static STATUS hid128 (){
PARSER hid83, hid127;
static STATUS p_tok;
p_tok = (TOPARSER hid83) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid127) ();
}
static STATUS hid129 (){
PARSER hid77, hid128;
static STATUS p_tok;
p_tok = (TOPARSER hid77) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid128) ();
}
static STATUS hid130 (){
PARSER hid71, hid129;
static STATUS p_tok;
p_tok = (TOPARSER hid71) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid129) ();
}
STATUS onebyteinstr(){
PARSER hid130;
return((TOPARSER hid130)());
}


static STATUS hid131(PARAM x){
return p_test0(opcodeTable[x]==8);
}
static VOID hid132(PARAM x,PARAM y){
 i_opclass=8; i_opcode=x; i_dword=y; 
}
static STATUS hid133(PARAM x,PARAM y){
PARSER p_nothing0;ACTION hid132;
return p_attach0n(TOPARSER p_nothing0,0,hid132,2,x,y);
}
static STATUS hid134(PARAM x){
PARSER wdword, hid133; PARAM y;
static STATUS p_tok;
P_PSTAR(y,(TOPARSER wdword)(),(TOPARSER hid133)(x,y));
return p_tok;
}
static STATUS hid135(PARAM x){
PARSER modrm, hid134;
return p_andparse0n (TOPARSER modrm,0,TOPARSER hid134,1,x);
}
static STATUS hid136(PARAM x){
PARSER hid131, hid135;
return p_andparse0n (TOPARSER hid131,1,x,TOPARSER hid135,1,x);
}
static STATUS hid137(){
PARSER op, hid136; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid136)(x));
return p_tok;
}
static STATUS hid138(PARAM x){
return p_test0(opcodeTable[x]==9);
}
static VOID hid139(PARAM x){
 i_opclass=9; i_opcode=x; 
}
static STATUS hid140(PARAM x){
PARSER p_nothing0;ACTION hid139;
return p_attach0n(TOPARSER p_nothing0,0,hid139,1,x);
}
static STATUS hid141(PARAM x){
PARSER opext, hid140;
return p_andparse0n (TOPARSER opext,0,TOPARSER hid140,1,x);
}
static STATUS hid142(PARAM x){
PARSER hid138, hid141;
return p_andparse0n (TOPARSER hid138,1,x,TOPARSER hid141,1,x);
}
static STATUS hid143(){
PARSER op, hid142; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid142)(x));
return p_tok;
}
static STATUS hid144(PARAM x){
return p_test0(opcodeTable[x]==10);
}
static VOID hid145(PARAM x,PARAM y){
 i_opclass=10; i_opcode=x; i_byte=y; 
}
static STATUS hid146(PARAM x,PARAM y){
PARSER p_nothing0;ACTION hid145;
return p_attach0n(TOPARSER p_nothing0,0,hid145,2,x,y);
}
static STATUS hid147(PARAM x){
PARSER byte, hid146; PARAM y;
static STATUS p_tok;
P_PSTAR(y,(TOPARSER byte)(),(TOPARSER hid146)(x,y));
return p_tok;
}
static STATUS hid148(PARAM x){
PARSER opext, hid147;
return p_andparse0n (TOPARSER opext,0,TOPARSER hid147,1,x);
}
static STATUS hid149(PARAM x){
PARSER hid144, hid148;
return p_andparse0n (TOPARSER hid144,1,x,TOPARSER hid148,1,x);
}
static STATUS hid150(){
PARSER op, hid149; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid149)(x));
return p_tok;
}
static STATUS hid151(PARAM x){
return p_test0(opcodeTable[x]==11);
}
static VOID hid152(PARAM x,PARAM y){
 i_opclass=11; i_opcode=x; i_dword=y; 
}
static STATUS hid153(PARAM x,PARAM y){
PARSER p_nothing0;ACTION hid152;
return p_attach0n(TOPARSER p_nothing0,0,hid152,2,x,y);
}
static STATUS hid154(PARAM x){
PARSER wdword, hid153; PARAM y;
static STATUS p_tok;
P_PSTAR(y,(TOPARSER wdword)(),(TOPARSER hid153)(x,y));
return p_tok;
}
static STATUS hid155(PARAM x){
PARSER opext, hid154;
return p_andparse0n (TOPARSER opext,0,TOPARSER hid154,1,x);
}
static STATUS hid156(PARAM x){
PARSER hid151, hid155;
return p_andparse0n (TOPARSER hid151,1,x,TOPARSER hid155,1,x);
}
static STATUS hid157(){
PARSER op, hid156; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid156)(x));
return p_tok;
}
static STATUS hid158(PARAM x){
return p_test0(opcodeTable[x]==12);
}
static VOID hid159(PARAM x){
 i_opclass=12; i_opcode=x; 
}
static STATUS hid160(PARAM x){
PARSER p_nothing0;ACTION hid159;
return p_attach0n(TOPARSER p_nothing0,0,hid159,1,x);
}
static STATUS hid161(PARAM x){
PARSER opextg, hid160;
return p_andparse0n (TOPARSER opextg,0,TOPARSER hid160,1,x);
}
static STATUS hid162(PARAM x){
PARSER hid158, hid161;
return p_andparse0n (TOPARSER hid158,1,x,TOPARSER hid161,1,x);
}
static STATUS hid163(){
PARSER op, hid162; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid162)(x));
return p_tok;
}
static STATUS hid164 (){
PARSER waitgroup, repeatgroup;
static STATUS p_tok;
p_tok = (TOPARSER waitgroup) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER repeatgroup) ();
}
static STATUS hid165 (){
PARSER testgroup, hid164;
static STATUS p_tok;
p_tok = (TOPARSER testgroup) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid164) ();
}
static STATUS hid166 (){
PARSER casejmpblk, hid165;
static STATUS p_tok;
p_tok = (TOPARSER casejmpblk) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid165) ();
}
static STATUS hid167 (){
PARSER hid163, hid166;
static STATUS p_tok;
p_tok = (TOPARSER hid163) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid166) ();
}
static STATUS hid168 (){
PARSER hid157, hid167;
static STATUS p_tok;
p_tok = (TOPARSER hid157) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid167) ();
}
static STATUS hid169 (){
PARSER hid150, hid168;
static STATUS p_tok;
p_tok = (TOPARSER hid150) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid168) ();
}
static STATUS hid170 (){
PARSER hid143, hid169;
static STATUS p_tok;
p_tok = (TOPARSER hid143) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid169) ();
}
static STATUS hid171 (){
PARSER hid137, hid170;
static STATUS p_tok;
p_tok = (TOPARSER hid137) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid170) ();
}
STATUS onecontinue(){
PARSER hid171;
return((TOPARSER hid171)());
}

static STATUS hid172(PARAM x){
return p_test0(opcode2Table[x]==0);
}
static VOID hid173(PARAM x){
 i_opclass=0; i_opcode=x; 
}
static STATUS hid174(PARAM x){
PARSER p_nothing0;ACTION hid173;
return p_attach0n(TOPARSER p_nothing0,0,hid173,1,x);
}
static STATUS hid175(PARAM x){
PARSER hid172, hid174;
return p_andparse0n (TOPARSER hid172,1,x,TOPARSER hid174,1,x);
}
static STATUS hid176(){
PARSER op, hid175; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid175)(x));
return p_tok;
}
static STATUS hid177(PARAM x){
return p_test0(opcode2Table[x]==1);
}
static VOID hid178(PARAM x,PARAM y){
 i_opclass=1; i_opcode=x; i_dword=y; 
}
static STATUS hid179(PARAM x,PARAM y){
PARSER p_nothing0;ACTION hid178;
return p_attach0n(TOPARSER p_nothing0,0,hid178,2,x,y);
}
static STATUS hid180(PARAM x){
PARSER adword, hid179; PARAM y;
static STATUS p_tok;
P_PSTAR(y,(TOPARSER adword)(),(TOPARSER hid179)(x,y));
return p_tok;
}
static STATUS hid181(PARAM x){
PARSER hid177, hid180;
return p_andparse0n (TOPARSER hid177,1,x,TOPARSER hid180,1,x);
}
static STATUS hid182(){
PARSER op, hid181; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid181)(x));
return p_tok;
}
static STATUS hid183(PARAM x){
return p_test0(opcode2Table[x]==2);
}
static VOID hid184(PARAM x){
 i_opclass=2; i_opcode=x; 
}
static STATUS hid185(PARAM x){
PARSER p_nothing0;ACTION hid184;
return p_attach0n(TOPARSER p_nothing0,0,hid184,1,x);
}
static STATUS hid186(PARAM x){
PARSER modrm, hid185;
return p_andparse0n (TOPARSER modrm,0,TOPARSER hid185,1,x);
}
static STATUS hid187(PARAM x){
PARSER hid183, hid186;
return p_andparse0n (TOPARSER hid183,1,x,TOPARSER hid186,1,x);
}
static STATUS hid188(){
PARSER op, hid187; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid187)(x));
return p_tok;
}
static STATUS hid189(PARAM x){
return p_test0(opcode2Table[x]==3);
}
static VOID hid190(PARAM x,PARAM y){
 i_opclass=3; i_opcode=x; i_byte=y;  
}
static STATUS hid191(PARAM x,PARAM y){
PARSER p_nothing0;ACTION hid190;
return p_attach0n(TOPARSER p_nothing0,0,hid190,2,x,y);
}
static STATUS hid192(PARAM x){
PARSER byte, hid191; PARAM y;
static STATUS p_tok;
P_PSTAR(y,(TOPARSER byte)(),(TOPARSER hid191)(x,y));
return p_tok;
}
static STATUS hid193(PARAM x){
PARSER modrm, hid192;
return p_andparse0n (TOPARSER modrm,0,TOPARSER hid192,1,x);
}
static STATUS hid194(PARAM x){
PARSER hid189, hid193;
return p_andparse0n (TOPARSER hid189,1,x,TOPARSER hid193,1,x);
}
static STATUS hid195(){
PARSER op, hid194; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid194)(x));
return p_tok;
}
static STATUS hid196(PARAM x){
return p_test0(opcode2Table[x]==4);
}
static VOID hid197(PARAM x){
 i_opclass=4; i_opcode=x; 
}
static STATUS hid198(PARAM x){
PARSER p_nothing0;ACTION hid197;
return p_attach0n(TOPARSER p_nothing0,0,hid197,1,x);
}
static STATUS hid199(PARAM x){
PARSER opext, hid198;
return p_andparse0n (TOPARSER opext,0,TOPARSER hid198,1,x);
}
static STATUS hid200(PARAM x){
PARSER hid196, hid199;
return p_andparse0n (TOPARSER hid196,1,x,TOPARSER hid199,1,x);
}
static STATUS hid201(){
PARSER op, hid200; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid200)(x));
return p_tok;
}
static STATUS hid202(PARAM x){
return p_test0(opcode2Table[x]==5);
}
static VOID hid203(PARAM x,PARAM y){
 i_opclass=5; i_opcode=x; i_byte=y;  
}
static STATUS hid204(PARAM x,PARAM y){
PARSER p_nothing0;ACTION hid203;
return p_attach0n(TOPARSER p_nothing0,0,hid203,2,x,y);
}
static STATUS hid205(PARAM x){
PARSER byte, hid204; PARAM y;
static STATUS p_tok;
P_PSTAR(y,(TOPARSER byte)(),(TOPARSER hid204)(x,y));
return p_tok;
}
static STATUS hid206(PARAM x){
PARSER opext, hid205;
return p_andparse0n (TOPARSER opext,0,TOPARSER hid205,1,x);
}
static STATUS hid207(PARAM x){
PARSER hid202, hid206;
return p_andparse0n (TOPARSER hid202,1,x,TOPARSER hid206,1,x);
}
static STATUS hid208(){
PARSER op, hid207; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid207)(x));
return p_tok;
}
static STATUS hid209 (){
PARSER hid201, hid208;
static STATUS p_tok;
p_tok = (TOPARSER hid201) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid208) ();
}
static STATUS hid210 (){
PARSER hid195, hid209;
static STATUS p_tok;
p_tok = (TOPARSER hid195) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid209) ();
}
static STATUS hid211 (){
PARSER hid188, hid210;
static STATUS p_tok;
p_tok = (TOPARSER hid188) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid210) ();
}
static STATUS hid212 (){
PARSER hid182, hid211;
static STATUS p_tok;
p_tok = (TOPARSER hid182) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid211) ();
}
static STATUS hid213 (){
PARSER hid176, hid212;
static STATUS p_tok;
p_tok = (TOPARSER hid176) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid212) ();
}
STATUS twobyteinstr(){
PARSER hid213;
return((TOPARSER hid213)());
}

static STATUS hid214(){
return p_test0(addressOveride==0);
}
static STATUS hid215(){
PARSER hid214, modrm1;
return p_andparse0n (TOPARSER hid214,0,TOPARSER modrm1,0);
}
static STATUS hid216(){
return p_test0(addressOveride==1);
}
static STATUS hid217(){
PARSER hid216, modrm2;
return p_andparse0n (TOPARSER hid216,0,TOPARSER modrm2,0);
}
static STATUS hid218 (){
PARSER hid215, hid217;
static STATUS p_tok;
p_tok = (TOPARSER hid215) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid217) ();
}
STATUS modrm(){
PARSER hid218;
return((TOPARSER hid218)());
}

static STATUS hid219(PARAM x){
return p_test0(modTable[x]==1);
}
static VOID hid220(PARAM x){
 i_mod=x; 
}
static STATUS hid221(PARAM x){
PARSER p_nothing0;ACTION hid220;
return p_attach0n(TOPARSER p_nothing0,0,hid220,1,x);
}
static STATUS hid222(PARAM x){
PARSER hid219, hid221;
return p_andparse0n (TOPARSER hid219,1,x,TOPARSER hid221,1,x);
}
static STATUS hid223(){
PARSER op, hid222; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid222)(x));
return p_tok;
}
static STATUS hid224(PARAM x){
return p_test0(modTable[x]==2);
}
static VOID hid225(PARAM x,PARAM y1,PARAM y2){
 i_mod=x; i_sib=y1; m_dword=y2; 
}
static STATUS hid226(PARAM x,PARAM y1,PARAM y2){
PARSER p_nothing0;ACTION hid225;
return p_attach0n(TOPARSER p_nothing0,0,hid225,3,x,y1,y2);
}
static STATUS hid227(PARAM x,PARAM y1){
PARSER dword, hid226; PARAM y2;
static STATUS p_tok;
P_PSTAR(y2,(TOPARSER dword)(),(TOPARSER hid226)(x,y1,y2));
return p_tok;
}
static STATUS hid228(PARAM x){
PARSER sibstar, hid227; PARAM y1;
static STATUS p_tok;
P_PSTAR(y1,(TOPARSER sibstar)(),(TOPARSER hid227)(x,y1));
return p_tok;
}
static STATUS hid229(PARAM x){
PARSER hid224, hid228;
return p_andparse0n (TOPARSER hid224,1,x,TOPARSER hid228,1,x);
}
static STATUS hid230(){
PARSER op, hid229; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid229)(x));
return p_tok;
}
static STATUS hid231(PARAM x){
return p_test0(modTable[x]==2);
}
static VOID hid232(PARAM x,PARAM y){
 i_mod=x; i_sib=y; 
}
static STATUS hid233(PARAM x,PARAM y){
PARSER p_nothing0;ACTION hid232;
return p_attach0n(TOPARSER p_nothing0,0,hid232,2,x,y);
}
static STATUS hid234(PARAM x){
PARSER sibnstar, hid233; PARAM y;
static STATUS p_tok;
P_PSTAR(y,(TOPARSER sibnstar)(),(TOPARSER hid233)(x,y));
return p_tok;
}
static STATUS hid235(PARAM x){
PARSER hid231, hid234;
return p_andparse0n (TOPARSER hid231,1,x,TOPARSER hid234,1,x);
}
static STATUS hid236(){
PARSER op, hid235; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid235)(x));
return p_tok;
}
static STATUS hid237(PARAM x){
return p_test0(modTable[x]==3);
}
static VOID hid238(PARAM x,PARAM y){
 i_mod=x; m_dword=y; 
}
static STATUS hid239(PARAM x,PARAM y){
PARSER p_nothing0;ACTION hid238;
return p_attach0n(TOPARSER p_nothing0,0,hid238,2,x,y);
}
static STATUS hid240(PARAM x){
PARSER dword, hid239; PARAM y;
static STATUS p_tok;
P_PSTAR(y,(TOPARSER dword)(),(TOPARSER hid239)(x,y));
return p_tok;
}
static STATUS hid241(PARAM x){
PARSER hid237, hid240;
return p_andparse0n (TOPARSER hid237,1,x,TOPARSER hid240,1,x);
}
static STATUS hid242(){
PARSER op, hid241; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid241)(x));
return p_tok;
}
static STATUS hid243(PARAM x){
return p_test0(modTable[x]==4);
}
static VOID hid244(PARAM x,PARAM y){
 i_mod=x; m_byte=y; 
}
static STATUS hid245(PARAM x,PARAM y){
PARSER p_nothing0;ACTION hid244;
return p_attach0n(TOPARSER p_nothing0,0,hid244,2,x,y);
}
static STATUS hid246(PARAM x){
PARSER byte, hid245; PARAM y;
static STATUS p_tok;
P_PSTAR(y,(TOPARSER byte)(),(TOPARSER hid245)(x,y));
return p_tok;
}
static STATUS hid247(PARAM x){
PARSER hid243, hid246;
return p_andparse0n (TOPARSER hid243,1,x,TOPARSER hid246,1,x);
}
static STATUS hid248(){
PARSER op, hid247; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid247)(x));
return p_tok;
}
static STATUS hid249(PARAM x){
return p_test0(modTable[x]==5);
}
static VOID hid250(PARAM x,PARAM y1,PARAM y2){
 i_mod=x; i_sib=y1; m_byte=y2; 
}
static STATUS hid251(PARAM x,PARAM y1,PARAM y2){
PARSER p_nothing0;ACTION hid250;
return p_attach0n(TOPARSER p_nothing0,0,hid250,3,x,y1,y2);
}
static STATUS hid252(PARAM x,PARAM y1){
PARSER byte, hid251; PARAM y2;
static STATUS p_tok;
P_PSTAR(y2,(TOPARSER byte)(),(TOPARSER hid251)(x,y1,y2));
return p_tok;
}
static STATUS hid253(PARAM x){
PARSER sib, hid252; PARAM y1;
static STATUS p_tok;
P_PSTAR(y1,(TOPARSER sib)(),(TOPARSER hid252)(x,y1));
return p_tok;
}
static STATUS hid254(PARAM x){
PARSER hid249, hid253;
return p_andparse0n (TOPARSER hid249,1,x,TOPARSER hid253,1,x);
}
static STATUS hid255(){
PARSER op, hid254; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid254)(x));
return p_tok;
}
static STATUS hid256(PARAM x){
return p_test0(modTable[x]==6);
}
static VOID hid257(PARAM x,PARAM y){
 i_mod=x; m_dword=y; 
}
static STATUS hid258(PARAM x,PARAM y){
PARSER p_nothing0;ACTION hid257;
return p_attach0n(TOPARSER p_nothing0,0,hid257,2,x,y);
}
static STATUS hid259(PARAM x){
PARSER dword, hid258; PARAM y;
static STATUS p_tok;
P_PSTAR(y,(TOPARSER dword)(),(TOPARSER hid258)(x,y));
return p_tok;
}
static STATUS hid260(PARAM x){
PARSER hid256, hid259;
return p_andparse0n (TOPARSER hid256,1,x,TOPARSER hid259,1,x);
}
static STATUS hid261(){
PARSER op, hid260; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid260)(x));
return p_tok;
}
static STATUS hid262(PARAM x){
return p_test0(modTable[x]==7);
}
static VOID hid263(PARAM x,PARAM y1,PARAM y2){
 i_mod=x; i_sib=y1; m_dword=y2; 
}
static STATUS hid264(PARAM x,PARAM y1,PARAM y2){
PARSER p_nothing0;ACTION hid263;
return p_attach0n(TOPARSER p_nothing0,0,hid263,3,x,y1,y2);
}
static STATUS hid265(PARAM x,PARAM y1){
PARSER dword, hid264; PARAM y2;
static STATUS p_tok;
P_PSTAR(y2,(TOPARSER dword)(),(TOPARSER hid264)(x,y1,y2));
return p_tok;
}
static STATUS hid266(PARAM x){
PARSER sib, hid265; PARAM y1;
static STATUS p_tok;
P_PSTAR(y1,(TOPARSER sib)(),(TOPARSER hid265)(x,y1));
return p_tok;
}
static STATUS hid267(PARAM x){
PARSER hid262, hid266;
return p_andparse0n (TOPARSER hid262,1,x,TOPARSER hid266,1,x);
}
static STATUS hid268(){
PARSER op, hid267; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid267)(x));
return p_tok;
}
static STATUS hid269(PARAM x){
return p_test0(modTable[x]==8);
}
static VOID hid270(PARAM x){
 i_mod=x; 
}
static STATUS hid271(PARAM x){
PARSER p_nothing0;ACTION hid270;
return p_attach0n(TOPARSER p_nothing0,0,hid270,1,x);
}
static STATUS hid272(PARAM x){
PARSER hid269, hid271;
return p_andparse0n (TOPARSER hid269,1,x,TOPARSER hid271,1,x);
}
static STATUS hid273(){
PARSER op, hid272; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid272)(x));
return p_tok;
}
static STATUS hid274 (){
PARSER hid268, hid273;
static STATUS p_tok;
p_tok = (TOPARSER hid268) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid273) ();
}
static STATUS hid275 (){
PARSER hid261, hid274;
static STATUS p_tok;
p_tok = (TOPARSER hid261) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid274) ();
}
static STATUS hid276 (){
PARSER hid255, hid275;
static STATUS p_tok;
p_tok = (TOPARSER hid255) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid275) ();
}
static STATUS hid277 (){
PARSER hid248, hid276;
static STATUS p_tok;
p_tok = (TOPARSER hid248) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid276) ();
}
static STATUS hid278 (){
PARSER hid242, hid277;
static STATUS p_tok;
p_tok = (TOPARSER hid242) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid277) ();
}
static STATUS hid279 (){
PARSER hid236, hid278;
static STATUS p_tok;
p_tok = (TOPARSER hid236) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid278) ();
}
static STATUS hid280 (){
PARSER hid230, hid279;
static STATUS p_tok;
p_tok = (TOPARSER hid230) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid279) ();
}
static STATUS hid281 (){
PARSER hid223, hid280;
static STATUS p_tok;
p_tok = (TOPARSER hid223) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid280) ();
}
STATUS modrm1(){
PARSER hid281;
return((TOPARSER hid281)());
}

static STATUS hid282(PARAM x){
return p_test0(mod16Table[x]==1);
}
static VOID hid283(PARAM x){
 i_mod=x; 
}
static STATUS hid284(PARAM x){
PARSER p_nothing0;ACTION hid283;
return p_attach0n(TOPARSER p_nothing0,0,hid283,1,x);
}
static STATUS hid285(PARAM x){
PARSER hid282, hid284;
return p_andparse0n (TOPARSER hid282,1,x,TOPARSER hid284,1,x);
}
static STATUS hid286(){
PARSER op, hid285; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid285)(x));
return p_tok;
}
static STATUS hid287(PARAM x){
return p_test0(mod16Table[x]==2);
}
static VOID hid288(PARAM x,PARAM y){
 i_mod=x; m_dword=y; 
}
static STATUS hid289(PARAM x,PARAM y){
PARSER p_nothing0;ACTION hid288;
return p_attach0n(TOPARSER p_nothing0,0,hid288,2,x,y);
}
static STATUS hid290(PARAM x){
PARSER word, hid289; PARAM y;
static STATUS p_tok;
P_PSTAR(y,(TOPARSER word)(),(TOPARSER hid289)(x,y));
return p_tok;
}
static STATUS hid291(PARAM x){
PARSER hid287, hid290;
return p_andparse0n (TOPARSER hid287,1,x,TOPARSER hid290,1,x);
}
static STATUS hid292(){
PARSER op, hid291; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid291)(x));
return p_tok;
}
static STATUS hid293(PARAM x){
return p_test0(mod16Table[x]==3);
}
static VOID hid294(PARAM x,PARAM y){
 i_mod=x; m_byte=y;  
}
static STATUS hid295(PARAM x,PARAM y){
PARSER p_nothing0;ACTION hid294;
return p_attach0n(TOPARSER p_nothing0,0,hid294,2,x,y);
}
static STATUS hid296(PARAM x){
PARSER byte, hid295; PARAM y;
static STATUS p_tok;
P_PSTAR(y,(TOPARSER byte)(),(TOPARSER hid295)(x,y));
return p_tok;
}
static STATUS hid297(PARAM x){
PARSER hid293, hid296;
return p_andparse0n (TOPARSER hid293,1,x,TOPARSER hid296,1,x);
}
static STATUS hid298(){
PARSER op, hid297; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid297)(x));
return p_tok;
}
static STATUS hid299(PARAM x){
return p_test0(mod16Table[x]==4);
}
static VOID hid300(PARAM x,PARAM y){
 i_mod=x; m_dword=y; 
}
static STATUS hid301(PARAM x,PARAM y){
PARSER p_nothing0;ACTION hid300;
return p_attach0n(TOPARSER p_nothing0,0,hid300,2,x,y);
}
static STATUS hid302(PARAM x){
PARSER word, hid301; PARAM y;
static STATUS p_tok;
P_PSTAR(y,(TOPARSER word)(),(TOPARSER hid301)(x,y));
return p_tok;
}
static STATUS hid303(PARAM x){
PARSER hid299, hid302;
return p_andparse0n (TOPARSER hid299,1,x,TOPARSER hid302,1,x);
}
static STATUS hid304(){
PARSER op, hid303; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid303)(x));
return p_tok;
}
static STATUS hid305(PARAM x){
return p_test0(mod16Table[x]==5);
}
static VOID hid306(PARAM x){
 i_mod=x; 
}
static STATUS hid307(PARAM x){
PARSER p_nothing0;ACTION hid306;
return p_attach0n(TOPARSER p_nothing0,0,hid306,1,x);
}
static STATUS hid308(PARAM x){
PARSER hid305, hid307;
return p_andparse0n (TOPARSER hid305,1,x,TOPARSER hid307,1,x);
}
static STATUS hid309(){
PARSER op, hid308; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid308)(x));
return p_tok;
}
static STATUS hid310 (){
PARSER hid304, hid309;
static STATUS p_tok;
p_tok = (TOPARSER hid304) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid309) ();
}
static STATUS hid311 (){
PARSER hid298, hid310;
static STATUS p_tok;
p_tok = (TOPARSER hid298) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid310) ();
}
static STATUS hid312 (){
PARSER hid292, hid311;
static STATUS p_tok;
p_tok = (TOPARSER hid292) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid311) ();
}
static STATUS hid313 (){
PARSER hid286, hid312;
static STATUS p_tok;
p_tok = (TOPARSER hid286) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid312) ();
}
STATUS modrm2(){
PARSER hid313;
return((TOPARSER hid313)());
}

static STATUS hid314(PARAM x){
return p_test0(sibTable[x]==1);
}
static STATUS hid315(PARAM x){
return p_atch0((PARAM)((TOVALUE x)));
}
static STATUS hid316(PARAM x){
PARSER hid314, hid315;
return p_andparse0n (TOPARSER hid314,1,x,TOPARSER hid315,1,x);
}
static STATUS hid317(){
PARSER op, hid316; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid316)(x));
return p_tok;
}
STATUS sibstar(){
PARSER hid317;
return((TOPARSER hid317)());
}

static STATUS hid318(PARAM x){
return p_test0(sibTable[x]==2);
}
static STATUS hid319(PARAM x){
return p_atch0((PARAM)((TOVALUE x)));
}
static STATUS hid320(PARAM x){
PARSER hid318, hid319;
return p_andparse0n (TOPARSER hid318,1,x,TOPARSER hid319,1,x);
}
static STATUS hid321(){
PARSER op, hid320; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid320)(x));
return p_tok;
}
STATUS sibnstar(){
PARSER hid321;
return((TOPARSER hid321)());
}

STATUS sib(){
PARSER byte;
return((TOPARSER byte)());
}
  
static STATUS hid322(PARAM x1){
return p_test0(x1==255);
}
static STATUS hid323(PARAM x1,PARAM x2){
return p_test0(x2==36);
}
static STATUS hid324(PARAM x1,PARAM x2,PARAM x3){
return p_test0(rmTable[x3]==5);
}
static VOID hid325(PARAM x1,PARAM x2,PARAM x3){
 i_opclass=13; i_opcode=x1; i_mod=x2; i_sib=x3; 
}
static STATUS hid326(PARAM x1,PARAM x2,PARAM x3){
PARSER p_nothing0;ACTION hid325;
return p_attach0n(TOPARSER p_nothing0,0,hid325,3,x1,x2,x3);
}
static VOID hid327(PARAM x1,PARAM x2,PARAM x3){
 finished=1; 
}
static STATUS hid328(PARAM x1,PARAM x2,PARAM x3){
PARSER p_nothing0;ACTION hid327;
return p_attach0n(TOPARSER p_nothing0,0,hid327,3,x1,x2,x3);
}
static STATUS hid329(PARAM x1,PARAM x2,PARAM x3){
PARSER label1, hid328;
return p_andparse0n (TOPARSER label1,0,TOPARSER hid328,3,x1,x2,x3);
}
static STATUS hid330(PARAM x1,PARAM x2,PARAM x3){
PARSER p_uniq0, hid329;
return p_andparse0n (TOPARSER p_uniq0,0,TOPARSER hid329,3,x1,x2,x3);
}
static STATUS hid331(PARAM x1,PARAM x2,PARAM x3){
PARSER labelstartposition, hid330;
return p_andparse0n (TOPARSER labelstartposition,0,TOPARSER hid330,3,x1,x2,x3);
}
static STATUS hid332(PARAM x1,PARAM x2,PARAM x3){
PARSER hid326, hid331;
return p_andparse0n (TOPARSER hid326,3,x1,x2,x3,TOPARSER hid331,3,x1,x2,x3);
}
static STATUS hid333(PARAM x1,PARAM x2,PARAM x3){
PARSER hid324, hid332;
return p_andparse0n (TOPARSER hid324,3,x1,x2,x3,TOPARSER hid332,3,x1,x2,x3);
}
static STATUS hid334(PARAM x1,PARAM x2){
PARSER op, hid333; PARAM x3;
static STATUS p_tok;
P_PSTAR(x3,(TOPARSER op)(),(TOPARSER hid333)(x1,x2,x3));
return p_tok;
}
static STATUS hid335(PARAM x1,PARAM x2){
PARSER hid323, hid334;
return p_andparse0n (TOPARSER hid323,2,x1,x2,TOPARSER hid334,2,x1,x2);
}
static STATUS hid336(PARAM x1){
PARSER op, hid335; PARAM x2;
static STATUS p_tok;
P_PSTAR(x2,(TOPARSER op)(),(TOPARSER hid335)(x1,x2));
return p_tok;
}
static STATUS hid337(PARAM x1){
PARSER hid322, hid336;
return p_andparse0n (TOPARSER hid322,1,x1,TOPARSER hid336,1,x1);
}
static STATUS hid338(){
PARSER op, hid337; PARAM x1;
static STATUS p_tok;
P_PSTAR(x1,(TOPARSER op)(),(TOPARSER hid337)(x1));
return p_tok;
}
static STATUS hid339(PARAM x){
return p_test0(x==255);
}
static STATUS hid340(PARAM x,PARAM y){
return p_test0(regTable[y]<7);
}
static STATUS hid341(PARAM x){
PARSER p_anything0, hid340; PARAM y;
static STATUS p_tok;
P_PSTAR(y,(TOPARSER p_anything0)(),(TOPARSER hid340)(x,y));
return p_tok;
}
static STATUS hid342(PARAM x){
PARSER hid341;
return p_hidden0n(TOPARSER hid341,1,x);
}
static VOID hid343(PARAM x){
 i_opclass=13; i_opcode=x; 
}
static STATUS hid344(PARAM x){
PARSER p_nothing0;ACTION hid343;
return p_attach0n(TOPARSER p_nothing0,0,hid343,1,x);
}
static STATUS hid345(PARAM x){
PARSER opext, hid344;
return p_andparse0n (TOPARSER opext,0,TOPARSER hid344,1,x);
}
static STATUS hid346(PARAM x){
PARSER hid342, hid345;
return p_andparse0n (TOPARSER hid342,1,x,TOPARSER hid345,1,x);
}
static STATUS hid347(PARAM x){
PARSER hid339, hid346;
return p_andparse0n (TOPARSER hid339,1,x,TOPARSER hid346,1,x);
}
static STATUS hid348(){
PARSER op, hid347; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid347)(x));
return p_tok;
}
static STATUS hid349 (){
PARSER hid338, hid348;
static STATUS p_tok;
p_tok = (TOPARSER hid338) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid348) ();
}
STATUS casejmpblk(){
PARSER hid349;
return((TOPARSER hid349)());
}
 
static VOID hid350(PARAM x){
 m_dword=label_start_pos=x; opclass=1; bodyprint0(); 
}
static STATUS hid351(PARAM x){
PARSER p_nothing0;ACTION hid350;
return p_attach0n(TOPARSER p_nothing0,0,hid350,1,x);
}
static STATUS hid352(){
PARSER dword, hid351; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER dword)(),(TOPARSER hid351)(x));
return p_tok;
}
STATUS labelstartposition(){
PARSER hid352;
return((TOPARSER hid352)());
}

static STATUS hid353(){
return p_test0(cur_position==label_start_pos-7);
}
static VOID hid354(){
 addressprint(); 
}
static STATUS hid355(){
PARSER p_nothing0;ACTION hid354;
return p_attach0n(TOPARSER p_nothing0,0,hid354,0);
}
static VOID hid356(PARAM x){
 min_label=m_dword=x; bodyprint1(); 
}
static STATUS hid357(PARAM x){
PARSER p_nothing0;ACTION hid356;
return p_attach0n(TOPARSER p_nothing0,0,hid356,1,x);
}
static STATUS hid358(PARAM x){
PARSER tails, p_uniq0;
return p_andparse0n (TOPARSER tails,0,TOPARSER p_uniq0,0);
}
static STATUS hid359(PARAM x){
PARSER p_uniq0, hid358;
return p_andparse0n (TOPARSER p_uniq0,0,TOPARSER hid358,1,x);
}
static STATUS hid360(PARAM x){
PARSER hid357, hid359;
return p_andparse0n (TOPARSER hid357,1,x,TOPARSER hid359,1,x);
}
static STATUS hid361(){
PARSER dword, hid360; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER dword)(),(TOPARSER hid360)(x));
return p_tok;
}
static STATUS hid362(){
PARSER hid355, hid361;
return p_andparse0n (TOPARSER hid355,0,TOPARSER hid361,0);
}
static STATUS hid363(){
PARSER hid353, hid362;
return p_andparse0n (TOPARSER hid353,0,TOPARSER hid362,0);
}
static STATUS hid364 (){
PARSER hid363, p_nothing0;
static STATUS p_tok;
p_tok = (TOPARSER hid363) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER p_nothing0) ();
}
STATUS label1(){
PARSER hid364;
return((TOPARSER hid364)());
}

static STATUS hid365(){
PARSER label;
return p_many0n(TOPARSER label,0);
}
STATUS tails(){
PARSER hid365;
return((TOPARSER hid365)());
}

static STATUS hid366(){
return p_test0(nextMode&&cur_position<min_label-4);
}
static VOID hid367(){
 addressprint(); 
}
static STATUS hid368(){
PARSER p_nothing0;ACTION hid367;
return p_attach0n(TOPARSER p_nothing0,0,hid367,0);
}
static STATUS hid369(PARAM x){
return p_test0(isGoodAddress(x));
}
static VOID hid370(PARAM x){
 if((m_dword=x)<min_label)min_label=x; bodyprint1(); 
}
static STATUS hid371(PARAM x){
PARSER p_nothing0;ACTION hid370;
return p_attach0n(TOPARSER p_nothing0,0,hid370,1,x);
}
static STATUS hid372(PARAM x){
PARSER hid371, p_uniq0;
return p_andparse0n (TOPARSER hid371,1,x,TOPARSER p_uniq0,0);
}
static STATUS hid373(PARAM x){
PARSER hid369, hid372;
return p_andparse0n (TOPARSER hid369,1,x,TOPARSER hid372,1,x);
}
static STATUS hid374(){
PARSER dword, hid373; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER dword)(),(TOPARSER hid373)(x));
return p_tok;
}
static STATUS hid375(){
PARSER hid368, hid374;
return p_andparse0n (TOPARSER hid368,0,TOPARSER hid374,0);
}
static STATUS hid376(){
PARSER hid366, hid375;
return p_andparse0n (TOPARSER hid366,0,TOPARSER hid375,0);
}
STATUS label(){
PARSER hid376;
return((TOPARSER hid376)());
}


STATUS opext(){
PARSER modrm;
return((TOPARSER modrm)());
}

STATUS opextg(){
PARSER opext;
return((TOPARSER opext)());
}
 
static STATUS hid377(PARAM x){
return p_test0(x==246);
}
static VOID hid378(PARAM x,PARAM y){
 i_opclass=14; i_opcode=x; i_byte=y; 
}
static STATUS hid379(PARAM x,PARAM y){
PARSER p_nothing0;ACTION hid378;
return p_attach0n(TOPARSER p_nothing0,0,hid378,2,x,y);
}
static STATUS hid380(PARAM x){
PARSER byte, hid379; PARAM y;
static STATUS p_tok;
P_PSTAR(y,(TOPARSER byte)(),(TOPARSER hid379)(x,y));
return p_tok;
}
static STATUS hid381(PARAM x){
PARSER xS0, hid380;
return p_andparse0n (TOPARSER xS0,0,TOPARSER hid380,1,x);
}
static STATUS hid382(PARAM x){
PARSER hid377, hid381;
return p_andparse0n (TOPARSER hid377,1,x,TOPARSER hid381,1,x);
}
static STATUS hid383(){
PARSER op, hid382; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid382)(x));
return p_tok;
}
static STATUS hid384(PARAM x){
return p_test0(x==246);
}
static STATUS hid385(PARAM x,PARAM y){
return p_test0(regTable[y]>1);
}
static STATUS hid386(PARAM x){
PARSER p_anything0, hid385; PARAM y;
static STATUS p_tok;
P_PSTAR(y,(TOPARSER p_anything0)(),(TOPARSER hid385)(x,y));
return p_tok;
}
static STATUS hid387(PARAM x){
PARSER hid386;
return p_hidden0n(TOPARSER hid386,1,x);
}
static VOID hid388(PARAM x){
 i_opclass=14; i_opcode=x; 
}
static STATUS hid389(PARAM x){
PARSER p_nothing0;ACTION hid388;
return p_attach0n(TOPARSER p_nothing0,0,hid388,1,x);
}
static STATUS hid390(PARAM x){
PARSER opext, hid389;
return p_andparse0n (TOPARSER opext,0,TOPARSER hid389,1,x);
}
static STATUS hid391(PARAM x){
PARSER hid387, hid390;
return p_andparse0n (TOPARSER hid387,1,x,TOPARSER hid390,1,x);
}
static STATUS hid392(PARAM x){
PARSER hid384, hid391;
return p_andparse0n (TOPARSER hid384,1,x,TOPARSER hid391,1,x);
}
static STATUS hid393(){
PARSER op, hid392; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid392)(x));
return p_tok;
}
static STATUS hid394(PARAM x){
return p_test0(x==247);
}
static VOID hid395(PARAM x,PARAM y){
 i_opclass=14; i_opcode=x; i_dword=y; 
}
static STATUS hid396(PARAM x,PARAM y){
PARSER p_nothing0;ACTION hid395;
return p_attach0n(TOPARSER p_nothing0,0,hid395,2,x,y);
}
static STATUS hid397(PARAM x){
PARSER wdword, hid396; PARAM y;
static STATUS p_tok;
P_PSTAR(y,(TOPARSER wdword)(),(TOPARSER hid396)(x,y));
return p_tok;
}
static STATUS hid398(PARAM x){
PARSER xS0, hid397;
return p_andparse0n (TOPARSER xS0,0,TOPARSER hid397,1,x);
}
static STATUS hid399(PARAM x){
PARSER hid394, hid398;
return p_andparse0n (TOPARSER hid394,1,x,TOPARSER hid398,1,x);
}
static STATUS hid400(){
PARSER op, hid399; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid399)(x));
return p_tok;
}
static STATUS hid401(PARAM x){
return p_test0(x==247);
}
static VOID hid402(PARAM x){
 i_opclass=14; i_opcode=x; 
}
static STATUS hid403(PARAM x){
PARSER p_nothing0;ACTION hid402;
return p_attach0n(TOPARSER p_nothing0,0,hid402,1,x);
}
static STATUS hid404(PARAM x){
PARSER opext, hid403;
return p_andparse0n (TOPARSER opext,0,TOPARSER hid403,1,x);
}
static STATUS hid405(PARAM x){
PARSER hid401, hid404;
return p_andparse0n (TOPARSER hid401,1,x,TOPARSER hid404,1,x);
}
static STATUS hid406(){
PARSER op, hid405; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid405)(x));
return p_tok;
}
static STATUS hid407 (){
PARSER hid400, hid406;
static STATUS p_tok;
p_tok = (TOPARSER hid400) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid406) ();
}
static STATUS hid408 (){
PARSER hid393, hid407;
static STATUS p_tok;
p_tok = (TOPARSER hid393) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid407) ();
}
static STATUS hid409 (){
PARSER hid383, hid408;
static STATUS p_tok;
p_tok = (TOPARSER hid383) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid408) ();
}
STATUS testgroup(){
PARSER hid409;
return((TOPARSER hid409)());
}

static STATUS hid410(PARAM x){
return p_test0(regTable[x]==0);
}
static STATUS hid411(){
PARSER p_anything0, hid410; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER p_anything0)(),(TOPARSER hid410)(x));
return p_tok;
}
static STATUS hid412(){
PARSER hid411;
return p_hidden0n(TOPARSER hid411,0);
}
static STATUS hid413(){
PARSER hid412, opext;
return p_andparse0n (TOPARSER hid412,0,TOPARSER opext,0);
}
STATUS xS0(){
PARSER hid413;
return((TOPARSER hid413)());
}

static STATUS hid414(PARAM x){
return p_test0(regTable[x]==6);
}
static STATUS hid415(){
PARSER p_anything0, hid414; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER p_anything0)(),(TOPARSER hid414)(x));
return p_tok;
}
static STATUS hid416(){
PARSER hid415;
return p_hidden0n(TOPARSER hid415,0);
}
static STATUS hid417(){
PARSER hid416, opext;
return p_andparse0n (TOPARSER hid416,0,TOPARSER opext,0);
}
STATUS xS6(){
PARSER hid417;
return((TOPARSER hid417)());
}

static STATUS hid418(PARAM x){
return p_test0(regTable[x]==7);
}
static STATUS hid419(){
PARSER p_anything0, hid418; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER p_anything0)(),(TOPARSER hid418)(x));
return p_tok;
}
static STATUS hid420(){
PARSER hid419;
return p_hidden0n(TOPARSER hid419,0);
}
static STATUS hid421(){
PARSER hid420, opext;
return p_andparse0n (TOPARSER hid420,0,TOPARSER opext,0);
}
STATUS xS7(){
PARSER hid421;
return((TOPARSER hid421)());
}

static STATUS hid422(PARAM x1){
return p_test0(x1==155);
}
static STATUS hid423(PARAM x1,PARAM x2){
return p_test0(x2==217);
}
static VOID hid424(PARAM x1,PARAM x2){
 i_opclass=15; i_opcode=x2; prefixStack[i_psp++]=x1; 
}
static STATUS hid425(PARAM x1,PARAM x2){
PARSER p_nothing0;ACTION hid424;
return p_attach0n(TOPARSER p_nothing0,0,hid424,2,x1,x2);
}
static STATUS hid426(PARAM x1,PARAM x2){
PARSER xS6, hid425;
return p_andparse0n (TOPARSER xS6,0,TOPARSER hid425,2,x1,x2);
}
static STATUS hid427(PARAM x1,PARAM x2){
PARSER hid423, hid426;
return p_andparse0n (TOPARSER hid423,2,x1,x2,TOPARSER hid426,2,x1,x2);
}
static STATUS hid428(PARAM x1){
PARSER op, hid427; PARAM x2;
static STATUS p_tok;
P_PSTAR(x2,(TOPARSER op)(),(TOPARSER hid427)(x1,x2));
return p_tok;
}
static STATUS hid429(PARAM x1){
PARSER hid422, hid428;
return p_andparse0n (TOPARSER hid422,1,x1,TOPARSER hid428,1,x1);
}
static STATUS hid430(){
PARSER op, hid429; PARAM x1;
static STATUS p_tok;
P_PSTAR(x1,(TOPARSER op)(),(TOPARSER hid429)(x1));
return p_tok;
}
static STATUS hid431(PARAM x1){
return p_test0(x1==155);
}
static STATUS hid432(PARAM x1,PARAM x2){
return p_test0(x2==217);
}
static VOID hid433(PARAM x1,PARAM x2){
 i_opclass=15; i_opcode=x2; prefixStack[i_psp++]=x1; 
}
static STATUS hid434(PARAM x1,PARAM x2){
PARSER p_nothing0;ACTION hid433;
return p_attach0n(TOPARSER p_nothing0,0,hid433,2,x1,x2);
}
static STATUS hid435(PARAM x1,PARAM x2){
PARSER xS7, hid434;
return p_andparse0n (TOPARSER xS7,0,TOPARSER hid434,2,x1,x2);
}
static STATUS hid436(PARAM x1,PARAM x2){
PARSER hid432, hid435;
return p_andparse0n (TOPARSER hid432,2,x1,x2,TOPARSER hid435,2,x1,x2);
}
static STATUS hid437(PARAM x1){
PARSER op, hid436; PARAM x2;
static STATUS p_tok;
P_PSTAR(x2,(TOPARSER op)(),(TOPARSER hid436)(x1,x2));
return p_tok;
}
static STATUS hid438(PARAM x1){
PARSER hid431, hid437;
return p_andparse0n (TOPARSER hid431,1,x1,TOPARSER hid437,1,x1);
}
static STATUS hid439(){
PARSER op, hid438; PARAM x1;
static STATUS p_tok;
P_PSTAR(x1,(TOPARSER op)(),(TOPARSER hid438)(x1));
return p_tok;
}
static STATUS hid440(PARAM x1){
return p_test0(x1==155);
}
static STATUS hid441(PARAM x1,PARAM x2){
return p_test0(x2==219);
}
static STATUS hid442(PARAM x1,PARAM x2,PARAM x3){
return p_test0(x3==226);
}
static VOID hid443(PARAM x1,PARAM x2,PARAM x3){
 i_opclass=15; i_opcode=x2; i_mod=x3; prefixStack[i_psp++]=x1; 
}
static STATUS hid444(PARAM x1,PARAM x2,PARAM x3){
PARSER p_nothing0;ACTION hid443;
return p_attach0n(TOPARSER p_nothing0,0,hid443,3,x1,x2,x3);
}
static STATUS hid445(PARAM x1,PARAM x2,PARAM x3){
PARSER hid442, hid444;
return p_andparse0n (TOPARSER hid442,3,x1,x2,x3,TOPARSER hid444,3,x1,x2,x3);
}
static STATUS hid446(PARAM x1,PARAM x2){
PARSER op, hid445; PARAM x3;
static STATUS p_tok;
P_PSTAR(x3,(TOPARSER op)(),(TOPARSER hid445)(x1,x2,x3));
return p_tok;
}
static STATUS hid447(PARAM x1,PARAM x2){
PARSER hid441, hid446;
return p_andparse0n (TOPARSER hid441,2,x1,x2,TOPARSER hid446,2,x1,x2);
}
static STATUS hid448(PARAM x1){
PARSER op, hid447; PARAM x2;
static STATUS p_tok;
P_PSTAR(x2,(TOPARSER op)(),(TOPARSER hid447)(x1,x2));
return p_tok;
}
static STATUS hid449(PARAM x1){
PARSER hid440, hid448;
return p_andparse0n (TOPARSER hid440,1,x1,TOPARSER hid448,1,x1);
}
static STATUS hid450(){
PARSER op, hid449; PARAM x1;
static STATUS p_tok;
P_PSTAR(x1,(TOPARSER op)(),(TOPARSER hid449)(x1));
return p_tok;
}
static STATUS hid451(PARAM x1){
return p_test0(x1==155);
}
static STATUS hid452(PARAM x1,PARAM x2){
return p_test0(x2==219);
}
static STATUS hid453(PARAM x1,PARAM x2,PARAM x3){
return p_test0(x3==227);
}
static VOID hid454(PARAM x1,PARAM x2,PARAM x3){
 i_opclass=15; i_opcode=x2; i_mod=x3; prefixStack[i_psp++]=x1; 
}
static STATUS hid455(PARAM x1,PARAM x2,PARAM x3){
PARSER p_nothing0;ACTION hid454;
return p_attach0n(TOPARSER p_nothing0,0,hid454,3,x1,x2,x3);
}
static STATUS hid456(PARAM x1,PARAM x2,PARAM x3){
PARSER hid453, hid455;
return p_andparse0n (TOPARSER hid453,3,x1,x2,x3,TOPARSER hid455,3,x1,x2,x3);
}
static STATUS hid457(PARAM x1,PARAM x2){
PARSER op, hid456; PARAM x3;
static STATUS p_tok;
P_PSTAR(x3,(TOPARSER op)(),(TOPARSER hid456)(x1,x2,x3));
return p_tok;
}
static STATUS hid458(PARAM x1,PARAM x2){
PARSER hid452, hid457;
return p_andparse0n (TOPARSER hid452,2,x1,x2,TOPARSER hid457,2,x1,x2);
}
static STATUS hid459(PARAM x1){
PARSER op, hid458; PARAM x2;
static STATUS p_tok;
P_PSTAR(x2,(TOPARSER op)(),(TOPARSER hid458)(x1,x2));
return p_tok;
}
static STATUS hid460(PARAM x1){
PARSER hid451, hid459;
return p_andparse0n (TOPARSER hid451,1,x1,TOPARSER hid459,1,x1);
}
static STATUS hid461(){
PARSER op, hid460; PARAM x1;
static STATUS p_tok;
P_PSTAR(x1,(TOPARSER op)(),(TOPARSER hid460)(x1));
return p_tok;
}
static STATUS hid462(PARAM x1){
return p_test0(x1==155);
}
static STATUS hid463(PARAM x1,PARAM x2){
return p_test0(x2==221);
}
static VOID hid464(PARAM x1,PARAM x2){
 i_opclass=15; i_opcode=x2; prefixStack[i_psp++]=x1; 
}
static STATUS hid465(PARAM x1,PARAM x2){
PARSER p_nothing0;ACTION hid464;
return p_attach0n(TOPARSER p_nothing0,0,hid464,2,x1,x2);
}
static STATUS hid466(PARAM x1,PARAM x2){
PARSER xS6, hid465;
return p_andparse0n (TOPARSER xS6,0,TOPARSER hid465,2,x1,x2);
}
static STATUS hid467(PARAM x1,PARAM x2){
PARSER hid463, hid466;
return p_andparse0n (TOPARSER hid463,2,x1,x2,TOPARSER hid466,2,x1,x2);
}
static STATUS hid468(PARAM x1){
PARSER op, hid467; PARAM x2;
static STATUS p_tok;
P_PSTAR(x2,(TOPARSER op)(),(TOPARSER hid467)(x1,x2));
return p_tok;
}
static STATUS hid469(PARAM x1){
PARSER hid462, hid468;
return p_andparse0n (TOPARSER hid462,1,x1,TOPARSER hid468,1,x1);
}
static STATUS hid470(){
PARSER op, hid469; PARAM x1;
static STATUS p_tok;
P_PSTAR(x1,(TOPARSER op)(),(TOPARSER hid469)(x1));
return p_tok;
}
static STATUS hid471(PARAM x1){
return p_test0(x1==155);
}
static STATUS hid472(PARAM x1,PARAM x2){
return p_test0(x2==221);
}
static VOID hid473(PARAM x1,PARAM x2){
 i_opclass=15; i_opcode=x2; prefixStack[i_psp++]=x1; 
}
static STATUS hid474(PARAM x1,PARAM x2){
PARSER p_nothing0;ACTION hid473;
return p_attach0n(TOPARSER p_nothing0,0,hid473,2,x1,x2);
}
static STATUS hid475(PARAM x1,PARAM x2){
PARSER xS7, hid474;
return p_andparse0n (TOPARSER xS7,0,TOPARSER hid474,2,x1,x2);
}
static STATUS hid476(PARAM x1,PARAM x2){
PARSER hid472, hid475;
return p_andparse0n (TOPARSER hid472,2,x1,x2,TOPARSER hid475,2,x1,x2);
}
static STATUS hid477(PARAM x1){
PARSER op, hid476; PARAM x2;
static STATUS p_tok;
P_PSTAR(x2,(TOPARSER op)(),(TOPARSER hid476)(x1,x2));
return p_tok;
}
static STATUS hid478(PARAM x1){
PARSER hid471, hid477;
return p_andparse0n (TOPARSER hid471,1,x1,TOPARSER hid477,1,x1);
}
static STATUS hid479(){
PARSER op, hid478; PARAM x1;
static STATUS p_tok;
P_PSTAR(x1,(TOPARSER op)(),(TOPARSER hid478)(x1));
return p_tok;
}
static STATUS hid480(PARAM x1){
return p_test0(x1==155);
}
static STATUS hid481(PARAM x1,PARAM x2){
return p_test0(x2==223);
}
static STATUS hid482(PARAM x1,PARAM x2,PARAM x3){
return p_test0(x3==224);
}
static VOID hid483(PARAM x1,PARAM x2,PARAM x3){
 i_opclass=15; i_opcode=x2; i_mod=x3; prefixStack[i_psp++]=x1; 
}
static STATUS hid484(PARAM x1,PARAM x2,PARAM x3){
PARSER p_nothing0;ACTION hid483;
return p_attach0n(TOPARSER p_nothing0,0,hid483,3,x1,x2,x3);
}
static STATUS hid485(PARAM x1,PARAM x2,PARAM x3){
PARSER hid482, hid484;
return p_andparse0n (TOPARSER hid482,3,x1,x2,x3,TOPARSER hid484,3,x1,x2,x3);
}
static STATUS hid486(PARAM x1,PARAM x2){
PARSER op, hid485; PARAM x3;
static STATUS p_tok;
P_PSTAR(x3,(TOPARSER op)(),(TOPARSER hid485)(x1,x2,x3));
return p_tok;
}
static STATUS hid487(PARAM x1,PARAM x2){
PARSER hid481, hid486;
return p_andparse0n (TOPARSER hid481,2,x1,x2,TOPARSER hid486,2,x1,x2);
}
static STATUS hid488(PARAM x1){
PARSER op, hid487; PARAM x2;
static STATUS p_tok;
P_PSTAR(x2,(TOPARSER op)(),(TOPARSER hid487)(x1,x2));
return p_tok;
}
static STATUS hid489(PARAM x1){
PARSER hid480, hid488;
return p_andparse0n (TOPARSER hid480,1,x1,TOPARSER hid488,1,x1);
}
static STATUS hid490(){
PARSER op, hid489; PARAM x1;
static STATUS p_tok;
P_PSTAR(x1,(TOPARSER op)(),(TOPARSER hid489)(x1));
return p_tok;
}
static STATUS hid491(PARAM x){
return p_test0(x==155);
}
static VOID hid492(PARAM x){
 i_opclass=15; i_opcode=x; 
}
static STATUS hid493(PARAM x){
PARSER p_nothing0;ACTION hid492;
return p_attach0n(TOPARSER p_nothing0,0,hid492,1,x);
}
static STATUS hid494(PARAM x){
PARSER hid491, hid493;
return p_andparse0n (TOPARSER hid491,1,x,TOPARSER hid493,1,x);
}
static STATUS hid495(){
PARSER op, hid494; PARAM x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER op)(),(TOPARSER hid494)(x));
return p_tok;
}
static STATUS hid496 (){
PARSER hid490, hid495;
static STATUS p_tok;
p_tok = (TOPARSER hid490) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid495) ();
}
static STATUS hid497 (){
PARSER hid479, hid496;
static STATUS p_tok;
p_tok = (TOPARSER hid479) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid496) ();
}
static STATUS hid498 (){
PARSER hid470, hid497;
static STATUS p_tok;
p_tok = (TOPARSER hid470) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid497) ();
}
static STATUS hid499 (){
PARSER hid461, hid498;
static STATUS p_tok;
p_tok = (TOPARSER hid461) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid498) ();
}
static STATUS hid500 (){
PARSER hid450, hid499;
static STATUS p_tok;
p_tok = (TOPARSER hid450) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid499) ();
}
static STATUS hid501 (){
PARSER hid439, hid500;
static STATUS p_tok;
p_tok = (TOPARSER hid439) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid500) ();
}
static STATUS hid502 (){
PARSER hid430, hid501;
static STATUS p_tok;
p_tok = (TOPARSER hid430) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid501) ();
}
STATUS waitgroup(){
PARSER hid502;
return((TOPARSER hid502)());
}

static STATUS hid503(PARAM x1){
return p_test0(x1==242);
}
static STATUS hid504(PARAM x1,PARAM x2){
return p_test0(repeatgroupTable[x2]==1);
}
static VOID hid505(PARAM x1,PARAM x2){
 i_opclass=16; i_opcode=x2; prefixStack[i_psp++]=x1; 
}
static STATUS hid506(PARAM x1,PARAM x2){
PARSER p_nothing0;ACTION hid505;
return p_attach0n(TOPARSER p_nothing0,0,hid505,2,x1,x2);
}
static STATUS hid507(PARAM x1,PARAM x2){
PARSER hid504, hid506;
return p_andparse0n (TOPARSER hid504,2,x1,x2,TOPARSER hid506,2,x1,x2);
}
static STATUS hid508(PARAM x1){
PARSER op, hid507; PARAM x2;
static STATUS p_tok;
P_PSTAR(x2,(TOPARSER op)(),(TOPARSER hid507)(x1,x2));
return p_tok;
}
static STATUS hid509(PARAM x1){
PARSER hid503, hid508;
return p_andparse0n (TOPARSER hid503,1,x1,TOPARSER hid508,1,x1);
}
static STATUS hid510(){
PARSER op, hid509; PARAM x1;
static STATUS p_tok;
P_PSTAR(x1,(TOPARSER op)(),(TOPARSER hid509)(x1));
return p_tok;
}
static STATUS hid511(PARAM x1){
return p_test0(x1==243);
}
static STATUS hid512(PARAM x1,PARAM x2){
return p_test0(repeatgroupTable[x2]==1);
}
static VOID hid513(PARAM x1,PARAM x2){
 i_opclass=16; i_opcode=x2; prefixStack[i_psp++]=x1; 
}
static STATUS hid514(PARAM x1,PARAM x2){
PARSER p_nothing0;ACTION hid513;
return p_attach0n(TOPARSER p_nothing0,0,hid513,2,x1,x2);
}
static STATUS hid515(PARAM x1,PARAM x2){
PARSER hid512, hid514;
return p_andparse0n (TOPARSER hid512,2,x1,x2,TOPARSER hid514,2,x1,x2);
}
static STATUS hid516(PARAM x1){
PARSER op, hid515; PARAM x2;
static STATUS p_tok;
P_PSTAR(x2,(TOPARSER op)(),(TOPARSER hid515)(x1,x2));
return p_tok;
}
static STATUS hid517(PARAM x1){
PARSER hid511, hid516;
return p_andparse0n (TOPARSER hid511,1,x1,TOPARSER hid516,1,x1);
}
static STATUS hid518(){
PARSER op, hid517; PARAM x1;
static STATUS p_tok;
P_PSTAR(x1,(TOPARSER op)(),(TOPARSER hid517)(x1));
return p_tok;
}
static STATUS hid519(PARAM x1){
return p_test0(x1==243);
}
static STATUS hid520(PARAM x1,PARAM x2){
return p_test0(repeatgroupTable[x2]==2);
}
static VOID hid521(PARAM x1,PARAM x2){
 i_opclass=16; i_opcode=x2; prefixStack[i_psp++]=x1; 
}
static STATUS hid522(PARAM x1,PARAM x2){
PARSER p_nothing0;ACTION hid521;
return p_attach0n(TOPARSER p_nothing0,0,hid521,2,x1,x2);
}
static STATUS hid523(PARAM x1,PARAM x2){
PARSER hid520, hid522;
return p_andparse0n (TOPARSER hid520,2,x1,x2,TOPARSER hid522,2,x1,x2);
}
static STATUS hid524(PARAM x1){
PARSER op, hid523; PARAM x2;
static STATUS p_tok;
P_PSTAR(x2,(TOPARSER op)(),(TOPARSER hid523)(x1,x2));
return p_tok;
}
static STATUS hid525(PARAM x1){
PARSER hid519, hid524;
return p_andparse0n (TOPARSER hid519,1,x1,TOPARSER hid524,1,x1);
}
static STATUS hid526(){
PARSER op, hid525; PARAM x1;
static STATUS p_tok;
P_PSTAR(x1,(TOPARSER op)(),(TOPARSER hid525)(x1));
return p_tok;
}
static STATUS hid527 (){
PARSER hid518, hid526;
static STATUS p_tok;
p_tok = (TOPARSER hid518) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid526) ();
}
static STATUS hid528 (){
PARSER hid510, hid527;
static STATUS p_tok;
p_tok = (TOPARSER hid510) ();
return (GOODSTATUS(p_tok))?p_tok:(TOPARSER hid527) ();
}
STATUS repeatgroup(){
PARSER hid528;
return((TOPARSER hid528)());
}

