# include "ccx.h"

int    nextMode;	   // some role in preprocessing
int    minEntry=0;
int    newEntry=0;
int    delEntry=0;
int    newActivity=0; // newEntry or (+ delEntry)
int    saveActivity=0;
int    addedAddress=0;
int    minErase=0;
char   mname[16];

Bnode *head;	         // label data B-Tree header
int    btn;           // label data B-Tree control number
Bnode *headx;
int    btnx;
int    fsize;

int    tLc=0;
int    triedLabels[16384];	  // size increased 1998.1.9 by sangcho

int    dmc=0;
int    dmLabels[8];
int    needJump=0;
int    nsc=0;
int    needSomecare[1024];
int    fatalPosition;
int    fatalReference;

int  whyNow(int, int);
int  referCount(int);
int  (*prxntf)(const char *s,...);
int  nullxx(const char *s,...);

int  MydebugAction(BYTE);
void Disassembler();
int  SaveMap();
//void SaveBtrees();
int  LoadMap();
//void LoadBtrees();
PKEY searchBtree1(PKEY);
PKEY searchBtree2(PKEY);

extern int    imageBase;
extern int    imagebaseRVA;
extern int    lastAnchor;
extern int    delta;
extern int    i_opcode;
extern int    i_byte;
extern int    i_mod;
extern int    i_col_save;
extern int    imb;
extern int    byteaddress;
extern int    entryPoint;     // entry point of the file
extern char  *piNameBuff;	  // import module name buffer
extern char  *pfNameBuff;	  // import functions in the module name buffer
extern char  *peNameBuff;	  // export function name buffer
extern char  *pmNameBuff;     // menu name buffer
extern char  *pdNameBuff;	  // dialog name buffer
extern int    piNameBuffSize; // import module name buffer size
extern int    pfNameBuffSize; // import functions in the module name buffer	size
extern int    peNameBuffSize; // export function name buffer size
extern int    pmNameBuffSize; // menu name buffer size
extern int    pdNameBuffSize; // dialog name buffer	size

// *********************************************************
// ****************** main here ****************************
// *********************************************************

int main(argc,argv)
int argc; char **argv;
{
ACTION precc_free, precc_alloc, p_exit; 
int brk();

FILE         *my_fp;
extern int    fsize;
int           i, j, m, n, r, sr;
BYTE          c, d;
PBYTE         p, q;
_key_         k;
char          fname[16];
extern char   mname[16];

	if (argc == 2)
	{
	    strcpy(fname, argv[1]);
		strcpy(mname, fname);
		for(i=0;i<16;i++) if (fname[i]=='.'||fname[i]==0) break;
		if (fname[i]=='.')
		{ 
		   mname[i+1]='m'; mname[i+2]='a'; mname[i+3]='p'; mname[i+4]=0;
		}
		else
		{
		   mname[i+1]='.';
		   mname[i+2]='m'; mname[i+3]='a'; mname[i+4]='p'; mname[i+5]=0;
		}
		my_fp = fopen (argv[1], "rb");
	    if (my_fp == NULL) 
		{
		printf ("canNOTopenFILE: %s", argv[1]);
		exit (0);
		}
	}
	else
	{
	     printf ("usage: disassem input_file_name ");
		 exit (0);
    }

	fseek (my_fp, 0L, SEEK_END);
	fsize = ftell (my_fp);
	rewind (my_fp);

	lpFile = (void *) calloc (fsize,1);
	if (lpFile == NULL)
	{
	    printf ("canNOTallocateMEMORY");
	    exit (0);
	}

	printf ("Disassembly of File: %s\n", argv[1]);
	n = fread (lpFile, fsize, 1, my_fp);

	if (n == -1)
	{
	    printf("failed to read the FILE");
		exit (0);
	}

	// I need to connect pedump and preprocessing.
	head  = init_Btree (&btn);
	headx = init_Btree (&btnx);

	p_argc=argc;p_argv=argv;
    pedump (p_argc, p_argv);     /* put together */
	
	printf ("\n");
	//printf ("\n*************** BEGINNING OF PROCESSING  ************************** \n");
	fprintf (stderr,"\n*************** PREPROCESSING BEGINS ************************** \n");
    
	precc_alloc();               /* set data params from macros & make data */

	resetDisassembler(CodeOffset);

	nextMode = 1;       // to say now preprocessing is started.
	prxntf = nullxx;			 // I don't need printing here.

	while (yytchar!=EOF)
    {
	    Disassembler();

		if (fatalError) ErrorRecover(); 
		
		// I have to make sure there is no looping.
		// in a micro level or macro level. think BIG.... be happy.... october 27,1997
		while(1)
		{
		    r=AddressCheck(GetNextOne(lastAnchor));
			//{fprintf(stderr, "GetNextOne(lastAnchor:%08X)=%08X\n",lastAnchor,r);}
			//fprintf(stdout, "GetNextOne(lastAnchor:%08X)=%08X\n",lastAnchor,r);
			if (r==0) break;
			if (fatalError) ErrorRecover();
			if (resetDisassembler(r-imagebaseRVA+CodeOffset)) break;
		}
		if ((r==0)||(loopingBadly())) break;
	}

	if (nextMode<3)	PostProcessing();
	//TryFinally();
	if (nextMode<4) PostProcessing1();

	//printf ("\n*************** END OF PREPROCESSING **************************** ");
	if (fatalError)
	{   
	    printf("\nError=%d",fatalError);
		fatalError=0;
	}

	//printf ("\n\n*************** LABELS COLLECTED ARE: *************************** ");
	//printf ("\n");

	
	//Btree_sort(head);
	
	//SaveMap();

	LabelProcess();

	//ShowTriedLabels();
    
	//precc_free();
	//Myfinish();exit(0);
	
	printf ("\n\n+++++++++++++++++++ ASSEMBLY CODE LISTING +++++++++++++++++++");
	printf ("\n//********************** Start of Code in Object CODE **************");
	printf ("\nProgram Entry Point = %08X (%s File Offset:%08X)\n",
	        imageBase+entryPoint,argv[1],CodeOffset); 
	fprintf (stderr,"\n\n*************** LISTING BEGINS *************************** \n");

	nextMode = 0;	     // to say now preporcessing is finished.
	prxntf   = printf;
	
	resetDisassembler(CodeOffset);

	while (yytchar!=EOF)
    {
	    
		Disassembler();
		
		if(cur_position<imagebaseRVA+CodeSize)
	    fprintf(stderr,"\nmainprocessing *** error # %3d *** near :%08X\n",
	                   fatalError,cur_position);
		if(cur_position<imagebaseRVA+CodeSize)
		fprintf(stdout,"\nmainprocessing *** error # %3d *** near :%08X",
	                   fatalError,cur_position);
	    fatalError=0;
	    get1token();
	}

	Xreference();

	precc_free();                /* close files and release memory NOW */
    Myfinish();
	
	printf ("\n*************** END OF LISTING ********************************** \n");
	fprintf (stderr,"\n*************** END OF LISTING ********************************** ");
	
}
// **********************************************************************
// **************************end of main ********************************
// **********************************************************************

//
// all the functions used in the main 
//

// **************************************
// disassembler block starts here
// **************************************

int initDisassembler()
{
    yyfirsttime = 1;			 // to refresh position from the file
	yytchar = 0;
	yylineno = 0;
	passcount = 0;
	pstr = NULL;
	a_loc = 0;
	a_loc_save = 0;
	i_col = 0;
	i_col_save = 0;
	i_psp = 0;
	NumberOfBytesProcessed = -1;
	operandOveride = 0;
	addressOveride = 0;
	fatalError = 0;
	needJump=0;
	return 1;
}

int resetDisassembler(int r)
{
static   int    sr=0;
PBYTE    p, pmin;
BYTE     c;
int           i, ref;

    initDisassembler();
	vCodeOffset = r;
	vCodeSize   = CodeOffset-vCodeOffset+CodeSize;
	// have to find last Anchor here
    p    =  (PBYTE)(lpMap+r-CodeOffset);
	pmin =  toMap(imagebaseRVA);
	for(;p>pmin;p--)if ((*p&0x80)==0x80) break;
	if (p<=pmin) lastAnchor=imagebaseRVA;
	else lastAnchor = imagebaseRVA + (int)p-(int)pmin;
	delta       = vCodeOffset - CodeOffset;
	ref         = imagebaseRVA + vCodeOffset - CodeOffset;
	triedLabels[tLc++] = ref;
	// mark start position here.
	if (nextMode) *(PBYTE)(lpMap+(r-CodeOffset)) |= 0x20;	  
	cur_position = imagebaseRVA+r-CodeOffset;
	return 1;
}

int      envSave[32];
int pushEnvironment()
{
	//fprintf(stderr," %08X ", cur_position);
	fprintf(stderr,"<");
	envSave[ 0]=yyfirsttime;
	envSave[ 1]=yytchar;
	envSave[ 2]=yylineno;
	envSave[ 3]=passcount;
	envSave[ 4]=(int)pstr;
	envSave[ 5]=a_loc;
	envSave[ 6]=a_loc_save;
	envSave[ 7]=i_col;
	envSave[ 8]=i_col_save;
	envSave[ 9]=i_psp;
	envSave[10]=NumberOfBytesProcessed;
	envSave[11]=operandOveride;
    envSave[12]=addressOveride;
	envSave[13]=vCodeOffset;
	envSave[14]=vCodeSize;
	envSave[15]=lastAnchor;
	envSave[16]=delta;
	envSave[18]=cur_position;
	envSave[19]=needJump;
	envSave[20]=goteof;
	envSave[21]=(int)yyfp;
	envSave[22]=(int)yypmax;
	return 1;
}

int popEnvironment()
{
	//fprintf(stderr," %08X ", cur_position);
	fprintf(stderr,">");
	yyfirsttime	            = envSave[ 0];
	yytchar				    = envSave[ 1];
	yylineno				= envSave[ 2];
	passcount				= envSave[ 3];
	pstr		   = (TOKEN *)envSave[ 4];
	a_loc 					= envSave[ 5];
	a_loc_save 				= envSave[ 6];
	i_col 					= envSave[ 7];
	i_col_save 				= envSave[ 8];
	i_psp 					= envSave[ 9];
	NumberOfBytesProcessed 	= envSave[10];
	operandOveride 			= envSave[11];
    addressOveride 			= envSave[12];
	vCodeOffset 			= envSave[13];
	vCodeSize 				= envSave[14];
	lastAnchor 				= envSave[15];
	delta 					= envSave[16];
	cur_position 			= envSave[18];
	needJump 				= envSave[19];
	goteof                  = envSave[20];
	yyfp             = (PBYTE)envSave[21];
	yypmax           = (PBYTE)envSave[22];
	return 1;  
}

//
// the engine of this program: which uses preccx engine now.
//
void Disassembler()
{
PARSER    instruction;
status    tok;
BYTE      c;
PBYTE     p, q;
int       choice;

	fprintf(stderr,".");
	
	while (yytchar!=EOF)
    {
	    precc_begin ();           /* user defined setup stuff */

        if(!pstr)                 /* not set yet! It's the */
        {                         /* first time through */
            pstr = maxp = buffer; /* or - 1 ? */
            get1token();          // modified by sang cho
        }

        while(yytchar!=EOF)
        {
		    realignbuffer();
			addressfix();
			p = toMap(cur_position);
			c=*p;
			if (nextMode) 
			{ 
			         if (c==0x0E)     {fatalError=256;break;} 
				else if ((c&0x08)==0x08){needJump=1;    break;} 
				else if ((c&0x05)==0x05){needJump=1;    break;}  
				else if ((c&0x04)==0x04){fatalError=-2; break;}
				choice=0;
			}
			else 
			{
			          if (c==0x0E)  choice=1;   // address  
				 else if (c==0x0F)  choice=2;	// byte
				 else if (c==0x0C)  choice=3;	// CC block
			     else               choice=0;
			}
			addressprint1(choice);

			tok = instruction(choice);

			bodyprint(choice);

			if (nextMode) checkZeros();
            if (GOODSTATUS(tok)){passcount++;}
		    else {break;}
			if (fatalError) break;
			if (nextMode&&needJump)break;
		}
		if (fatalError) break;
		if (nextMode&&needJump)break;
    }
    /* go round the loop */
	
	//if (GOODSTATUS(tok)) 
	{                   
        pushEXIT;
        pc = 0;             /* program start address */
        pc = p_evaluate (); /* evaluate starts with (pc=0) */
		pc = 0;
    }
}

// **************************************************
// disassembler monitoring or surporting functions
// **************************************************

int ErrorRecover()
{
int    i, n, ref;
	//fprintf(stdout, "Error Recover %08X::code=%5d\n", cur_position, fatalError);
	//fprintf(stderr, "Error Recover %08X::code=%5d\n", cur_position, fatalError);
    
	
	     if (fatalError==256) trySomeAddress(cur_position);
	else if (fatalError==999) 
	{
	    if (i_opcode>4)	DareMe();
		eraseUncertain(cur_position);
		dmc=0;
	}
	else if (fatalError==998) 
	{
		// 1998.1.8
		
		//n = secondChance(fatalReference);
		//if (n==0)

		if ((n=secondChance(fatalReference))<1)
		{
		    eraseUncertain(fatalPosition);
		    eraseUncertain(fatalReference);
		}
		// else should give some credit.. here 
	}
	else if (fatalError==900)
	{
	    eraseLittle(cur_position);
	}
	else if (fatalError!=0) 
	{
	    eraseUncertain(cur_position);
		ref=triedLabels[tLc-1];
		if((ref+8>cur_position)&&(lastAnchor>cur_position||lastAnchor<ref)) 
		youDidIt(ref);
	}

	for(i=0;i<nsc;i++)eraseCarefully(needSomecare[i]);
	nsc=0;
	fatalError=0;
}

//
// minimum filter to check if this is code or not. 
//
int checkZeros()
{
static int opsave=-1, modsave=-1;

    if (i_opcode==0 && i_mod==0 && opsave==0 && modsave==0) fatalError=-1;
	if (i_opcode==0x90 && opsave==0 && modsave==0) fatalError=-1;
	if (i_opcode==0 && i_mod==0 && opsave==0x90) fatalError=-1;
	if (i_opcode==0 && i_mod==0 && opsave==0xC3) fatalError=-1;
	opsave=i_opcode; modsave=i_mod;
    return 1;
}

#define maxTry 16000
//
// this one is very important one. i don't know how i can handle this yet.
//
int loopingBadly()
{
	if (tLc>maxTry) return 1;
	return 0;
}

int GetNextOne(int a)
{
int   r;

    switch(nextMode)
	{
	    case 1: r=GetNextOneSimple(a);    if(r>0) return r;
		case 2: r=GetNextOneHard();       if(r>0) return r;
		case 3:	r=GetNextOneReallyHard(); if(r>0) return r;
		default: return 0;
	}
}

int GetNextOneSimple(int a)
{
int      r;
PBYTE    p, pmax;

	if (a<imagebaseRVA)          return 0;
	if (a>imagebaseRVA+CodeSize) return 0;
    
	p =    toMap(a);
	pmax = toMap(imagebaseRVA+CodeSize);
	for(;p<pmax;p++)if ((*p&0x2F)==0x20) break;
	if (p>=pmax) return 0;
	r = fromMap(p);
	return r;
}

int GetNextOneHard()
{
static PBYTE  p;
PBYTE         pmax;

	nextMode=2;
	p   =toMap(imagebaseRVA);
	pmax=toMap(imagebaseRVA+CodeSize);
	
	for(;p<pmax;p++)if ((*p&0x2F)==0x20) break;
	if (p<pmax) return fromMap(p);
	else return 0;
}

int GetNextOneReallyHard()
{
static int savecount=0;
static int s=0, ss[16]={0,}, nss=0;
int    startcount;
static PBYTE   p, pstart, pmax, psave=0;
PBYTE          q, qstart;
static BYTE    codeByte[64]={
	   0x55,0x8B,0x8D,0x83,0x56,0x53,0x8D,0x81,0x8D,0x80,0x8A,0x33,
	   //0x64,0x6A,0x66,0x68,0x50,0x51,0x52,0x57,0x58,0x54,0x40,
	   0xB8,0xB9,0xBA,0xC1,0xC7,0xD9,0xDB,0xDD,0xE8,0xE9,0x9B,0};
PKEY            pk;
_key_           k;
int             r, i, n;

	nextMode=3;
	PostProcessing();
	
	pstart=toMap(imagebaseRVA);
	pmax  =toMap(imagebaseRVA+CodeSize);
	qstart=toFile(imagebaseRVA);
	
	startcount=0; 
	// at the beginning the following condition cannot happen, but...
	p=pstart;
	newActivity=newEntry;   
	if (newActivity>saveActivity||savecount>1)
	while(p<pmax) {if ((*p&0x2F)==0x20) startcount++;p++;}
	saveActivity=newActivity;
	savecount=startcount;
	p=pstart;
	while(startcount>0&&p<pmax)
	{
		while(p<pmax) {if ((*p&0x2F)==0x20) break;p++;}
		r=fromMap(p); 
		// added 1998. 1. 9 by sang cho to avoid looping
		n=0;
		for (i=0;i<16;i++) if (r==ss[i]) n++; 
	    if (n==0) {ss[nss]=r; nss++; if (nss>15)nss=0; return r;}	 
		p++;
	}

	if (s==0||minEntry<s)
	{	p=pstart;q=qstart;r=imagebaseRVA;  }
	else { p=toMap(s); q=toFile(s); r=s;  }
	while(p<pmax)
	{
	    while((p<pmax)&&(*p&0x04)){p++;q++;r++;}
		//fprintf(stdout,"%08X::%02X>:%02X:<%02X==%02X>%02X<%02X\n",
		//        r,*(q-1),*q,*(q+1),*(p-1),(*p),*(p+1));
		if (p>=pmax) return 0;
		if (((*q)&&((*p&0x20)||strchr(codeByte,*q)))&&(r>s))
		{  s=r; minEntry=r; return r;  }
		if (*(q-2)==0xCC&&*(q-1)==0xCC&&r>s)
		{  s=r; minEntry=r; return r;  }
		else 
		{
		    k.c_ref=r; k.c_pos=0; k.class=0;
			if (referCount(r)>1) 
			{
			    if (r>s){s=r; minEntry=r; return r;}

				s=r; *p++=0x0F; q++; r++;
			}
			else
		    {   
				s=r; *p++=0x0F; q++; r++;
			}
		}

		while(p<pmax && ((*p&0x04)==0) 
		  && (*q==0||strchr(codeByte,*q)==NULL))
		{ 
		   *p=0x0F; p++; q++; r++;
		}
	}
	return 0;
}

int nextTry(int ref, int *size)
{
PBYTE           pmax = toMap(imagebaseRVA+CodeSize);
static PBYTE    p, ps, pe, q;
int             i, n, nn, nz, r;
int             cBox[256];
	
	p=toMap(ref);
	q=toFile(ref);
	while(p<pmax)
	{
	    for(i=0;i<256;i++)cBox[i]=0;
	    while(p<pmax&&((*p&0x0F)!=0x0F)){p++;q++;}
		while(p<pmax&&((*p&0x0F)==0x0F)&&(*q==0x00||*q==0x90)){p++;q++;}
	    ps=p; n=0;
	    while(p<pmax&&((*p&0x0F)==0x0F))
	    { cBox[*q] += 1; p++; q++; n++; }
	    pe=p; 
		nz=0;
	    nn=cBox[0x55]+cBox[0x8B]+cBox[0x8D]+cBox[0xE8]+cBox[0xFF];
	    for(i=0;i<0x33;i++)nz+=cBox[i];
		nz+=cBox[0xFF];
		nz-=nn+cBox[0xC3]*n+cBox[0xE9];
		if(3<n && 4*nz<3*n)
	    {
	        for(p=ps;p<pe;p++)*p=0;
	        r=fromMap(ps);
	        *size=(int)pe-(int)ps;
	        return r;
        }
		p=pe;
	}
	*size=1;
	return 0;
}

int eraseTry(int ref, int size)
{
PBYTE    pmax  =toMap(imagebaseRVA+CodeSize);
PBYTE    p, pe;
	
	p =toMap(ref);
	pe=p+size;
	while(p<pmax&&p<pe)*p++=0x0F;
	nsc=0;
	dmc=0;
	fatalError=0;
	return 1;
}

int TryFinally()
{
int      n, ref, off, size;
PBYTE    p, pe;
	
	nextMode=4;
	PostProcessing1();

	ref=nextTry(imagebaseRVA,&size);
	off=ref-imagebaseRVA+CodeOffset;
	
	//fprintf(stderr,"f ref=%08X",ref);
	if (ref==0) return 1;

	resetDisassembler(off);

	while (yytchar!=EOF)
    {
	    Disassembler();

		if (fatalError==998)
		{
		   if (!secondChance(fatalReference))eraseTry(ref,size); 
		}
		else if (fatalError) eraseTry(ref,size);

		ref=nextTry(ref+size,&size);
		off=ref-imagebaseRVA+CodeOffset;
		if (ref==0) break;
		resetDisassembler(off);
	}

	return 1;
}

int secondChance(int xref)
{
static int frefTab[4096];
static int nfrefTab=0;
int      n;
int      i, ref, off, size;
PBYTE    p, ps, pe, q;	
	
	if (xref==0) return 0;
	p=toMap(xref);
	if(*p!=0x0F)return 0;
	q=toFile(xref);
	if(*q==0x00)return 0;

	// added 1998. 1.8 by sangcho to avoid looping
	n=0;
	for	(i=0;i<nfrefTab;i++) if (frefTab[i]==fatalReference) n++;
	if(n>2) return -1;
	frefTab[nfrefTab++]=fatalReference;
	
	ps=p;
	while(*p==0x0F)p++;
	pe=p;
	p=ps;
	while(p<pe)*p++=0x00;
	
	pushEnvironment();
	off=xref-imagebaseRVA+CodeOffset;

	resetDisassembler(off);

	while (yytchar!=EOF)
    {
	    Disassembler();

		if (fatalError) 
		{
			p=ps;
			while(p<pe)*p++=0x0F;
		    popEnvironment();
			return 0;
		}
		else break;
	}
	popEnvironment();
	return 1;
}



#define TOLERANCE 0x00008000

int trySomeAddress(int r)
{
int            i,n,d,rr;
PBYTE          p, q, t;
	 
	 p=toMap(r);
	 q=toFile(r);
	 
	 n=0;
	 while((*p&0x0E)==0x0E){p++;q++;r++;}

	 fprintf(stderr,"t");
	 // I don't know why I am doing this way but somehow it makes sense.
	 for (i=0;i<CodeSize;i++)
	 {
	     d=*(int*)((int)q+4*i) - *(int*)((int)q+4*i-4); 
	     if ((-TOLERANCE < d) && (d < TOLERANCE)) 
		 {
			 if ((*(p+4*i+0)==0x00)&&(*(p+4*i+1)==0x00)&&(*(p+4*i+2)==0x00)&&(*(p+4*i+3)==0x00))
	         {
	             rr=*(int*)((int)q+4*i);
				 EnterLabel(166, rr,(r+4*i));
			     //fprintf(stderr,"address++%08X :: %08X\n",r+4*i,*(int*)((int)p+4*i));
				 //fprintf(stdout,"address++%08X\n",r+4*i);
	 	     }
			 //else fprintf(stderr,"$");
		 }
		 else break;
	 }
	 return 1;
}


int PostProcessing()
{
static int     s=0;
int            i,j,m,n;
int            c,d,r,rr;
int            cBox[256];
_key_          k;
PKEY           pk;
PBYTE          p, pmax, pstart, ps, pe;
PBYTE          q, qstart, qs, t;

    pstart=toMap(imagebaseRVA);
	pmax  =toMap(imagebaseRVA+CodeSize);
	qstart=toFile(imagebaseRVA);
    
	if (s==0||addedAddress){ p=pstart;q=qstart;	}
	else {p=pmax;}
	addedAddress=0; 
	// First check whether this is label or not.	
	while(p<pmax)
	{
	    while(p<pmax && (*p)!=0x0E)p++,q++;
		while(p<pmax && (*p)==0x0E)p++,q++;
		if (p<pmax)
		for (i=0;i<CodeSize;i++)
		{
		    d=*(int*)((int)q+4*i) - *(int*)((int)q+4*i-4);
			if ((-TOLERANCE<d) && (d<TOLERANCE))
			{
	 		     if ((*(p+4*i+0)==0x00)&&(*(p+4*i+1)==0x00)&&(*(p+4*i+2)==0x00)&&(*(p+4*i+3)==0x00))
			     {   
				     r=fromMap(p+4*i);
					 rr=*(int*)((int)q+4*i);
					 EnterLabel(166,rr,r);
				}
				 else { p=p+4*i; q=q+4*i; break; }
			}
			else { p=p+4*i; q=q+4*i; break; }
		}
		else break;
	}
	// now for CC blocks to go
	// sometimes non CC data maybe lost...beware!
	if (s==0) {p=pstart;q=qstart;}
	else {p=pmax;}
	while(p<pmax)
	{
	    while(p<pmax && (*p) >0){p++;q++;}
		while(p<pmax && (*p)==0)
		{
		    if ((*q==0xCC)&&(*(q+1)==0xCC)&&((*(q+2)==0xCC)||(*(p+2)>0)))
		    while(*q==0xCC){*p++=0x0C; q++;}
			p++; q++;
		}
	}
	// now for byte datas to go
	// I have to test some more conditions here november 2,1997 sangcho
	     if (s==0)       r=imagebaseRVA;
	else if (minErase<s) r=minErase;
	else                 r=s; 
	p=toMap(r);q=toFile(r);s=r+CodeSize;
	while(p<pmax)
	{
		while(p<pmax && (*p&0x04)){p++;q++;r++;}
		ps=p;  rr=r; 
		if ((*p)==0x20)
		{
			if (s>r) s=r;
			p++;q++;r++;
		    while(p<pmax && (*p)==0x00){p++;q++;r++;}
			continue;
		}
		for(i=0;i<256;i++)cBox[i]=0;
		m=0;
		while(p<pmax && (*p&0x04)==0)
		{
		    cBox[*q]+=1;
			p++; q++; m++; r++;
		}
		pe=p;
		if ((cBox[0xC2]+cBox[0xC3]==0) &&
	    ((cBox[0x81]+cBox[0x83]+cBox[0x89]+cBox[0x8B])*100<m))
		{
			p=ps;
			while(p<pe)
		    {  
			    *p=0x0F;
		        p++;rr++;
	        }
		}
		else if(s>rr)s=rr;
		if (m==0){p++;q++;r++;}
	}	
	fprintf(stderr,"#"); 
	minErase=s;
	return 1;
}


int PostProcessing1()
{
int      i, r, n, nn, nz, rs, re, ri, rr;
int            cBox[256];
PBYTE    pstart, pmax, p, ps, pe, pp;
PBYTE    qstart, qi, q, qs, qe, qq;

    pstart   = toMap(imagebaseRVA);
	qstart   = toFile(imagebaseRVA);
	r        = imagebaseRVA;
	pmax     = pstart+CodeSize;
	p=pmax-1;
	q=qstart+CodeSize-1;
	while(*q==0&&(*p&0x80)==0)q--,p--;
	p++;
	while(p<pmax)
	{
	    *p++=0x0F;
	}
	// I got something which is not processed yet.   
	// I'll set everything to byte data whew...
	p=pstart;
	while(p<pmax) 
	{   
	    if ((*p&0x04)==0)
	    {	*p=0x0F; p++; r++;  }
		else p++,r++;
	}
	// now i am doing something should be done.
	// i am trying to find code blocks which lies between
	// some address blocks or byte blocks which is imcomplete
	// namely, which does not have return or jmp statement.
	// so it should looks like
	// {START|address|byte}code{address|byte|END}
	// if this code block ends with C3 or C2 something or 
	// one of jmp statment it is OK
	// otherwise there is some problem.
	
	p=pstart;
	q=qstart;
	r=imagebaseRVA;
	ri=r;
	while(p<pmax)
	{
	    while(*p&0x08)
		{
		    if (*p==0x2F)
			{*p=0x0F;rr=fromMap(p);fprintf(stderr,"2F%08X",rr);}
			p++;q++;r++;
		}
	    ps=p;n=0;
	    for(i=0;i<256;i++)cBox[i]=0;
		while((*p&0x08)==0x00)
	    {   
	        if (*p&0x05==0x05){cBox[*q]+=1;n++;qi=q;ri=r;}
			p++;q++;r++;
	    }
	    pe=p;qe=q;re=r;nn=0;nz=0;
		for(i=0x41;i<0x5B;i++)nn+=cBox[i];
		for(i=0x61;i<0x7B;i++)nn+=cBox[i];
		nn+=cBox[0x00]+cBox[0x90];
		nz+=cBox[0x00]+cBox[0x01]+cBox[0x02]+cBox[0x03];
		if((nn*3>n*2)||(nz*2>n)||(n==1&&isNotGoodJump(fromMap(ps)))||
		(n<16&&(cBox[0xC2]+cBox[0xC3]==0)&&(*qi!=0xE9)&&(*qi!=0xFF)))
		{
		    p=ps;
			while(p<pe)
			{
			    if(*p&0x20)eraseSuspicious(fromMap(p));
				if(*p&0x40)break;
			    *p++=0x0F;
		    }
		}
		p=pe;q=qe;r=re;
	}

	// now for some final touch,,
	// namely clear some garbage code which clings to byte data

	p=pstart;q=qstart;r=imagebaseRVA;
	while(p<pmax)
	{
	    while((p<pmax)&&((*p&0x0F)==0x0F)){p++;q++;r++;}
		while((p<pmax)&&((*p&0x0F)!=0x0F)){p++;q++;r++;}
		if((*(p-1)&0x80)==0)
		{
		    pe=p;p--;qe=q;q--;re=r;r--;
			while((*p&0x80)==0x00&&!(*p&0x40)){p--;q--;r--;}
			if((*p&0x40)||(*p&0x0C)==0x0C){p=pe;q=qe;r=re;continue;}
			p++;q++;r++;
			while(p<pe)
			{
			    if((*p&0x0C)==0x0C){p=pe;q=qe;r=re;break;}
			    *p++=0x0F;q++;r++;
			}
		}
	}

	// now for some real final touch,,		   nov.10,1997 -sangcho-
	// namely clear some garbage code which clings hard to byte data

	p=pstart;
	q=qstart;
	r=imagebaseRVA;
	while(p<pmax)
	{
	    while((p<pmax)&&((*p&0x0F)==0x0F)){p++;q++;r++;}
	    while((p<pmax)&&((*p&0x0F)!=0x0F)){p++;q++;r++;}
		if((*(p-1)&0x80))
		{
		    pe=p;qe=q;re=r;
			p--;q--;r--;
			if((*(p-1)&0x88)==0)
			{
			    p--;q--;r--;
			    while((*p&0x88)==0&&!(*p&0x40)){p--;q--;r--;}
			    if(*p&0x40){p=pe;q=qe;r=re;continue;}
			    p++;q++;r++;
			    ps=p;n=0;
				for(i=0;i<256;i++)cBox[i]=0;
		        while((p<pe)&&((*p&0x08)==0x00))
	            {   
	                if ((*p&0x05)==0x05){cBox[*q]+=1;n++;qi=q;}
			        p++;q++;r++;
	            }
		        nz=0;
				for(i=0;i<0x33;i++)nz+=cBox[i];
				nz-=cBox[0xC3]*n+cBox[0xE9]+cBox[0xFF];
		        //nz=cBox[0x00]+cBox[0x01]+cBox[0x02]+cBox[0x03];
				if((nz*2>n)||(n==1&&isNotGoodJump(fromMap(ps))))
		        {
			        p=ps;
			        while(p<pe)
				    {
				        if(*p&0x40){p=pe;break;}
						*p++=0x0F;
		            }
			    }
		    }
			p=pe;q=qe;r=re;
		}
	}

	// now for some real final touch,,		   nov.12,1997 -sangcho-
	// namely clear some garbage code which clings hard to byte data
	// this time we need to 
	// find the code block which clings after byte data and which is dead.
	// so no outside reference is made, then you need to check out 
	// carefully what is code and what is byte,
	// so this is what i do:
	// if each instruction is in ascii character range including
	// 00 and 20 and 2A you treat them as byte data.
	// but if you find 55 then you are almost done!
	// and check if next byte is something 8B or not.
	// if it is then you are really done.
	// and convert everything between start to just before 55 to
	// byte data!

	p=pstart;
	q=qstart;
	r=imagebaseRVA;
	while(p<pmax)
	{
	    while((p<pmax)&&((*p&0x0F)!=0x0F)){p++;q++;r++;}
		while((p<pmax)&&((*p&0x0F)==0x0F)){p++;q++;r++;}
		if(*p&0x40)   continue;
		if(!(*p&0x02))continue;
		ps=p;qs=q;rs=r;
	   	while((p<pmax)&&!(*p&0x02)&&!(*p&0x80)){p++;q++;r++;}
		if(!(*p&0x02))continue;
		pe=p;qe=q;re=r;
		p=ps;q=qs;r=rs;
		while((p<pmax)&&(*q<0x80)){p++;q++;r++;}
		if((*q==0x8B)&&(*(q-1)==0x55)){pp=p-1;qq=q-1;rr=r-1;}
		else {p=pe;q=qe;r=re;continue;}
		p=ps;q=qs;r=rs;nn=0;
		while(p<pp)
		{
		    if((*p&0x20)&&referCount(r)>0)nn++;
			p++;q++;r++;
		}
		if(nn){p=pe;q=qe;r=re;continue;}
		p=ps;
		while(p<pp){*p++=0x0F;}
		p=pe;q=qe;r=re;
	}

	fprintf(stderr,"1$");
	return 1;
}

// ***************************************
// some reporting functions
// ***************************************

int ShowTriedLabels()
{
int i;

	//fprintf (stderr, "\n*************** tried labels are: ***************** ");
	fprintf (stdout, "\n*************** tried labels are: ***************** ");
	for (i=0;i<tLc;i++)
	{
		if (i % 8 == 0) fprintf(stdout,"\n");
	    fprintf(stdout, "%08X,",triedLabels[i]);
	}
}

int ReportMap()
{
int            i,j,m,n;
int            c,d,r;
PBYTE          p, pmax, pstart, psave, q, qstart;

    pstart=p=toMap(imagebaseRVA);
	pmax=p+CodeSize;
	r=imagebaseRVA;
	n=0;
	while(p<pmax)
	{
	    if(n%24==0)printf("\n%08X:",r);
		printf(" %02X",*p);
        p++;	 r++;    n++;
	}
	printf("\n");
	return 1;
}

int SaveMap()
{
PBYTE          p, pmax;
extern char    mname[];
FILE           *fp;

    fp=fopen(mname, "wb");
	p=toMap(imagebaseRVA);
	pmax=p+CodeSize;
	while(p<pmax)
	{
		fputc(*p, fp);
        p++;	 
	}
	fclose(fp);
	return 1;
}

int LoadMap()
{
PBYTE          p, pmax;
extern char    mname[];
FILE           *fp;

    fp=fopen(mname, "rb");
	p=toMap(imagebaseRVA);
	pmax=p+CodeSize;
	while(p<pmax)
	{
		*p++=fgetc(fp);
	}
	fclose(fp);
	return 1;
}


int stringCheck(int c, int ref, int pos)
{
int    n;
PBYTE  p, q, qq;

	if(pos<imagebaseRVA||pos>imagebaseRVA+CodeSize) return 1;
	q=toFile(ref);
    switch(c)
	{
	    case 512: case 513: case 1024:
		    n=strlen(q);qq=q;
			if(n>0) while(qq<q+n&&isprint(*qq))qq++;
			if (n>0&&qq==q+n) 
			{
				p=toMap(pos);
				if(*p&0x05) *p |= 0x10;
			}
		default:
	}
	return 1;
}


int labelBody(Bnode *t, int i)
{
int    c, r, rr;
PBYTE  p, pp;
    
	c=t->key[i].class;
	r=t->key[i].c_ref;
	rr=t->key[i].c_pos;
	if ((imagebaseRVA+CodeSize<r)&&(r<imageBase+maxRVA+maxRVAsize))
	return stringCheck(c, r, rr);
	p=toMap(r);	
	if (p==NULL)         return 1;
	if ((*p&0x05)!=0x05) return 1;
	pp=toMap(rr);
	if ((*p==0x0F)&&(*pp==0x0F)) return 1;
	switch(c)
	{
	    case 1: case 2:	
	        if (pp==NULL)              break;
			if (*p==0x0F) { whyNow(rr, r);  break;}  
	        if ((*p&0x20)&&(*pp&0x05)==0x05) break;
	        if (*pp&0x05) *p |= 0x20;  break;
	    case 3: case 4:
	        if (pp==NULL)              break;
			if (*p==0x0F) { whyNow(rr, r);  break;}  
			if (*p==0x0F)              break;
	        if ((*p&0x20)&&(*pp&0x05)==0x05) break;
	        if (*pp&0x05) *p |= 0x20;  break;
	    case 5: case 7: case 9:
	        if (pp==NULL)              break;
			if (*p==0x0F) { whyNow(rr, r);  break;}  
	        if ((*p&0x20)&&(*pp&0x05)==0x05) break;
	        if (*pp&0x05) *p |= 0x20;  break;
	    case 11: case 13: case 15: case 17:
	        if (pp==NULL)              break;
			if (*p==0x0F) { whyNow(rr, r);  break;}  
	        if ((*p&0x40)&&(*pp&0x05)==0x05) break;
	        if (*pp&0x05) *p |= 0x60;  break;
	    case 133:
	        break;
	    case 165: case 166:
	        if (pp==NULL)                      break;
	        if ((*p&0x20)&&(*pp&0x0E)==0x0E)   break;
	        if ((*pp&0x0E)==0x0E) *p |= 0x20;  break;
	    case 512: case 513: case 1024:
		    if (pp==NULL)              break;
			if ((*p&0x0F)==0x0F)       return stringCheck(c, r, rr);
	        break;
	    case 2048:
	        *p |= 0xE0;  break;
	    default:
	}
	return 1;
}

int labelP(Bnode *t)
{
int       i;

    if (t != NULL)
	{
	    for (i = 0; i < t->n; i++)
	    {
	        labelP(t->ptr[i]);
		    labelBody(t,i);
	    }
	labelP(t->ptr[i]);
	}
}


int LabelProcess()
{
PBYTE    p, pmax;
	// I need to recycle one bit of Map,.... november 16,1997 -sangcho-

    p=(PBYTE)lpMap; pmax=p+CodeSize;
    while(p<pmax){*p^=(*p&0xF0);p++;}
	
	labelP(head);
}

int xrefBody(Bnode *t, int i)
{
static int   sr=0, col=0;
int    c, r, rr;
PBYTE  p, pp, q;
    
	c=t->key[i].class;
	r=t->key[i].c_ref;
	rr=t->key[i].c_pos;
	p=toMap(r);	
	if (p==NULL)         return 1;
	if ((*p&0x25)!=0x25) return 1;
	if (c==1||c==2)      return 1;
	pp=toMap(rr);
	q=toFile(r);
	if (sr!=r)
	{
	    if ((*p&0x80)&&(*q!=0xC3)) 
		{
			printf("\n**%08X::",r);printExportName1(r);
			if(rr>imagebaseRVA) {printf("\n            %08X,",rr);col=1;}
			else col=7;
		}
		else if (*p&0x40)
		    {printf("\n==%08X::%08X,",r,rr);col=1;}
		else {printf("\n--%08X::%08X,",r,rr);col=1;}
	}
	else 
	{
	    if (col%7==0) printf("\n            %08X,",rr);
		else printf("%08X,",rr);           col++;
	}
	sr=r;
	return 1;
}

int xrefP(Bnode *t)
{
int       i;

    if (t != NULL)
	{
	    for (i = 0; i < t->n; i++)
	    {
	        xrefP(t->ptr[i]);
		    xrefBody(t,i);
	    }
	xrefP(t->ptr[i]);
	}
}

int Xreference()
{
    printf("\n\n*************** Cross Reference Listing ****************");
	return xrefP(head);
}


// ************************************
// main cleaning agent 
// ************************************

int eraseUncertain(int ref)
{	
PBYTE    p, s, e;
int      i, j, n, r, rr;
BYTE     c;
_key_    k;

    p=toMap(ref-1);
	for (i=0;i>imagebaseRVA-ref;i--,p--)
	if ((*p==0x00)||(*p&0x88)) break;
	// start position to erase
	s = p+1;
	p=toMap(ref);
	if (*p) { p++;}
	for (i=0;i<CodeSize+imagebaseRVA-ref;i++,p++)
	if ((*p==0x00)||(*p&0x08)||(*p&0x60))break;
	// end position to erase (before this point)
	e = p;
	// I need to do something here, delete labels generated at this point
	n = 0;  r=fromMap(s);
	for (p=s;p<e;p++,r++)
	{
	    if(*p&0x40){p=e;break;}
	    if (*p&0x10) 
		{
		    DeleteLabels(r); n++; 
		}
		// i have to take care of very bad situation here.
		if (*p&0x20)
		{
			if (referCount(r)<3)
			{
			    *p=0x00; if(minErase>r)minErase=r;
				needSomecare[nsc++]=fromMap(p);
			}
			else {subtractCount(r,1); *p=0x20;}
		}
		else { *p=0x00;	if(minErase>r)minErase=r; }
	}
	//if (e>s)
	//fprintf(stdout, "\n(%08X)eraseUncertain: %08X - %08X ... %3d labels are deleted\n",r,
	//        fromMap(s),fromMap(e),n);
	//if (e>s)
    //{fprintf(stderr, "\n(%08X)eraseUncertain: %08X - %08X ... %3d labels are deleted\n",r,
	//        fromMap(s),fromMap(e),n);getch();}
	return 1;
}

int youDidIt(int ref)
{
    return eraseCarefully(ref);
}

int eraseUncertain1(int ref)
{	
int            cBox[256];
PBYTE          p, ps, pe, pp, q;
int            i, j, n, nn, r;
BYTE           c;
_key_          k;

    p=toMap(ref-1);
	for (i=0;i>imagebaseRVA-ref;i--,p--)
	if ((*p==0x00)||(*p&0x88)) break;
	// start position to erase
	ps = p+1;
	p=toMap(ref);
	if (*p) { p++;}
	for (i=0;i<CodeSize+imagebaseRVA-ref;i++,p++)
	if ((*p==0x00)||(*p&0x08)||(*p&0x40)||((*p&0x22)==0x20))break;
	// end position to erase (before this point)
	pe = p;
	// I need to do something here, delete labels generated at this point
	n = 0;  r=fromMap(ps);
	p=ps;q=toFile(r);nn=0;
	for(i=0;i<256;i++)cBox[i]=0;
	while(p<pe)
	{
	    if(*q==0x55&&*(q+1)>0x80)break;
		cBox[*q]+=1;p++;q++;nn++;
	}
	pp=p;
	if ((cBox[0xC2]+cBox[0xC3]==0) &&
	   ((cBox[0x81]+cBox[0x83]+cBox[0x89]+cBox[0x8B])*100<nn))
	{
		p=ps;
		while(p<pp) 
		{ 
		    if (*p&0x10) {DeleteLabels(r); n++;}
			*p=0x0F; p++; r++;
		}
		while(p<pe) 
		{ 
		    if (*p&0x10) {DeleteLabels(r); n++;}
			*p=0x00; p++; r++;
		}
	}
	else 
	for (p=ps;p<pe;p++,r++)
	{
	    if(*p&0x40){p=pe;break;}
	    if (*p&0x10) { DeleteLabels(r); n++; }
		// i have to take care of very bad situation here.
		if (*p&0x20)
		{
			if (referCount(r)<3) 
			{
			    *p=0x00; if(minErase>r)minErase=r;
			}
			else {subtractCount(r,1);*p=0x20;}
		}
		else {*p=0x00; if(minErase>r)minErase=r;}
	}
	if (pe>ps)
	{
//	    r=fromMap(ps);
//fprintf(stdout, "\n@(%08X)eraseUncertain1: %08X - %08X ... %3d labels are deleted\n",r,
//	    r,fromMap(pe),n);
	}
	return 1;    
}


int eraseCarefully(int ref)
{	
int    i, n;
_key_  k;
PKEY   pk;

	//{fprintf(stdout, "\n(%08X)eraseCareFully:\n",ref);}

	if ((n=referCount(ref))==0) return 1;
	
	k.c_ref=ref; k.c_pos=0; k.class=0;
	for(i=0;i<n;i++)
	{
	    pk = searchBtree3(&k);
	    if (pk==NULL) return 1;
	    eraseUncertain1(pk->c_pos);
	}
	return 1;
}

// some bad code generated reference which is not a start position of
// my code, so i am invoking BIG action to erase whoever does that.
// i have to come up with this one. a little bit different from above.
// DeleteLabels this one may involve more labels.(very unlikely)
//                                       november 2, 1997 sangcho
int DareMe()
{
int      i;

	for(i=0;i<dmc;i++) eraseCarefully(dmLabels[i]);
	dmc=0;
	return 1;
}



int eraseLittle(int ref)
{	
PBYTE  p, s, e, pstart, pmax;
int    i, j, n, r, rr;
BYTE   c;
_key_  k;

	pstart=(PBYTE)lpMap;pmax=pstart+CodeSize;
    p=toMap(ref-1);s=NULL;
	while(p>pstart)
	{if((*p==0x00)||(*p&0x08)||(*p&0x80)||(*p&0x05)==0x05)break;p--;}
	if(*p==0||(*p&0x08)||(*p&0x80))s=p+1; 
	if(s==NULL)
	{
	// now check whether this position is secure or not.
		r=fromMap(p);
		if(isThisSecure(r)){s=toMap(ref);*(s-1)|=0x80;}
	}
	rr=r;
	while(s==NULL)
	{
		while(p>pstart)
		{if((*p==0x00)||(*p&0x08)||(*p&0x80)||(*p&0x05)==0x05)break;p--;}
		if(*p==0||(*p&0x80)||(*p&0x08)){s=p+1;break;}
		r=fromMap(p);
		if(isThisSecure(r)){s=toMap(rr);*(s-1)|=0x80;break;}
		if(r==rr){p--;}else rr=r;
	}
	// now I need to set e to the point with 0x40
	p=toMap(ref);
	while(p<pmax){if(*p&0x40)break;p++;}
	e=p;
	// I need to do something here, delete labels generated at this point
	n = 0;
	for (p=s;p<e;p++)
	{
		r=fromMap(p);
	    if (*p&0x10) 
		{
		    DeleteLabels(r); n++; 
		}
		// i have to take care of very bad situation here.
		if (*p&0x20)
		{
			if (referCount(r)<3) 
			{
			    *p=0x00;
			}
			else {subtractCount(r,1); *p=0x20;}
		}
		else *p=0x00;
	}
	//if (e>s)
	//fprintf(stdout, "\n==(%08X)eraseLittle: %08X - %08X ... %3d labels are deleted\n",
	//                 r,fromMap(s),fromMap(e),n);
	return 1;    
}


int whyNow(int pos, int ref)
{	
PBYTE  p, s, e;
int    i, j, n, r;
BYTE   c;
_key_  k;

    if (secondChance(ref)) return 1;
	//fprintf(stderr, ":%08X>%08X ",pos, ref);
	//fprintf(stdout, ":%08X>%08X ",pos, ref);
	return 1;    
}


int eraseSuspicious1(int ref)
{	
PBYTE  p, s, e;
int    i, j, n, r;
BYTE   c;
_key_  k;

    p=toMap(ref-1);
	for (i=0;i>imagebaseRVA-ref;i--,p--)
	if ((*p&0x08)||!(*p&0x02)) break;
	// start position to erase
	s = p+1;
	p=toMap(ref);
	if (!(*p&0x08)&&(*p&0x02)) { p++;}
	for (i=0;i<CodeSize-ref+imagebaseRVA;i++,p++)
	if ((*p&0x08)||!(*p&0x02))break;
	// end position to erase (before this point)
	e = p;
	// I need to do something here, delete labels generated at this point
	n = 0;
	for (p=s;p<e;p++)
	{
	    r=fromMap(p);
	    if (*p&0x10) DeleteLabels(r);  
		*p=0x0F;
	}
	return 1;    
}

int eraseSuspicious(int ref)
{
int    i, n, r;
_key_  k;
PKEY   pk;

	//{fprintf(stderr, "\n(%08X)eraseCareFully:\n",ref);getch();}
	if ((n=referCount(ref))==0) return 1;
	
	k.c_ref=ref; k.c_pos=0; k.class=0;
	for(i=0;i<n;i++)
	{
	    pk = searchBtree3(&k);
	    if (pk==NULL) return 1;
		r=pk->c_pos;
	    eraseSuspicious1(r);
	}
	return 1;
}


// *******************************************
// label handling functions
// *******************************************

int BadEnter(PBYTE p, int ref, int pos)
{
static BYTE    mapByte[32]={
	   0x05,0x07,0x15,0x17,0x20,0x25,0x27,0x87,
	   0x35,0x37,0x40,0x45,0x47,0x55,0x60,0x85,
	   0x65,0x75,0xA5,0xA7,0xA0,0xB5,0xB7,0x00};

	if(strchr(mapByte,*p)!=NULL) return 0;
	fprintf(stderr,"%02X",*p);
	//fprintf(stdout,"%02X:pos=%08X:ref=%08X:",*p,pos,ref);
	fatalPosition=pos;
	fatalReference=ref;
	fatalError=998;
	return 1;
}

//=================================================================================
// I need to describe the intended usage of _key_ and its fields.
// as you can see the _key_ structure consists of three fields
//  _key_ ::= class,  c_pos, c_ref
// class tells what kind of reference we are dealing with
// the table shows:
//---------------------------------------------------------------------------------
//  class of reference  | unconditional(jump or call)  |  conditional jump	      |
// --------------------------------------------------------------------------------
// Jmp  Short Rel Disp  |                1             |               2          |
// Jmp  Near  Rel Disp  |                3             |               4          |
// Jmp  Near  Abs Indir |                5             |              ***         |
// Jmp  Far   Absolute  |                7             |              ***         |
// Jmp  Far   Abs Indir | 			     9             |              ***         |
// Call Near  Rel Disp  |               11             |              ***         |
// Call Near  Abs Indir |               13             |              ***         |
// Call Far   Absolute  |               15             |              ***         |
// Call Far   Abs Indir |               17             |              ***         |
//---------------------------------------------------------------------------------
// Jmp indirect address holding place                                 133         |
// the reference which is pointed by above address                    165         |
// the reference which is adjacent to above 165                       166         |
// the possible reference by   --  push dword                         512         |
// the possible reference by   --  push [reg or mem]                  513         | 
// the possible reference by   --  mov [reg or mem], dword           1024         |
// the definitive reference by export function block                 2048         |
//---------------------------------------------------------------------------------

//=================================================================================
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// this one tell what is lpMap and its intended usage...
//-------------------------------------------------------------------//
//																	 //
// I can use lpMap (code check buffer?)								 //
//-------------------------------------------------------------------//
//       0x00: unprocessed                                           //
//       0x01: starting position of instruction  (masked)            //
//       0x02: gray mark(suspicious code)        (masked)            //
//       0x04: processed instructions            (masked)            //
//       0x08: data(address, byte, CC block)     (no masking)        //
//             0x0C: cc block                      "                 //
//             0x0E: address                       "                 //
//             0x0F: byte                          "                 //
//       0x10: label generated here              (masked)            //
//       0x20: start point set                   (masked)            //
//       0x40: entry or not                      (masked)            //
//       0x80: anchor set                        (masked)            //
//-------------------------------------------------------------------//

// this function tries to record all the possible entries and labels
// and data references we can find and decipher. 
int EnterLabel(int class, int ref, int pos)
{
int            r, rr, d;
_key_          k;
PKEY           pk;
int           *q;
PBYTE          p;

	//{fprintf(stderr,"EnterLabel::class=%5dX,ref=%08X\n",class,ref);getch();}

	if (ref<imagebaseRVA) return 0;
	if (!AddressCheck(pos)) return 0;
	if (ref<imagebaseRVA+CodeSize) 
	{
		switch(class)
		{
		    case 1: case 2: case 3: case 4: case 7: case 11: case 15: case 165: 
			     k.class = class;
				 k.c_pos = pos;
				 k.c_ref = ref;
		         MyBtreeInsert(&k);
				 k.class = -class;
				 k.c_pos = ref;
				 k.c_ref = pos;
				 p = toMap(ref);
				 MyBtreeInsert(&k);  // we can use this .. for erase uncertain case.
				 if (BadEnter(p,ref,pos)) break;
				 if (!(*p&0x20)) 
				 {if (minEntry>ref) minEntry=ref; newEntry++; *p |= 0x20;}	 
				 p = toMap(pos);
				 *p |= 0x10;
				 break;
			case 166: 
			// mark that address data
			     p = toMap(pos);    addedAddress++;
				 *p = 0x0E; *(p+1) = 0x0E; *(p+2) = 0x0E; *(p+3) = 0x0E; 
			     k.class = class;
				 k.c_pos = pos;
				 k.c_ref = ref;
				 MyBtreeInsert(&k);
				 k.class = -class;
                 k.c_pos = ref;
                 k.c_ref = pos;		// we can use this .. for erase uncertain case.
                 MyBtreeInsert(&k);	
				 p=toMap(ref);				 
				 if (BadEnter(p,ref,pos)) break;
				 if (!(*p&0x20)) 
				 {if (minEntry>ref) minEntry=ref; newEntry++; *p |= 0x20;}	
				 break;
			case 512: case 513:	case 1024:
			     k.class = class;
				 k.c_pos = pos;
			     k.c_ref = ref;
				 MyBtreeInsert(&k);
				 k.class = -class;
				 k.c_pos = ref;
				 k.c_ref = pos;		// we can use this .. for erase uncertain case.
				 MyBtreeInsert(&k);
				 break;
//-------------------------------------------------------------------//
// now it is indirect address reference and we need to take some	 //
// serious actions, namely if it is preventable than it is OK		 //
// but if bad deed is already done we need to UNDO it.				 //
// this requires couple of things.									 //
// first we need to store indirect references in some convenient way //
// and every time we need to check whether we touch it or not.		 //
// second we need to store all the anchors and start positions		 //
// so we can easily determine how much we need to UNDO.				 //
//                          october 24, 1997 late night-- sang cho	 //
//-------------------------------------------------------------------//
			case 5: case 9: case 13: case 17: case 133: 
			// mark that address data
			     if (ref<pos+4) { eraseUncertain(ref); break; }
				 
			     p = toMap(ref);   addedAddress++;
				 *p = 0x0E; *(p+1) = 0x0E; *(p+2) = 0x0E; *(p+3) = 0x0E; 
			     k.class = class;
				 k.c_pos = pos;
				 k.c_ref = ref;
				 MyBtreeInsert(&k);
				 k.class = -class;
				 k.c_pos = ref;
				 k.c_ref = pos;
				 MyBtreeInsert(&k);	   // we can use this .. for erase uncertain case.
				 p = toMap(pos);
				 *p |= 0x10;
			// I am forming chain of label references.
			// also new class is defined here.
			     r = Get32Address(ref);
				 if (r>0)
				 {
				     k.class = class + 32;
				     k.c_pos = ref;
					 k.c_ref = r;
					 if (AddressCheck(r))
					 {
					     p = toMap(r);
					     MyBtreeInsert(&k);
				         if (BadEnter(p,r,pos)) break;
				     	 if (!(*p&0x20)) 
				         {if (minEntry>r) minEntry=r; newEntry++; *p |= 0x20;}	
					 }
				 }
					break;
			// I need to UNDO that bad deed, I once did.
			// but this one is in the middle of printing really something untouchable,
			// so what should I do, can I preempt it and proceed what I have to do?
			// well... if I am more careful I think I can do that.
			// OK this is fixed now, I can progress as I wished.   october 25, 1997
			// the following code is move to above position....^^^^^.....
			//if (ref<pos+4) { eraseUncertain(ref); break; }

		    default:
		}
	}
 //
 // if reference is out of code range what can I do?
 // I have to think about it a while, meantime I'll just 
 // do the thing I can do.
 //
	else
	{
		switch(class)
		{
		    case 3: case 4:
			     fatalError=950;
				 break;
			case 7: case 11: case 15: case 165:	
			     r = Get32Address(ref);
				 if (r>0)
				 {
                     k.class = class;
                     k.c_pos = pos;
                     k.c_ref = r;
                     MyBtreeInsert(&k);
                     k.class = -class;
                     k.c_pos = r;
                     k.c_ref = pos;
                     MyBtreeInsert(&k);	// we can use this .. for erase uncertain case.
				 }
				 break;
			case 166: 
			// mark that address data
			     p = toMap(pos);     addedAddress++;
				 *p = 0x0E; *(p+1) = 0x0E; *(p+2) = 0x0E; *(p+3) = 0x0E; 
			     k.class = class;
				 k.c_pos = pos;
				 k.c_ref = ref;
				 MyBtreeInsert(&k);
				 k.class = -class;
                 k.c_pos = ref;
                 k.c_ref = pos;		// we can use this .. for erase uncertain case.
                 MyBtreeInsert(&k);	
				 break;
			case 512: case 513: case 1024:
				 {
                     k.class = class;
                     k.c_pos = pos;
                     k.c_ref = ref;
                     MyBtreeInsert(&k);
                     k.class = -class;
                     k.c_pos = ref;
                     k.c_ref = pos;
                     MyBtreeInsert(&k);	// we can use this .. for erase uncertain case.
				 }
				 break;
			case 5: case 9: case 13: case 17: case 133: 
			// mark that address data
				 r = Get32Address(ref);
				 if (r>0)
				 {
				     k.class = class;
				     k.c_pos = pos;
				     k.c_ref = r;
				     MyBtreeInsert(&k);
				     k.class = -class;
				     k.c_pos = r;
				     k.c_ref = pos;
	       	         MyBtreeInsert(&k);	// we can use this .. for erase uncertain case.
			// I am forming chain of label references.
			// also new class is defined here.
			         rr = Get32Address(r);
				     if (rr>0)
				     {
				         k.class = class + 32;
				         k.c_pos = r;
				         k.c_ref = rr;
				         MyBtreeInsert(&k);
				     }
				 }
			default:
		}
	}
}

// this is inverse of EnterLabel, but... who knows!
int DeleteLabels(int ref)
{
int            r, rr;
_key_          k, k1, k2, k3, k4;
PKEY           pk;
PBYTE          p;

	//{fprintf(stderr, "(%08X)DeleteLabels:\n",ref);getch();}
	// this is very tricky.. i need to be extremely careful. oct.29,1997sangcho
	k.c_ref=ref; k.c_pos=0; k.class=0;
	pk = searchBtree1(&k);
	if(pk==NULL) return 1;    
    k1=*pk;   
	k.class=-k1.class; k.c_pos=k1.c_ref; k.c_ref=k1.c_pos;
	pk = searchBtree1(&k);
	if(pk==NULL) return 1; 
	k2=*pk;
	if(k2.class==133 || k2.class==5 || k2.class==9 || k2.class==13 || k2.class==17)
	{
	    r=Get32Address(k2.c_ref);
		rr=Get32Address(r);
		if (r>0)
		{
		    k3.class = k2.class + 32;
			k3.c_pos = k2.c_ref;
			k3.c_ref = r;
			// now we have to delete k3
			if (MyBtreeDelete(&k3)==0)
			{
			    p=toMap(k3.c_ref);
		        if ((*p)&0x20) 
				{
					*p^=0x20; delEntry++;
				}
		    }
		}
	}
	else if(MyBtreeDelete(&k2)==0)
	{
	    p=toMap(k2.c_ref);
		if ((*p)&0x20) 
		{
			*p^=0x20;
		}
	}
	// we have to delete k1 and k2
	MyBtreeDelete(&k1);
	//fprintf(stdout,"deleted label==%5d::%08X<<%08X\n",k2.class,k2.c_ref,k2.c_pos);
	return 1;
}


// **********************************************
// address checking or getactual address. etc...
// **********************************************

int isGoodAddress(int ref)
{
int    d;

   d=ref-cur_position; 
   if ((imagebaseRVA<ref)&&(ref<imagebaseRVA+CodeSize)
       &&(-TOLERANCE<d && d<TOLERANCE))
   return 1; else return 0;
}

int AddressCheck(int ref)
{
    if (ref<imagebaseRVA) return 0;
	if (ref<imagebaseRVA+CodeSize) return ref;
	if (ref<imageBase+maxRVA+maxRVAsize) return ref;
	return 0;
}

int Get32Address(int ref)
{
int   r;

    if (ref<imagebaseRVA) return 0;
	if (ref<imagebaseRVA+CodeSize) 
	return AddressCheck(*(int *)((int)lpFile+ref-imagebaseRVA+CodeOffset));
	r=(int)GetActualAddress(lpFile, ref-imageBase);
	return (*(int *)(r));
}

int isThisSecure(int ref)
{
_key_   k;
PKEY    pk;
BYTE    b=*toFile(ref);
BYTE    c=*toMap(ref);
int     r, n;

    if (b==0xC3) return 1; 
	if (!(c&0x10)) return 0;
	if (b==0xE9||b==0xFF||b==0xEB)
	{
	    k.class=0;k.c_ref=ref;k.c_pos=0;
		pk=searchBtree1(&k);
		r=pk->c_pos;
		if(!AddressCheck(r))
		{
		    k.c_ref=r;k.c_pos=0;k.class=0;
		    pk=searchBtree1(&k);
			if(pk==NULL)return 0;
			else return 1;
		}
		n=referCount(r);
		if(n>1)return 1;
		if(n>0&&(b==0xE9||b==0xFF))return 1;
		if(n>0&&r<imagebaseRVA+CodeSize&&(*toMap(r)&0x60))return 1;
	}
	return 0;
}


int isNotGoodJump(int ref)
{
_key_   k;
PKEY    pk;
BYTE    b=*toFile(ref);
int     r;

    if (b==0xC3) return 0;
	if (b==0xC2) return 0;
	if (b==0xE9||b==0xFF)
	{
	    k.class=0;k.c_ref=ref;k.c_pos=0;
		pk=searchBtree1(&k);
		r=pk->c_pos;
		if(!AddressCheck(r))
		{
		    k.c_ref=r;k.c_pos=0;k.class=0;
		    pk=searchBtree1(&k);
			if(pk==NULL)return 1;
			else return 0;
		}
		if(r<imagebaseRVA+CodeSize&&(*toMap(r)&0x20))return 0;
		if(r>imagebaseRVA+CodeSize&&referCount(r)>0)return 0;
	}
	return 1;
}

PBYTE toMap(int ref)
{ 
    if(ref<imagebaseRVA) return NULL;
	if(ref>imagebaseRVA+CodeSize) return NULL;
	return (PBYTE)(ref-imagebaseRVA+(int)lpMap);
}

PBYTE toFile(int ref)
{ 
    if(ref<imagebaseRVA) return NULL;
	if(ref>imagebaseRVA+fsize) return NULL;
	if (ref<imagebaseRVA+CodeSize)
	return (PBYTE)(ref-imagebaseRVA+(int)lpFile+CodeOffset);
	return (PBYTE)GetActualAddress(lpFile,ref-imageBase);
}

int fromMap(PBYTE p)
{ 
    return (int)p-(int)lpMap+imagebaseRVA; 
}

int fromFile(PBYTE p)
{ 
    return (int)p-(int)lpFile-CodeOffset+imagebaseRVA; 
}

//
// I cannot actually compute m16:m32 far address value
// so I will only record m32 part of it, hope it actually works.
//
int Get16_32Address(int ref)
{
    return Get32Address(ref);
}

// *************************************
// miscellaneous functions
// *************************************

int Myfinish()
{
    free ((void *)piNameBuff);
	free ((void *)peNameBuff);
	free ((void *)lpFile);
	free ((void *)lpMap);
	Btree_deleteall(head, &btn);
	Btree_deleteall(headx,&btnx);
	exit(0);
}


int  nullxx(const char *s,...)
{
    return 1;
}

// =============================================================
// I am using two B-trees namely head and headx.
// the reason to do so is as follows:
//
// head tree contains reference and position pair plus class
//
// where reference:the position called, jumped, etc.
//		 position: where above reference is made.
//		 class:    the kind of reference. (explained in EnterLabel)
//
// headx tree contains the reversed pair of above pair plus -class
// so i can trace which reference i am looking for.
// besides that i use headx for some other purposes, like
// keep count of reference: which is weighted for some reason i guess.
// the bigger the count is it is safe to keep this reference.
// when some volatile situation occurs i will consult this reference
// count. whenever new reference is made the count is updated.
// namely increased or decreased.
//
// for reference count i use c_pos for jump count and 
//							 class for call count
//                           c_ref is highest bit set to 1....
//
//                           november 5,1997   --sangcho--
/*  *******************************************************  */
/*  BTREEI.C  :                                              */
/*                  Programmed By Lee jaekyu                 */
/*                  modified by sangcho--october 22,1997     */
/*                  modified by sangcho--november 5,1997     */
/*  *******************************************************  */
int EQ(PKEY p, PKEY q)
{
    if (p->class>0)
	{
	    if ((p->c_ref==q->c_ref)&&(p->c_pos==q->c_pos)) return 1; 
		else return 0;
    }
	if (p->c_ref==q->c_ref) return 1;
	return 0;
}

int GE(PKEY p, PKEY q)
{
    if (p->class>0)
	{
        if (p->c_ref>q->c_ref) return 1;
	    else if ((p->c_ref==q->c_ref)&&(p->c_pos >= q->c_pos)) return 1; 
	    return 0;
    }
	if (p->c_ref >= q->c_ref) return 1;
	return 0;
}

int GT(PKEY p, PKEY q)
{
    if (p->class>0)
	{
	    if (p->c_ref>q->c_ref) return 1;
	    else if ((p->c_ref==q->c_ref)&&(p->c_pos > q->c_pos)) return 1; 
	    return 0;
    }
	if (p->c_ref > q->c_ref) return 1;
	return 0;
}

int LE(PKEY p, PKEY q)
{
    if (p->class>0)
	{
        if (p->c_ref < q->c_ref) return 1;
	    else if ((p->c_ref==q->c_ref)&&(p->c_pos <= q->c_pos)) return 1; 
	    return 0;
    }
	if (p->c_ref <= q->c_ref) return 1;
	return 0;
}

int LT(PKEY p, PKEY q)
{
    if (p->class>0)
	{
	    if (p->c_ref < q->c_ref) return 1;
	    else if ((p->c_ref==q->c_ref)&&(p->c_pos < q->c_pos)) return 1; 
	    return 0;
    }
	if (p->c_ref < q->c_ref) return 1;
	return 0;
}

// modified november 2,1997 sangcho i really hope this will work.
// modified november 5,1997 sangcho............same..............

PKEY searchBtree1(PKEY k)
{
Bnode *t;
int i; 
	if (k->class>0)
	     t=Btree_search(k, head, &btn);
	else t=Btree_search(k, headx, &btnx);
	if (t==NULL) return NULL;
	for (i=0;i<t->n;i++)
	if (EQ(k, &(t->key[i]))) return &(t->key[i]);
	return NULL;
}

PKEY searchBtree21(Bnode *t, PKEY k)
{
int i, c, r;
PKEY   p;
	p = NULL;
    if (t != NULL)
	{
	    for (i = 0; i < t->n; i++)
	    {
		    if (p = searchBtree21(t->ptr[i], k)) return p;
			c=t->key[i].class; r=t->key[i].c_ref;
			if (((c==3)||(c==4)||(c==11)||(c==165)||(c==166))
			    &&(r==k->c_ref))
		    return &(t->key[i]);
	    }
		if (p = searchBtree21(t->ptr[i], k)) return p;
	}
	return p;
}

PKEY searchBtree2(PKEY k)
{
    if (k->class>0)
	     return searchBtree21(head, k);
    else return searchBtree21(headx,k);
}


PKEY searchBtree31(Bnode *t, PKEY k)
{
int i, c, r;
PKEY   p;
	p = NULL;
    if (t != NULL)
	{
	    for (i = 0; i < t->n; i++)
	    {
		    if (p = searchBtree31(t->ptr[i], k)) return p;
			c=t->key[i].class; r=t->key[i].c_ref;
			if (((c < 5)||(c==11)||(c==165)||(c==166))
			    &&(r==k->c_ref))
		    return &(t->key[i]);
	    }
		if (p = searchBtree31(t->ptr[i], k)) return p;
	}
	return p;
}

PKEY searchBtree3(PKEY k)
{
    return searchBtree31(head, k);
}

int  referCount(int ref)
{
_key_  k;
Bnode *t;
int i;
    k.class=0; k.c_ref=ref; k.c_pos=0;
	k.c_ref |= 0x80000000;
	t=Btree_search(&k, headx, &btnx);
	if (t==NULL)return 0;
	for (i=0;i<t->n;i++)
	if (EQ(&k, &(t->key[i]))) break;
	if (t==NULL)return 0;
	return t->key[i].class + t->key[i].c_pos;
}


int  addCount(int ref, int class)
{
_key_  k;
Bnode *t;
int i;
    k.class=0; k.c_ref=ref; k.c_pos=0;
	k.c_ref |= 0x80000000;
	t=Btree_search(&k, headx, &btnx);
	if (t==NULL) t=Btree_insert(&k, headx, &btnx);
	if (t==NULL)return 0;
	for (i=0;i<t->n;i++)
	if (EQ(&k, &(t->key[i]))) break;
	if (t==NULL)return 0;
	switch(class)
	{
	    case 1: case 2:
			t->key[i].c_pos += 1;
			break;
		case 3: case 4: case 7: case 165: case 166:
		    t->key[i].c_pos += 256;
			break;
		case 11: case 15:
		    t->key[i].class += 1;
			break;
		default:
	}
	return t->key[i].class + t->key[i].c_pos;
}

int  subtractCount(int ref, int class)
{
int    c;
_key_  k;
Bnode *t;
int i; 
    k.class=0; k.c_ref=ref; k.c_pos=0;
	k.c_ref |= 0x80000000;
	t=Btree_search(&k, headx, &btnx);
	if (t==NULL)return 0;
	for (i=0;i<t->n;i++)
	if (EQ(&k, &(t->key[i]))) break;
	if (t==NULL)return 0;
	switch(class)
	{
	    case 1: case 2:
			t->key[i].c_pos -= 1;
			break;
		case 3: case 4: case 5: case 165: case 166:
		    t->key[i].c_pos -= 256;
			break;
		case 11: case 13:
		    t->key[i].class -= 1;
			break;
		default:
	}
	if (t->key[i].c_pos < 0) t->key[i].c_pos = 0;
	if (t->key[i].class < 0) t->key[i].class = 0;
	c=t->key[i].class + t->key[i].c_pos;
	if (c==0)
	{
	    Btree_delete(&k, headx, &btnx);
	    return 0;
	}
	return c;
}

int  MyBtreeInsert(PKEY k)
{
Bnode *b;
    if (k->class>0)
	{
		if (searchBtree1(k)) return 0;	// already exist
		else Btree_insert(k, head, &btn);
		return addCount(k->c_ref, k->class);
    }
	else if (Btree_insert(k, headx, &btnx)) return 1;
	else return 0;
}

int  MyBtreeInsertEx(PKEY k)
{
_key_     key;
	Btree_insert(k, head, &btn);
	key.class=256; key.c_ref=k->c_ref; key.c_pos=256*256;
	key.c_ref |= 0x80000000;
	Btree_insert(&key, headx, &btnx);
	return 1;
}

// i can refuse to be deleted provied that reference count is big enough.
int  MyBtreeDelete(PKEY k)
{
Bnode *b;
	if (k->class>0)
	{
	     if (searchBtree1(k))  
		 {
		     Btree_delete(k, head, &btn);
			 return subtractCount(k->c_ref,k->class);
		     //return 0;
		 }
		 else return 0;
	}
    else Btree_delete(k, headx, &btnx);
	return 0;
}

Bnode *init_Btree(int *num)
{
Bnode *head;
    head = (Bnode*)calloc(sizeof(Bnode),1);
    head->ptr[0] = NULL;
    head->n = 0;
    *num = 0;
	return head;
}

int in_Bnode(PKEY pkey, Bnode *t)
{
int i;
    for (i = 0; i < t->n; i++)
	if (EQ(pkey, &(t->key[i]))) return i;
    return -1;
}

Bnode *Btree_search(PKEY pkey, Bnode *base, int *num)
{
Bnode *t;
int i;
    t = base->ptr[0];
    while (t != NULL && in_Bnode(pkey, t) == -1)
	{
	for (i = 0; i < t->n && GE(pkey, &(t->key[i])); i++);
	t = t->ptr[i];
	}
    return t;
}

void insert_key(Bnode *t, PKEY pkey, Bnode *left, Bnode *right)
{
int i;
    i = t->n;
    while (LT(pkey, &(t->key[i-1])) && i > 0)
	{
	t->key[i] = t->key[i-1];
	t->ptr[i+1] = t->ptr[i];
	i--;
	}
    t->n++;
    t->key[i] = *pkey;
    t->ptr[i] = left;
    t->ptr[i+1] = right;
}

Bnode *split(PKEY pkey, Bnode *pivot, Bnode *base)
{
Bnode *left, *right;
Bnode *child;
int i;
    if ((right = (Bnode*)calloc(sizeof(Bnode),1)) == NULL) return NULL;
    if (pivot == base)
	{
	child = pivot->ptr[0];
	if ((left = (Bnode*)calloc(sizeof(Bnode),1)) == NULL) return NULL;
	for (i = 0; i < M; i++)   /* left node create */
	    {
	    left->key[i] = child->key[i];
	    left->ptr[i] = child->ptr[i];
	    }
	left->ptr[i] = child->ptr[i];
	left->n = M;
	for (i = M+1; i < MM; i++)  /* right node create */
	    {
	    right->key[i-M-1] = child->key[i];
	    right->ptr[i-M-1] = child->ptr[i];
	    }
	right->ptr[i-M-1] = child->ptr[i];
	right->n = M;

	child->n = 0;   /* root node create */
	insert_key(child, &(child->key[M]), left, right);
	}
    else
	{
	for (i = 0; i < pivot->n && GE(pkey, &(pivot->key[i])); i++);
	left = pivot->ptr[i];
	left->n = M;  /* left already created */
	for (i = M+1; i < MM; i++)  /* right node create */
	    {
	    right->key[i-M-1] = left->key[i];
	    right->ptr[i-M-1] = left->ptr[i];
	    }
	right->ptr[i-M-1] = left->ptr[i];
	right->n = M;

	insert_key(pivot, &(left->key[M]), left, right);  /* pivot update */
	child = pivot;
	}
    return child;
}

Bnode *Btree_insert(PKEY pkey, Bnode *base, int *num)
{
Bnode *t, *parent;
int i;
    parent = base;
    t = base->ptr[0];
    if (t == NULL)
	{
	if ((t = (Bnode*)calloc(sizeof(Bnode),1)) == NULL) return NULL;
	t->n = 0;
	t->ptr[0] = NULL;
	base->ptr[0] = t;
	}
    while (t != NULL)
	{
	if (in_Bnode(pkey, t) >= 0) return NULL;  /* equal key */
	if (t->n == MM)
	    {
	    t = split(pkey, parent, base);
	    if (t == NULL) return NULL;
	    }
	parent = t;
	for (i = 0; i < t->n && GE(pkey, &(t->key[i])); i++);
	t = t->ptr[i];
	}
    insert_key(parent, pkey, NULL, NULL);
    (*num)++;
    return parent;
}

void delete_key(Bnode *t, int index)
{
int i;
    for (i = index+1; i < t->n; i++)
	{
	t->key[i-1] = t->key[i];
	t->ptr[i-1] = t->ptr[i];
	}
    t->ptr[i-1] = t->ptr[i];
    t->n--;
}

int borrow_key(Bnode *p, int index)
{
int from, to;
Bnode *p1, *p2;
    if (index == p->n)
	{  /* right most */
	from = index-1;
	to = index;
	}
    else
	{
	from = index+1;
	to = index;
	}
    p1 = p->ptr[from];
    p2 = p->ptr[to];
    if (p1->n <= M) return 0;
    if (from > to)
	{
	insert_key(p2, &(p->key[to]), p2->ptr[p2->n], p1->ptr[0]);
	p->key[to] = p1->key[0];
	delete_key(p1, 0);
	}
    else
	{
	insert_key(p2, &(p->key[from]), p1->ptr[p1->n], p2->ptr[0]);
	p->key[from] = p1->key[p1->n - 1];
	delete_key(p1, p1->n - 1);
	}
    return 1;
}

Bnode *bind_node(Bnode *p, int index, Bnode *base)
{
Bnode *left, *right;
int i;
    if (index == p->n) index--;
    left = p->ptr[index];
    right = p->ptr[index+1];
    left->key[left->n++] = p->key[index];
    for (i = 0; i < right->n; i++)
	{
	left->key[left->n] = right->key[i];
	left->ptr[left->n++] = right->ptr[i];
	}
    left->ptr[left->n] = right->ptr[i];
    delete_key(p, index);
    p->ptr[index] = left;
    free(right);
    if (p->n == 0)
	{
	free(p);
	base->ptr[0] = left;
	}
    return left;
}

void make_swap(Bnode *p, Bnode *t, PKEY pkey, int index)
{
Bnode *center, *pcenter;
    pcenter = t;
    center = pcenter->ptr[index+1];
    while (center->ptr[0] != NULL)
	{
	pcenter = center;
	center = center->ptr[0];
	}
    t->key[index] = center->key[0];
    *pkey = center->key[0];
}

Bnode *Btree_delete(PKEY pkey, Bnode *base, int *num)
{
Bnode *t, *parent;
int pi = 0;
int ti;
    parent = base;
    t = base->ptr[0];
    while (t != NULL)
	{
	if (t->n <= M && parent != base)
	    if (!borrow_key(parent, pi)) t = bind_node(parent, pi, base);
	if ((ti = in_Bnode(pkey, t)) >= 0)
	    {
	    if (t->ptr[0] == NULL) break;  /* if external break */
	    else make_swap(parent, t, pkey, ti);
	    }
	parent = t;
	for (pi = 0; pi < t->n && GE(pkey, &(t->key[pi])); pi++);
	t = t->ptr[pi];
	}
    if (t == NULL) return NULL;  /* can't find */
    if (t->n <= M && parent != base)  /* external but less M */
	if (!borrow_key(parent, pi)) t = bind_node(parent, pi, base);
    delete_key(t, in_Bnode(pkey, t));
    (*num)--;
    return t;
}

void _deleteall(Bnode *t)
{
int i;
    if (t != NULL)
	{
	for (i = 0; i < t->n+1; i++)
	    _deleteall(t->ptr[i]);
	free(t);
	}
}

Bnode *Btree_deleteall(Bnode *base, int *num)
{
    _deleteall(base->ptr[0]);
    base->ptr[0] = NULL;
    *num = 0;
    return base;
}

void _list(Bnode *t)
{
int i, nn;
static int x = 0;
    if (t != NULL)
	{
	x += 2;
	nn = 1;
	for (i = 2; i < x; i++) printf("   ");
	for (i = 0; i < t->n; i++)
	{
	    printf("%3d:%08X<%08X,", t->key[i].class, t->key[i].c_ref, t->key[i].c_pos);
		if(nn++ % 4==0)printf("\n");
	}
	printf("\n");
	for (i = 0; i < t->n+1; i++) _list(t->ptr[i]);
	x -= 2;
	}
}

void Btree_list(Bnode *base)
{
    _list(base->ptr[0]);
}

void _sort(Bnode *t)
{
int i, j;
static int x=0;
    if (t != NULL)
	{
	    for (i = 0; i < t->n; i++)
	    {
	        _sort(t->ptr[i]);
		    //if(t->key[i].class>2||t->key[i].class==0)
		    {
		        printf("%5d:%08X<%08X,", t->key[i].class, t->key[i].c_ref, t->key[i].c_pos);
	            if(x++ % 4==0)printf("\n");
		    }
	    }
	_sort(t->ptr[i]);
	}
}

void Btree_sort(Bnode *base)
{
    _sort(base->ptr[0]);
}

// ******************************
// some functions from preccx.
// ******************************

VOID  zer_error(){fatalError=100;}
VOID  bad_error(){fatalError=101;}
VOID  btk_error(){fatalError=-1;}
VOID  precc_begin(){BEGIN;}
VOID  precc_end(){END;}
void  precc_alloc()
{
ACTION p_creat_data;

    precc_data.readbuffersize=READBUFFERSIZE;
    precc_data.maxprogramsize=MAXPROGRAMSIZE;
    precc_data.stacksize=STACKSIZE;
    precc_data.contextstacksize=CONTEXTSTACKSIZE;
    precc_data.stacktokens=STACKTOKENS;
    precc_data.oldattributes=OLDATTRIBUTES;
    p_creat_data();
}
VOID  precc_free()
{
ACTION p_destr_data; static n;
if (!n++) p_destr_data();
}

