# define max_col 12
# define my_ON   0
# define my_OFF  1
# define WINAPI

# include "ccx.h"
# include <ctype.h>

//
// I use function pointer to turn off printing
// so if I want to printout something then %prxntf% becomes %printf% 
// and if I don't want to print out then %prxntf% becomes %nullxx% (which does nothing)
// wow, how convenient is this, but I rather like to have something more elegant
// like -- fprintf(stdout,...) and fprintf(nullfilepointer,...)
// I don't know whether this is doable or not... sang cho -- october 23, 1997
//
extern int (*prxntf)(const char *,...);
LPVOID WINAPI TranslateFunctionName (char *);
int           Get32Address(int);

extern int imageBase;
extern int entryPoint; 
extern int opcodeTable[]; 
extern int opcode2Table[];
extern int repeatgroupTable[];
extern int modTable[];
extern int mod16Table[];
extern int sibTable[];
extern int regTable[];
extern int rmTable[];

extern char  *piNameBuff;	  // import module name buffer
extern char  *pfNameBuff;	  // import functions in the module name buffer
extern char  *peNameBuff;	  // export function name buffer
extern char  *pmNameBuff;     // menu name buffer
extern char  *pdNameBuff;	  // dialog name buffer
extern int    piNameBuffSize; // import module name buffer size
extern int    pfNameBuffSize; // import functions in the module name buffer	size
extern int    peNameBuffSize; // export function name buffer size
extern int    pmNameBuffSize; // menu name buffer size
extern int    pdNameBuffSize; // dialog name buffer	size

extern int imagebaseRVA;
extern int fsize;
extern int a_loc;
extern int i_col;
extern int i_col_save;
extern int i_psp;
extern int prefixStack[];
extern int opclass;
extern int modclass;
extern int i_opclass;
extern int i_opcode;
extern int i_mod;
extern int i_sib;
extern int i_byte;
extern int i_word;
extern int i_dword;
extern int m_byte;
extern int needspacing;
extern int byteaddress;
extern int imb;
extern int mbytes[64];
extern int m_dword;
extern LPVOID lpFile;
extern int NumberOfBytesProcessed;
extern int addressOveride;
extern int operandOveride;
extern int lastAnchor;
extern int leaveFlag;
extern int delta;

extern int nextMode;
extern int dmc;
extern int dmLabels[8];

int gotJmpRef = 0;
int specifierFlag = my_OFF;
int class=0;
int ref=0;
int tempref[8]={0,};
int temppos[8]={0,};
int reg=-1;

void   WINAPI TranslateParameters (char **, char **, char **);

char  *reg8String[] = {  "al",  "cl",  "dl",  "bl",  "ah",  "ch",  "dh",  "bh"};
char *reg16String[] = {  "ax",  "cx",  "dx",  "bx",  "sp",  "bp",  "si",  "di"};
char *reg32String[] = { "eax", "ecx", "edx", "ebx", "esp", "ebp", "esi", "edi"};
char *reg64String[] = { "mm0", "mm1", "mm2", "mm3", "mm4", "mm5", "mm6", "mm7"};
char *SregString [] = {  "es",  "cs",  "ss",  "ds",  "fs",  "gs",  "##",  "##"};
char *mod16String[] = {"bx+si","bx+di","bp+si","bp+di","si","di",  "bp",  "bx"};

/* *********************************************************************** */
/* Original Part of grammar generated data                                 */
/* *********************************************************************** */



int  print_m_byte()
{
    prxntf("%02X", m_byte);
	return m_byte;
}
int  print_m_dword()
{
    if (addressOveride) prxntf("%04X",m_dword);
	else prxntf("%08X", m_dword);
	return m_dword;
}
int  print_i_byte()
{
    prxntf("%02X", i_byte);
	return i_byte;
}
int  print_i_byte32()
{
int r;
    r = ((i_byte>127)?i_byte-256:i_byte);
    if (operandOveride||addressOveride)	prxntf("%04X",r); 
	else prxntf("%08X",r);
	return r;
}
int  print_i_dword()
{
	if (operandOveride||addressOveride)	prxntf("%04X", i_dword);
    else prxntf("%08X", i_dword);
	return i_dword;
}
int  print_i_word()
{
    prxntf("%04X", i_word);
	return i_word;
}
int  print_rel8()
{
	ref = imagebaseRVA + delta + a_loc + ((i_byte>127)?i_byte-256:i_byte);
    if (addressOveride) prxntf("%04X",ref); else prxntf("%08X", ref);
	if (nextMode) 
	{   if (i_opcode == 0xEB) class = 1; else class = 2; }
	return ref;
}
int  print_rel32()
{
    ref = imagebaseRVA + delta + a_loc + i_dword;
    if (addressOveride) prxntf("%04X",ref); else prxntf("%08X", ref);
	return ref;
}
int  print_moff()
{
    prefix();
	if(addressOveride) prxntf("[%04X]",i_dword);
	else prxntf("[%08X]", i_dword);
	return i_dword;
}
int  r___(n)
int n;
{
    switch(n)
	{
	    case  8: prxntf("%s", reg8String [regTable[i_mod]]); break;
		case 16: prxntf("%s", reg16String[regTable[i_mod]]); break;
		case 32: prxntf("%s", reg32String[regTable[i_mod]]); break;
		case 64: prxntf("%s", reg64String[regTable[i_mod]]); break;
		default: fatalError=100;
	}
	return i_mod;
}
int  mm____()
{
    prxntf("%s", reg64String[regTable[i_mod]]);
	return i_mod;
}
int  rm_m32 (n)
int n;
{
    switch(n)
	{
	    case  8: prxntf("%s", reg8String [rmTable[i_mod]]); break;
		case 16: prxntf("%s", reg16String[rmTable[i_mod]]); break;
		case 32: prxntf("%s", reg32String[rmTable[i_mod]]); break;
		case 64: prxntf("%s", reg64String[rmTable[i_mod]]); break;
		default: fatalError=101;
	}
	return i_mod;
}
int  rm_m16 (n)
int n;
{
	prxntf("%s", mod16String[rmTable[i_mod]]); 
	return i_mod;
}
int  reg_s ()
{
	prxntf("%s", reg32String[regTable[i_sib]]);
	return i_sib;
}
int  base()
{
    prxntf("%s", reg32String[rmTable[i_sib]]);
	return i_sib;
}
int  scaledindex()
{
int c;
    c=modTable[i_sib];
	c=c/2;
	if (c>0) c--;
	switch(c)	 /* now c is SS of sib byte */
	{
	    case  0:               reg_s(); break;
		case  1: prxntf("2*"); reg_s(); break;
		case  2: prxntf("4*"); reg_s(); break;
		case  3: prxntf("8*"); reg_s(); break;
		default: fatalError=103;
	}
	return i_sib;
}
void specifier (n)
int n;
{ 
    if (nextMode) return;
    switch(n)
	{
	    case  8: prxntf("byte"); break;
		case 16: prxntf("word"); break;
		case 32: prxntf("dword"); break;
		case 64: prxntf("qword"); break;
		default:
	}
	prefix();
}

int  prefix()
{
	if (i_psp>0)
	{
                 if  (prefixStack[i_psp-1] ==  38)
			{    prxntf (" es:");            }
			else if  (prefixStack[i_psp-1] ==  46)
			{    prxntf (" cs:");            }
			else if  (prefixStack[i_psp-1] ==  54)
			{    prxntf (" ss:");            }
			else if  (prefixStack[i_psp-1] ==  62)
			{    prxntf (" ds:");            }
			else if  (prefixStack[i_psp-1] == 100)
			{    prxntf (" fs:");            }
			else if  (prefixStack[i_psp-1] == 101)
			{    prxntf (" gs:");            }
	}    
	if (i_psp>1)
	{
                 if  (prefixStack[i_psp-2] ==  38)
			{    prxntf (" es:");            }
			else if  (prefixStack[i_psp-2] ==  46)
			{    prxntf (" cs:");            }
			else if  (prefixStack[i_psp-2] ==  54)
			{    prxntf (" ss:");            }
			else if  (prefixStack[i_psp-2] ==  62)
			{    prxntf (" ds:");            }
			else if  (prefixStack[i_psp-2] == 100)
			{    prxntf (" fs:");            }
			else if  (prefixStack[i_psp-2] == 101)
			{    prxntf (" gs:");            }
	}
}

int  r_m_  (n)
{
	if (addressOveride==0) return r_m_32(n);
	else return r_m_16(n);
}

int  r_m_32  (n)
int n;
{
int    c, rr;

	rr=32;

    c=modTable[i_mod];
	switch(c)
	{
	    case  1: specifier(n);
		         prxntf("["); ref = rm_m32(rr); prxntf("]");         
		         return -1;
		case  2: specifier(n);
				 if (sibTable[i_sib]==1)  /* sib star */ 
				 {
				     prxntf("[");
					 if (regTable[i_sib]!=4)
					 {scaledindex(); prxntf("+"); gotJmpRef=1;} 
					 ref = print_m_dword(); prxntf("]");
				 }
				 else                     /* sib non star */
				 {
				     prxntf("["); base(); prxntf("+"); 
					 ref = scaledindex(); prxntf("]");
				 }
				 return ref;
		case  3: specifier(n);
		         prxntf("["); ref = print_m_dword(); prxntf("]"); 
				 return ref;
		case  4: specifier(n);
		         prxntf("["); rm_m32(rr); 
				 prxntf("+"); print_m_byte(); prxntf("]");
				 return -1;
		case  5: specifier(n);
		         prxntf("["); base(); prxntf("+");  
				 if (regTable[i_sib]!=4)
				 {scaledindex(); prxntf("+");} 
				 print_m_byte(); prxntf("]");
				 return -1;
		case  6: specifier(n);
				 prxntf("["); rm_m32(rr); 
				 prxntf("+"); ref = print_m_dword(); prxntf("]");
				 return ref;
		case  7: specifier(n);
				 prxntf("["); base(); prxntf("+"); 
				 if (regTable[i_sib]!=4)
				 {scaledindex(); prxntf("+");}  
				 ref = print_m_dword(); prxntf("]");
				 return ref;
		case  8:
		         rm_m32(n);
				 return -1;
		default: fatalError=105;
	}
}

int  r_m_16  (n)
int n;
{
int    c, rr;

	rr=16; 

    c=mod16Table[i_mod];
	switch(c)
	{
	    case  1: specifier(n);
		         prxntf("["); ref = rm_m16(rr); prxntf("]");         
		         return -1;
		case  2: specifier(n);
		         prxntf("["); ref = print_m_dword(); prxntf("]"); 
				 return ref;
		case  3: specifier(n);
		         prxntf("["); rm_m16(rr); 
				 prxntf("+"); print_m_byte(); prxntf("]");
				 return -1;
		case  4: specifier(n);
		         prxntf("["); rm_m16(rr); 
				 prxntf("+"); print_m_dword(); prxntf("]");
				 return -1;
		case  5: 
		         rm_m32(n);
				 return -1;
		default: fatalError=105;
	}
}


int  Sreg__()
{
	prxntf("%s", SregString[regTable[i_mod]]);
	return i_mod;
}
int  m16_32()
{
	prxntf("m16:m32"); ref = r_m_ ( 0);
	return Get16_32Address(ref);
}
void m32_32()
{
	prxntf("m32:m32"); r_m_ ( 0);
}
int  m_____()
{
int    rr;

	if (operandOveride||addressOveride) rr=16; else rr=32;

	return r_m_ (rr);
}

void nmonicprint()
{
	if (opclass==1) 
	{
		switch(i_opclass)
		{
		    case  0: print0case();
			         break;
		    case  1: print1case();
			         break;
			case  2: print2case();
			         break;
			case  3: print3case();
			         break;
			case  4: print4case();
			         break; 
			case  5: print5case();
			         break;
			case  6: print6case();
			         break;
			case  7: print7case();
			         break;
			case  8: print8case();
			         break;
			case  9: print9case();
			         break;
			case 10: print10case();
			         break;
			case 11: print11case();
			         break;
			case 12: print12case();
			         break;
			case 13: print13case();   
			         break;
			case 14: print14case();
			         break;
			case 15: print15case();
			         break;
			case 16: print16case();
			         break;
			default:
		}
	}
	else 
	{   
		switch(i_opclass)
		{
		    case  0: print20case();
			         break;
		    case  1: print21case();
			         break;
			case  2: print22case();
			         break;
			case  3: print23case();
			         break;
			case  4: print24case();
			         break;
			case  5: print25case();
			         break;
			default:
		}
    }	
} /* end of nmonicprint() */


int addressfix()
{
	if (yytchar==EOF) return 0;
    if (0<NumberOfBytesProcessed) a_loc = NumberOfBytesProcessed;
	cur_position = imagebaseRVA + a_loc + delta;
	return 1;
} /* end of addressprint() */

int addressprint1(int c)
{
static int cc=0;
PBYTE      p;

	if (yytchar==EOF) return 0;	
	if (nextMode)     return 0;
	if (c!=cc)
	{
	    if (cc==2 && imb>0) bodyprint21(); imb=0;
		prxntf("\n"); needspacing=0;
		if (!nextMode) fprintf(stderr,".");
	}
	else 
	{
	    if (needspacing){ prxntf("\n"); needspacing=0; }
	}

	
	if (cur_position==entryPoint+imageBase)
	    prxntf("\n//******************** Program Entry Point ********");
	p=toMap(cur_position); 
		 if (*p&0x80) printExportName();
	else if (*p&0x40) printEntryMark();
	else if (*p&0x20) printLabelMark();

	if (c!=cc)
	{
        if (cur_position<imagebaseRVA+CodeSize)
		prxntf("\n:%08X ", cur_position);
	}
	else 
	{
		if (c<2)
		prxntf("\n:%08X ", cur_position);
		else if (imb==0)
		{ 
		    prxntf("\n:%08X ", cur_position);
		    imb=0;
		}
	}
	cc=c;
	return 1;
} /* end of addressprint() */

int addressprint()
{
    addressfix();
	addressprint1(1);
	return 1;
}

int bodyprint(int c)
{
         if (c==0) bodyprint0();
	else if (c==1) bodyprint1();
	else if (c==2) bodyprint2();
	else if (c==3) bodyprint3();
}

int bodyprint0()
{
int            i,r;
BYTE           c;
PBYTE          p, q;
    
	if (yytchar==EOF) return 0; 
	if (finished) {finished=0; return 1;}

	r=imagebaseRVA+a_loc_save+delta;
	p=toMap(r);
	
	if (nextMode) 
	{
		q=toFile(r);
	    if (i_opcode==0xCC) *p= 0x0C; 
		else
		{
		    if (nextMode<3) 
			{    
			    *p |= 0x05; 
			    for(i=1;i<i_col;i++) 
				if(*(p+i)&0x40) 
				{
				    fatalError=900;
		            break;
				}
				else *(p+i) |= 0x04;
			}
			else
			{
			    *p |= 0x07; 
			    for(i=1;i<i_col;i++) 
				if(*(p+i)&0x40)
				{
				    fatalError=900;
					break;
				}
				else *(p+i) |= 0x06;
			}
			if(fatalError==0)
			for(i=1;i<i_col;i++)
		        if (*(p+i)&0x20)
				{dmLabels[dmc++]=r+i;*(p+i)^=0x20;}
	    }
	}
	else  for(i=i_col;i<max_col;i++)prxntf("  ");

	nmonicprint();

	if (nextMode)
	{
	    if (class) EnterLabel(class, ref, cur_position); 
	    if (dmc)   fatalError=999;
	}
	else
	{
	    if (*p&0x10) printString();
	}

	class = 0;
	ref   = 0;
	a_loc_save=a_loc;
	i_col_save=i_col;
	i_psp=0; 
	i_col=0;
	addressOveride = 0;
	operandOveride = 0;

	return 1;
}

int bodyprint1()
{
int       i;
    
	if (yytchar==EOF) return 0; 

	if (nextMode>0)
	EnterLabel(166, m_dword, cur_position);
	else
	{
	    for(i=i_col;i<max_col;i++)prxntf("  ");
	    prxntf ("DWORD %08X", m_dword);
	}
	class = 0;
	ref   = 0;
	a_loc_save=a_loc;
	i_col_save=i_col;
	i_psp=0; 
	i_col=0;
	operandOveride = 0;
	return 1;
}

int bodyprint2()
{
    mbytes[imb++]=m_byte;
    if (imb==16) 
        bodyprint21();
    return 1;
}



int bodyprint21()
{
int           i;
unsigned char c;
    
	if (yytchar==EOF) return 0; 

	if (nextMode==0)
	{
	    for(i=0;i<imb;i++)prxntf("%02X ",mbytes[i]);
	    for(   ;i<16; i++)prxntf("   "); prxntf("  ");
	    for(i=0;i<imb;i++)prxntf("%c",isprint(c=mbytes[i])?c:'.');
	}

	imb   = 0;
	class = 0;
	ref   = 0;
	a_loc_save=a_loc;
	i_col_save=i_col;
	i_psp=0; 
	i_col=0;
	operandOveride = 0;
	return 1;
}


int bodyprint3()
{
    if (yytchar==EOF) return 0; 
	
	imb++;
	
    class = 0;
	ref   = 0;
	a_loc_save=a_loc;
	i_col_save=i_col;
	i_psp=0; 
	i_col=0;
	operandOveride = 0;
	return 1;
}

int isEntry(int pos)
{
PBYTE   p=toMap(pos);

    if ((imagebaseRVA<=pos)&&(pos<imagebaseRVA+CodeSize)
	    &&((*p&0x40)==0x40)) return 1;
	else return 0;
}

int GotName(int pos, int pos1)
{
    int    r;
	char  *p;
	_key_  k;
	PKEY   pk;

    r=-pos;
	if ((int)lpFile<r&&r<(int)lpFile+fsize)
	{
	    k.c_ref=pos; k.c_pos=0; k.class=0;
		pk = searchBtree1(&k);
		
		if ((pk!=NULL)&&((int)piNameBuff<=pk->c_pos)
		  &&(pk->c_pos<(int)piNameBuff+piNameBuffSize))
		{  
			p=strtok((char *)(pk->c_pos),".");
		    prxntf("%s",p);prxntf(".");
			
		    p=TranslateFunctionName((char *)r);
	        prxntf("%s",p); 
		    return 1;
	    }
	}
	if ((int)peNameBuff<r&&r<(int)peNameBuff+peNameBuffSize)
	{
	    p=TranslateFunctionName((char *)r);
		prxntf("%s",p);
		return 1;
	}
	if (isEntry(pos1)) 
	{
	    prxntf("%08X",pos1);
		return 1;
	}
    return 0;
}

int printName(int pos)
{
int            r, rr;
_key_          k, k1, k2, k3, k4;
PKEY           pk;
		
// this is very tricky.. i need to be extremely careful. oct.31,1997sangcho
	    
		k.c_ref=pos; k.c_pos=0; k.class=0;
	    pk = searchBtree1(&k);
	    if(pk==NULL) return 0;

		k1=*pk;  
		if (AddressCheck(k1.c_pos))
		{
		    r=k1.c_pos;
			k.c_ref=r;  k.c_pos=0; k.class=0;
			
			pk = searchBtree1(&k);
			
			if(pk==NULL) 
			{
			    if (isEntry(k1.c_pos)) 
	            {
	                prxntf("%08X",k1.c_pos);
		            return 1;
	            }
			    return 0; 
			}

		    k2=*pk;
			if (k2.c_pos<0) return GotName(k2.c_pos, k1.c_pos);
			
			k.c_ref=k2.c_pos; k.c_pos=0; k.class=0;
			
			pk = searchBtree1(&k);
			
			if(pk==NULL)
			{
			    if (isEntry(k1.c_pos)) 
	            {
	                prxntf("%08X",k1.c_pos);
		            return 1;
	            }
			    return 0; 
			}

			k3=*pk;
			return GotName(k3.c_pos, k1.c_pos);
		}
		else
		{
		    k2=*pk;
			k.c_ref=k2.c_pos; k.c_pos=0; k.class=0;
			pk = searchBtree1(&k);
			if(pk==NULL) 
			{
			    if (isEntry(k1.c_pos)) 
	            {
	                prxntf("%08X",k1.c_pos);
		            return 1;
	            }
			    return 0; 
			}
			
			k3=*pk;
			return GotName(k3.c_pos, k1.c_pos);
		}
		return 1;
}


int printExportName1(int ref)
{
int            r, rr;
_key_          k;
PKEY           pk;
PBYTE          p;
	    
	k.c_ref=ref; k.c_pos=0; k.class=0;
	pk = searchBtree1(&k);
	if(pk==NULL) return 0;
	r=-(pk->c_pos);
	if ((int)peNameBuff<r&&r<(int)peNameBuff+peNameBuffSize)
	{
	    p=TranslateFunctionName((char *)r);
		prxntf("%s",p);
	}
	return 1;
}

int printExportName()
{
PBYTE          p, q;
    q=toFile(cur_position);
	if (*q==0xC3) 
	{
	    p=toMap(cur_position);
		if (*p&0x40) return printEntryMark();
		if (*p&0x20) return printLabelMark();
        return 1;
	}
	prxntf("\n=========\n");
	printExportName1(cur_position);
	prxntf("\n=========");
	return 1;
}

int printEntryMark()
{
    prxntf("\n=========");
}

int printLabelMark()
{
    prxntf("\n---------");
}

int printString()
{
int            r, rr;
_key_          k;
PKEY           pk;
PBYTE          p;
	    
	k.c_ref=cur_position; k.c_pos=0; k.class=0;
	pk = searchBtree1(&k);
	if(pk==NULL) return 0;
	r=pk->c_pos;
	p=toFile(r);
	prxntf("\n                      (StringData)\"%s\"",p);
	return 1;
}

int print0case()  
{			 	
	switch(i_opcode)
	{
		case 0x06:  prxntf("push es"); break;   
		case 0x07:  prxntf("pop es"); break;   
		case 0x0E:  prxntf("push cs"); break;   
		case 0x16:  prxntf("push ss"); break; 	
		case 0x17:  prxntf("pop ss"); break;	
		case 0x1E:  prxntf("push ds"); break; 	
		case 0x1F:  prxntf("pop ds"); break;	
		case 0x27:  prxntf("daa"); break; 
		case 0x2F:  prxntf("das"); break;     
		case 0x37:  prxntf("aaa"); break;     
		case 0x3F:  prxntf("aas"); break;     
		case 0x40:  if (operandOveride) prxntf("inc ax");
		            else                prxntf("inc eax"); 
					break;   
		case 0x41:  if (operandOveride) prxntf("inc cx");
		            else                prxntf("inc ecx"); 
					break;   
		case 0x42:  if (operandOveride) prxntf("inc dx");
		            else                prxntf("inc edx"); 
					break;     
		case 0x43:  if (operandOveride) prxntf("inc bx");
		            else                prxntf("inc ebx"); 
					break;   
		case 0x44:  if (operandOveride) prxntf("inc sp");
		            else                prxntf("inc esp"); 
					break;   
		case 0x45:  if (operandOveride) prxntf("inc bp");
		            else                prxntf("inc ebp"); 
					break;   
		case 0x46:  if (operandOveride) prxntf("inc si");
		            else                prxntf("inc esi"); 
					break;   
		case 0x47:  if (operandOveride) prxntf("inc di");
		            else                prxntf("inc edi"); 
					break;  
		case 0x48:  if (operandOveride) prxntf("dec ax");
		            else                prxntf("dec eax"); 
					break;   
		case 0x49:  if (operandOveride) prxntf("dec cx");
		            else                prxntf("dec ecx"); 
					break;   
		case 0x4A:  if (operandOveride) prxntf("dec dx");
		            else                prxntf("dec edx"); 
					break;     
		case 0x4B:  if (operandOveride) prxntf("dec bx");
		            else                prxntf("dec ebx"); 
					break;   
		case 0x4C:  if (operandOveride) prxntf("dec sp");
		            else                prxntf("dec esp"); 
					break;   
		case 0x4D:  if (operandOveride) prxntf("dec bp");
		            else                prxntf("dec ebp"); 
					break;   
		case 0x4E:  if (operandOveride) prxntf("dec si");
		            else                prxntf("dec esi"); 
					break;   
		case 0x4F:  if (operandOveride) prxntf("dec di");
		            else                prxntf("dec edi"); 
					break; 
		case 0x50:  if (operandOveride) prxntf("push ax");
		            else                prxntf("push eax"); 
					break;   
		case 0x51:  if (operandOveride) prxntf("push cx");
		            else                prxntf("push ecx"); 
					break;   
		case 0x52:  if (operandOveride) prxntf("push dx");
		            else                prxntf("push edx"); 
					break;     
		case 0x53:  if (operandOveride) prxntf("push bx");
		            else                prxntf("push ebx"); 
					break;   
		case 0x54:  if (operandOveride) prxntf("push sp");
		            else                prxntf("push esp"); 
					break;   
		case 0x55:  if (operandOveride) prxntf("push bp");
		            else                prxntf("push ebp"); 
					break;   
		case 0x56:  if (operandOveride) prxntf("push si");
		            else                prxntf("push esi"); 
					break;   
		case 0x57:  if (operandOveride) prxntf("push di");
		            else                prxntf("push edi"); 
					break;  
		case 0x58:  if (operandOveride) prxntf("pop ax");
		            else                prxntf("pop eax"); 
					break;   
		case 0x59:  if (operandOveride) prxntf("pop cx");
		            else                prxntf("pop ecx"); 
					break;   
		case 0x5A:  if (operandOveride) prxntf("pop dx");
		            else                prxntf("pop edx"); 
					break;     
		case 0x5B:  if (operandOveride) prxntf("pop bx");
		            else                prxntf("pop ebx"); 
					break;   
		case 0x5C:  if (operandOveride) prxntf("pop sp");
		            else                prxntf("pop esp"); 
					break;   
		case 0x5D:  if (operandOveride) prxntf("pop bp");
		            else                prxntf("pop ebp"); 
					break;   
		case 0x5E:  if (operandOveride) prxntf("pop si");
		            else                prxntf("pop esi"); 
					break;   
		case 0x5F:  if (operandOveride) prxntf("pop di");
		            else                prxntf("pop edi"); 
					break; 
		case 0x60:  prxntf("pushad"); break;  
		case 0x61:  prxntf("popad");  break;   
		case 0x6C:  prxntf("ins byte, port[dx]"); break;   
		case 0x6D:  prxntf("ins dword, port[dx]"); break;   
		case 0x6E:  prxntf("outs port[dx], byte"); break; 	
		case 0x6F:  prxntf("outs port[dx], dword"); break;	
		case 0x90:  prxntf("nop");        break; 	
		case 0x91:  if (operandOveride)	prxntf("xchg ax, cx");
		            else                prxntf("xchg eax, ecx"); 
					break;	
		case 0x92:  if (operandOveride)	prxntf("xchg ax, dx");
		            else                prxntf("xchg eax, edx"); 
					break; 
		case 0x93:  if (operandOveride)	prxntf("xchg ax, bx");
		            else                prxntf("xchg eax, ebx"); 
					break;     
		case 0x94:  if (operandOveride)	prxntf("xchg ax, sp");
		            else                prxntf("xchg eax, esp"); 
					break;     
		case 0x95:  if (operandOveride)	prxntf("xchg ax, bp");
		            else                prxntf("xchg eax, ebp"); 
					break;     
		case 0x96:  if (operandOveride)	prxntf("xchg ax, si");
		            else                prxntf("xchg eax, esi"); 
					break;   
		case 0x97:  if (operandOveride)	prxntf("xchg ax, di"); 
		            else                prxntf("xchg eax, edi"); 
					break;   
		case 0x98:  prxntf("cbw");    break;   
		case 0x99:  if (operandOveride)	prxntf("cwd");
		            else                prxntf("cdq");    
					break;   
		case 0x9C:  prxntf("pushfd");    break;   
		case 0x9D:  prxntf("popfd");    break;   
		case 0x9E:  prxntf("sahf");    break;   
		case 0x9F:  prxntf("lahf");  break;   
		case 0xA4:  prxntf("movsb");  break;   
		case 0xA5:  if (operandOveride) prxntf ("movsw");
		            else                prxntf ("movsd");  
					break;   
		case 0xA6:  prxntf("cmpsb");  break;   
		case 0xA7:  if (operandOveride) prxntf ("cmpsw");
		            else                prxntf ("cmpsd"); 
		            break;   
		case 0xAA:  prxntf("stosb"); break;
		case 0xAB:  if (operandOveride) prxntf ("stosw");
		            else                prxntf ("stosd"); 
		            break;    
		case 0xAC:  prxntf("lodsb"); break;   
		case 0xAD:  if (operandOveride) prxntf ("lodsw");
		            else                prxntf ("lodsd"); 
		            break;   
		case 0xAE:  prxntf("scasb"); break;   
		case 0xAF:  if (operandOveride) prxntf ("scasw");
		            else                prxntf ("scasd"); 
		            break;   
		case 0xC3:  prxntf("ret");  needspacing=1;  
		            lastAnchor=cur_position+i_col-1;
					*(unsigned char *)((int)lpMap+a_loc_save+delta+i_col-1) |= 0x80;
					break;   
		case 0xC9:  prxntf("leave");  break;   
		case 0xCB:  prxntf("ret(far)");	needspacing=1;
		            lastAnchor=cur_position+i_col-1;
					*(unsigned char *)((int)lpMap+a_loc_save+delta+i_col-1) |= 0x80;
					//leaveFlag=cur_position+i_col;
		            break;   
		case 0xCC:  prxntf("int 03"); break;   
		case 0xCE:  prxntf("into"); break;   
		case 0xCF:  if (operandOveride) prxntf ("iret");
		            else                prxntf ("iretd"); 
		            break;   
		case 0xD7:  prxntf("xlatb"); break;   
		case 0xEC:  prxntf("in al, port[dx]"); break;   
		case 0xED:  if (operandOveride) prxntf ("in ax, port[dx]");
		            else                prxntf ("in eax, port[dx]"); 
					break;   
		case 0xEE:  prxntf("out port[dx], al"); break;   
		case 0xEF:  if (operandOveride) prxntf ("out port[dx], ax");
		            else                prxntf ("out port[dx], eax"); 
					break;   
		case 0xF0:  prxntf("lock"); break;   
		case 0xF4:  prxntf("hlt"); break;   
		case 0xF5:  prxntf("cmc"); break;   
		case 0xF8:  prxntf("clc"); break;  
		case 0xF9:  prxntf("stc"); break;   
		case 0xFA:  prxntf("cli"); break;   
		case 0xFB:  prxntf("sti"); break;   
		case 0xFC:  prxntf("cld"); break; 	
		case 0xFD:  prxntf("std"); break;
		default:    fatalError=107;return -1;
	}
	return 0;
}

int print1case()
{
	switch(i_opcode)
	{
		case 0x04:  prxntf("add al, ");    print_i_byte(); break;   
		case 0x0C:  prxntf("or al, ");     print_i_byte(); break;   
		case 0x14:  prxntf("adc al, ");    print_i_byte(); break;   
		case 0x1C:  prxntf("sbb al, ");    print_i_byte(); break; 	
		case 0x24:  prxntf("and al, ");    print_i_byte(); break;	
		case 0x2C:  prxntf("sub al, ");    print_i_byte(); break; 	
		case 0x34:  prxntf("xor al, ");    print_i_byte(); break;	
		case 0x3C:  prxntf("cmp al, ");    print_i_byte(); break; 
		case 0x6A:  prxntf("push ");       print_i_byte32(); break;     
		case 0x70:  prxntf("jo ");         print_rel8();   break;     
		case 0x71:  prxntf("jno ");        print_rel8();   break;     
		case 0x72:  prxntf("jc ");         print_rel8();   break;   
		case 0x73:  prxntf("jae ");        print_rel8();   break;   
		case 0x74:  prxntf("je ");         print_rel8();   break;   
		case 0x75:  prxntf("jne ");        print_rel8();   break;   
		case 0x76:  prxntf("jbe ");        print_rel8();   break;   
		case 0x77:  prxntf("ja ");         print_rel8();   break;   
		case 0x78:  prxntf("js ");         print_rel8();   break;   
		case 0x79:  prxntf("jns ");        print_rel8();   break;   
		case 0x7A:  prxntf("jpe ");        print_rel8();   break;   
		case 0x7B:  prxntf("jpo ");        print_rel8();   break;   
		case 0x7C:  prxntf("jl ");         print_rel8();   break;   
		case 0x7D:  prxntf("jge ");        print_rel8();   break;   
		case 0x7E:  prxntf("jle ");        print_rel8();   break;   
		case 0x7F:  prxntf("jg ");         print_rel8();   break;   
		case 0xA8:  prxntf("test al, ");   print_i_byte(); break;   
		case 0xB0:  prxntf("mov al, ");    print_i_byte(); break;   
		case 0xB1:  prxntf("mov cl, ");    print_i_byte(); break;   
		case 0xB2:  prxntf("mov dl, ");    print_i_byte(); break;   
		case 0xB3:  prxntf("mov bl, ");    print_i_byte(); break;   
		case 0xB4:  prxntf("mov ah, ");    print_i_byte(); break;   
		case 0xB5:  prxntf("mov ch, ");    print_i_byte(); break;   
		case 0xB6:  prxntf("mov dh, ");    print_i_byte(); break;   
		case 0xB7:  prxntf("mov bh, ");    print_i_byte(); break;   
		case 0xCD:  prxntf("int ");        print_i_byte(); break;   
		case 0xD4:  prxntf("aam ");                        break;   
		case 0xD5:  prxntf("aad ");                        break;   
		case 0xE0:  prxntf("loopne ");     print_rel8();   break;   
		case 0xE1:  prxntf("loope ");      print_rel8();   break;   
		case 0xE2:  prxntf("loop ");       print_rel8();   break;   
		case 0xE3:  prxntf("jecxz ");      print_rel8();   break;   
		case 0xE4:  prxntf("in al, port["); print_i_byte(); prxntf("]");break;   
		case 0xE5:  prxntf("in eax, port[");print_i_byte(); prxntf("]");break;   
		case 0xE6:  prxntf("out port["); print_i_byte(); prxntf("], al");    break;   
		case 0xE7:  prxntf("out port["); print_i_byte(); prxntf("], eax");   break;
		case 0xEB:  prxntf("jmp ");        print_rel8();  
					if (nextMode>2 && referCount(ref)>3)
					{
					    lastAnchor=cur_position+i_col-1;
					    *(unsigned char *)((int)lpMap+a_loc_save+delta+i_col-1) |= 0x80;
					}
					break;
		default:    fatalError=109;return -1;
	}
	return 0;

}

int print2case()
{
    if (i_opcode==0xC2)
	{
	    prxntf("ret %04X", i_word);	needspacing=1;
	}
	else
	{
	    prxntf("ret %04X", i_word);	needspacing=1;
	}
	lastAnchor = cur_position+i_col-1;
	*(unsigned char *)((int)lpMap+a_loc_save+delta+i_col-1) |= 0x80;
	//leaveFlag=cur_position+i_col;
	return 0;
}

int print3case()
{
	prxntf("enter %04X, ", i_word); print_i_byte();
	return 0;
}

int print4case()
{
	switch(i_opcode)
	{
		case 0x05:  if (operandOveride) prxntf ("add ex, ");
		            else                prxntf ("add eax, ");   
		            print_i_dword();     
					break;   
		case 0x0D:  if (operandOveride)	prxntf ("or ax, ");
		            else                prxntf ("or eax, ");    
		            print_i_dword();     
					break;   
		case 0x15:  if (operandOveride)	prxntf ("adc ax, ");
		            else                prxntf ("adc eax, ");   
		            print_i_dword();     
					break;   
		case 0x1D:  if (operandOveride)	prxntf ("sbb ax, ");
		            else                prxntf ("sbb eax, ");   
		            print_i_dword();     
					break; 	
		case 0x25:  if (operandOveride)	prxntf ("and ax, "); 
		            else                prxntf ("and eax, ");   
		            print_i_dword();     
					break; 
		case 0x2D:  if (operandOveride)	prxntf ("sub ax, ");
		            else                prxntf ("sub eax, ");   
		            print_i_dword();     
					break;  	
		case 0x35:  if (operandOveride)	prxntf ("xor ax, ");
		            else                prxntf ("xor eax, ");   
		            print_i_dword();     
					break;	 
		case 0x3D:  if (operandOveride)	prxntf ("cmp ax, ");
		            else                prxntf ("cmp eax, ");   
		            print_i_dword();     
					break;  
		case 0x68:  prxntf("push ");    ref=print_i_dword();     // this is OK 
		// well I really don't know it is reasonably safe to do this.
		// I think when we push some (possible) address references into stack
		// there is strong reason to do so. that's why i am doing this. i guess...
		            class=512;          
		            break;     
		case 0xA0:  prxntf("mov al, byte");    print_moff();        
		            break;     
		case 0xA1:  if (operandOveride)	prxntf ("mov ax, word");
		            else                prxntf ("mov eax, dword");   
		            print_moff();        
					break;     
		case 0xA2:  prxntf("mov byte");print_moff();prxntf(", al"); 
		            break;
		case 0xA3:  if (operandOveride) prxntf("mov word");
		            else                prxntf("mov dword");
		            print_moff();
		            if (operandOveride)	prxntf (", ax");
					else                prxntf (", eax");
					break;
		case 0xA9:  if (operandOveride)	prxntf ("test ax, ");
		            else                prxntf ("test eax, ");  
		            print_i_dword();     
					break;   
		case 0xB8:  if (operandOveride)	prxntf ("mov ax, ");
		            else                prxntf ("mov eax, ");   
		            ref=print_i_dword();class=1024;     
					break;   
		case 0xB9:  if (operandOveride)	prxntf ("mov cx, ");
		            else                prxntf ("mov ecx, ");   
		            ref=print_i_dword();class=1024;     
					break;   
		case 0xBA:  if (operandOveride)	prxntf ("mov dx, "); 
		            else                prxntf ("mov edx, ");   
		            ref=print_i_dword();class=1024;     
					break;   
		case 0xBB:  if (operandOveride)	prxntf ("mov bx, ");
		            else                prxntf ("mov ebx, ");   
		            ref=print_i_dword();class=1024;     
					break;   
		case 0xBC:  if (operandOveride)	prxntf ("mov sp, ");
		            else                prxntf( "mov esp, ");   
		            ref=print_i_dword();class=1024;     
					break;   
		case 0xBD:  if (operandOveride)	prxntf ("mov bp, ");
		            else                prxntf("mov ebp, ");   
		            ref=print_i_dword();class=1024;     
					break;   
		case 0xBE:  if (operandOveride)	prxntf ("mov si, "); 
		            else                prxntf("mov esi, ");   
		            ref=print_i_dword();class=1024;     
					break;   
		case 0xBF:  if (operandOveride)	prxntf ("mov di, "); 
		            else                prxntf("mov edi, ");   
		            ref=print_i_dword();class=1024;     
					break;   
		case 0xE8:  prxntf("call "); 
		            if (nextMode) {
					    ref = print_rel32();       
		                class = 11; 
					}
					else if (!printName(cur_position)) 
					print_rel32();
					break;    
		case 0xE9:  prxntf("jmp ");  ref = print_rel32();       
		            class =  3;     
					lastAnchor=cur_position+i_col-1;
					*(unsigned char *)((int)lpMap+a_loc_save+delta+i_col-1) |= 0x80;
					//leaveFlag=cur_position+i_col;
					break;    		
		default:    fatalError=111;return -1;
	}
	return 0;

}

int print5case()
{
    if (i_opcode==0x9A)
	{
	    prxntf("call far %04X:%08X", i_word,i_dword);
		{class=15; ref=i_dword;}
	}
	else
	{
	    prxntf("jmp far %04X:%08X", i_word,i_dword); 
		{class=7; ref=i_dword;}
	}
	return 0;
}

int print6case()  
{
int    rr;

	if (operandOveride) rr=16; else rr=32;

	switch(i_opcode)
	{
	  	case 0x00: prxntf("add ");    r_m_( 8);  prxntf(", ");  r___( 8);  break; 
	  	case 0x01: prxntf("add ");    r_m_(rr);  prxntf(", ");  r___(rr);  break; 
	  	case 0x02: prxntf("add ");    r___( 8);  prxntf(", ");  r_m_( 8);  break; 
	  	case 0x03: prxntf("add ");    r___(rr);  prxntf(", ");  r_m_(rr);  break; 
	  	case 0x08: prxntf("or ");     r_m_( 8);  prxntf(", ");  r___( 8);  break; 
	  	case 0x09: prxntf("or ");     r_m_(rr);  prxntf(", ");  r___(rr);  break; 
	  	case 0x0A: prxntf("or ");     r___( 8);  prxntf(", ");  r_m_( 8);  break; 
	  	case 0x0B: prxntf("or ");     r___(rr);  prxntf(", ");  r_m_(rr);  break; 
	  	case 0x10: prxntf("adc ");    r_m_( 8);  prxntf(", ");  r___( 8);  break; 
	  	case 0x11: prxntf("adc ");    r_m_(rr);  prxntf(", ");  r___(rr);  break; 
	  	case 0x12: prxntf("adc ");    r___( 8);  prxntf(", ");  r_m_( 8);  break; 
	  	case 0x13: prxntf("adc ");    r___(rr);  prxntf(", ");  r_m_(rr);  break; 
	  	case 0x18: prxntf("sbb ");    r_m_( 8);  prxntf(", ");  r___( 8);  break; 
	  	case 0x19: prxntf("sbb ");    r_m_(rr);  prxntf(", ");  r___(rr);  break; 
	  	case 0x1A: prxntf("sbb ");    r___( 8);  prxntf(", ");  r_m_( 8);  break; 
	  	case 0x1B: prxntf("sbb ");    r___(rr);  prxntf(", ");  r_m_(rr);  break; 
	  	case 0x20: prxntf("and ");    r_m_( 8);  prxntf(", ");  r___( 8);  break; 
	  	case 0x21: prxntf("and ");    r_m_(rr);  prxntf(", ");  r___(rr);  break; 
	  	case 0x22: prxntf("and ");    r___( 8);  prxntf(", ");  r_m_( 8);  break; 
	  	case 0x23: prxntf("and ");    r___(rr);  prxntf(", ");  r_m_(rr);  break; 
	  	case 0x28: prxntf("sub ");    r_m_( 8);  prxntf(", ");  r___( 8);  break; 
	  	case 0x29: prxntf("sub ");    r_m_(rr);  prxntf(", ");  r___(rr);  break; 
	  	case 0x2A: prxntf("sub ");    r___( 8);  prxntf(", ");  r_m_( 8);  break; 
	  	case 0x2B: prxntf("sub ");    r___(rr);  prxntf(", ");  r_m_(rr);  break; 
	  	case 0x30: prxntf("xor ");    r_m_( 8);  prxntf(", ");  r___( 8);  break; 
	  	case 0x31: prxntf("xor ");    r_m_(rr);  prxntf(", ");  r___(rr);  break; 
	  	case 0x32: prxntf("xor ");    r___( 8);  prxntf(", ");  r_m_( 8);  break; 
	  	case 0x33: prxntf("xor ");    r___(rr);  prxntf(", ");  r_m_(rr);  break; 
	  	case 0x38: prxntf("cmp ");    r_m_( 8);  prxntf(", ");  r___( 8);  break; 
	  	case 0x39: prxntf("cmp ");    r_m_(rr);  prxntf(", ");  r___(rr);  break; 
	  	case 0x3A: prxntf("cmp ");    r___( 8);  prxntf(", ");  r_m_( 8);  break; 
	  	case 0x3B: prxntf("cmp ");    r___(rr);  prxntf(", ");  r_m_(rr);  break; 
	  	case 0x62: prxntf("bound ");  r___(rr);  prxntf(", ");  m32_32();  break; 
	  	case 0x63: prxntf("arpl ");   r_m_(16);  prxntf(", ");  r___(16);  break; 
	  	case 0x84: prxntf("test ");   r_m_( 8);  prxntf(", ");  r___( 8);  break; 
	  	case 0x85: prxntf("test ");   r_m_(rr);  prxntf(", ");  r___(rr);  break; 
	  	case 0x86: prxntf("xchg ");   r_m_( 8);  prxntf(", ");  r___( 8);  break; 
	  	case 0x87: prxntf("xchg ");   r_m_(rr);  prxntf(", ");  r___(rr);  break; 
	  	case 0x88: prxntf("mov ");    r_m_( 8);  prxntf(", ");  r___( 8);  break; 
	  	case 0x89: prxntf("mov ");    r_m_(rr);  prxntf(", ");  r___(rr);  break; 
	  	case 0x8A: prxntf("mov ");    r___( 8);  prxntf(", ");  r_m_( 8);  break; 
	  	case 0x8B: prxntf("mov ");    r___(rr);  prxntf(", ");  ref=r_m_(rr); 
				   reg=regTable[i_mod]; tempref[reg]=ref; temppos[reg]=cur_position;
				   break; 
	  	case 0x8C: prxntf("mov ");    r_m_(rr);  prxntf(", ");  Sreg__();  break; 
	  	case 0x8D: prxntf("lea ");    r___(rr);  prxntf(", ");  m_____();  break; 
	  	case 0x8E: prxntf("mov ");    Sreg__();  prxntf(", ");  r_m_(16);  break; 
	  	case 0xC4: prxntf("les es:"); r___(rr);  prxntf(", ");  m16_32();  break; 
	  	case 0xC5: prxntf("lds es:"); r___(rr);  prxntf(", ");  m16_32();  break;
		default:   fatalError=113;return -1;
	}
	return 0;
}

int print7case()
{
int    rr;

	if (operandOveride) rr=16; else rr=32;

    prxntf("imul "); r___(rr); 
	if (modTable[i_mod]<8 || regTable[i_mod]!=rmTable[i_mod])
	{   prxntf(", "); r_m_(rr); }
	prxntf(", "); 
	print_i_byte();
	return 0;
}

int print8case()
{
int    rr;

	if (operandOveride) rr=16; else rr=32;

    prxntf("imul "); r___(rr); 
	if (modTable[i_mod]<8 || regTable[i_mod]!=rmTable[i_mod])
	{   prxntf(", "); r_m_(rr); }
	prxntf(", "); 
	print_i_dword();
	return 0;
}

int print9case()
{
int    rr;

	if (operandOveride) rr=16; else rr=32;

    specifierFlag = my_ON;
    switch(i_opcode)
	{
	    case 0x8F: 
		           if (regTable[i_mod]>0)
		           {  
				       fatalError=115;
					   specifierFlag = my_OFF;
					   return -1;
				   }
				   prxntf("pop "); r_m_(rr); 
				   break;
		case 0xD0:
		           switch(regTable[i_mod])
				   {
				       case 0: prxntf("rol "); r_m_( 8); prxntf(", 1");	break;
					   case 1: prxntf("ror "); r_m_( 8); prxntf(", 1");	break;
					   case 2: prxntf("rcl "); r_m_( 8); prxntf(", 1");	break;
					   case 3: prxntf("rcr "); r_m_( 8); prxntf(", 1");	break;
					   case 4: prxntf("shl "); r_m_( 8); prxntf(", 1");	break;
					   case 5: prxntf("shr "); r_m_( 8); prxntf(", 1");	break;
					   case 7: prxntf("sar "); r_m_( 8); prxntf(", 1");	break;
					   default:	fatalError=117;
				   }
				   break;
		case 0xD1:
		           switch(regTable[i_mod])
				   {
				       case 0: prxntf("rol "); r_m_(rr); prxntf(", 1");	break;
					   case 1: prxntf("ror "); r_m_(rr); prxntf(", 1");	break;
					   case 2: prxntf("rcl "); r_m_(rr); prxntf(", 1");	break;
					   case 3: prxntf("rcr "); r_m_(rr); prxntf(", 1");	break;
					   case 4: prxntf("shl "); r_m_(rr); prxntf(", 1");	break;
					   case 5: prxntf("shr "); r_m_(rr); prxntf(", 1");	break;
					   case 7: prxntf("sar "); r_m_(rr); prxntf(", 1");	break;
					   default:	fatalError=118;
				   }
				   break;
		case 0xD2:
		           switch(regTable[i_mod])
				   {
				       case 0: prxntf("rol "); r_m_( 8); prxntf(", cl"); break;
					   case 1: prxntf("ror "); r_m_( 8); prxntf(", cl"); break;
					   case 2: prxntf("rcl "); r_m_( 8); prxntf(", cl"); break;
					   case 3: prxntf("rcr "); r_m_( 8); prxntf(", cl"); break;
					   case 4: prxntf("shl "); r_m_( 8); prxntf(", cl"); break;
					   case 5: prxntf("shr "); r_m_( 8); prxntf(", cl"); break;
					   case 7: prxntf("sar "); r_m_( 8); prxntf(", cl"); break;
					   default:	fatalError=119;
				   }
				   break;
		case 0xD3:
		           switch(regTable[i_mod])
				   {
				       case 0: prxntf("rol "); r_m_(rr); prxntf(", cl"); break;
					   case 1: prxntf("ror "); r_m_(rr); prxntf(", cl"); break;
					   case 2: prxntf("rcl "); r_m_(rr); prxntf(", cl"); break;
					   case 3: prxntf("rcr "); r_m_(rr); prxntf(", cl"); break;
					   case 4: prxntf("shl "); r_m_(rr); prxntf(", cl"); break;
					   case 5: prxntf("shr "); r_m_(rr); prxntf(", cl"); break;
					   case 7: prxntf("sar "); r_m_(rr); prxntf(", cl"); break;
					   default:	fatalError=121;
				   }
				   break;
		case 0xFE:
		           switch(regTable[i_mod])
				   {
				       case 0: prxntf("inc "); r_m_( 8); break;
					   case 1: prxntf("dec "); r_m_( 8); break;
					   default: fatalError=123;
				   }
				   break;
		default: fatalError=125;
	}
	specifierFlag=my_OFF;
	return 0;
}

int print10case()
{
int    rr;

	if (operandOveride) rr=16; else rr=32;

    switch(i_opcode)
	{
	    case 0x80: 
		           switch(regTable[i_mod])
				   {
				       case 0: prxntf("add "); r_m_( 8); prxntf(", "); break;
					   case 1: prxntf("or ");  r_m_( 8); prxntf(", "); break;
					   case 2: prxntf("adc "); r_m_( 8); prxntf(", "); break;
					   case 3: prxntf("sbb "); r_m_( 8); prxntf(", "); break;
					   case 4: prxntf("and "); r_m_( 8); prxntf(", "); break;
					   case 5: prxntf("sub "); r_m_( 8); prxntf(", "); break;
					   case 6: prxntf("xor "); r_m_( 8); prxntf(", "); break;
					   case 7: prxntf("cmp "); r_m_( 8); prxntf(", "); break;
					   default:	fatalError=127;
				   }
				   print_i_byte();
				   break;
		case 0x83:
		           switch(regTable[i_mod])
				   {
				       case 0: prxntf("add "); r_m_(rr); prxntf(", "); break;
					   case 1: prxntf("or ");  r_m_(rr); prxntf(", "); break;
					   case 2: prxntf("adc "); r_m_(rr); prxntf(", "); break;
					   case 3: prxntf("sbb "); r_m_(rr); prxntf(", "); break;
					   case 4: prxntf("and "); r_m_(rr); prxntf(", "); break;
					   case 5: prxntf("sub "); r_m_(rr); prxntf(", "); break;
					   case 6: prxntf("xor "); r_m_(rr); prxntf(", "); break;
					   case 7: prxntf("cmp "); r_m_(rr); prxntf(", "); break;
					   default:	fatalError=129;
				   }
				   print_i_byte32();
				   break;
		           
		case 0xC0:
		           switch(regTable[i_mod])
				   {
				       case 0: prxntf("rol "); r_m_( 8); prxntf(", "); break;
					   case 1: prxntf("ror "); r_m_( 8); prxntf(", "); break;
					   case 2: prxntf("rcl "); r_m_( 8); prxntf(", "); break;
					   case 3: prxntf("rcr "); r_m_( 8); prxntf(", "); break;
					   case 4: prxntf("shl "); r_m_( 8); prxntf(", "); break;
					   case 5: prxntf("shr "); r_m_( 8); prxntf(", "); break;
					   case 7: prxntf("sar "); r_m_( 8); prxntf(", "); break;
					   default:	fatalError=131;
				   }
				   print_i_byte();
				   break;
		case 0xC1:
		           switch(regTable[i_mod])
				   {
				       case 0: prxntf("rol "); r_m_(rr); prxntf(", "); break;
					   case 1: prxntf("ror "); r_m_(rr); prxntf(", "); break;
					   case 2: prxntf("rcl "); r_m_(rr); prxntf(", "); break;
					   case 3: prxntf("rcr "); r_m_(rr); prxntf(", "); break;
					   case 4: prxntf("shl "); r_m_(rr); prxntf(", "); break;
					   case 5: prxntf("shr "); r_m_(rr); prxntf(", "); break;
					   case 7: prxntf("sar "); r_m_(rr); prxntf(", "); break;
					   default:	fatalError=133;
				   }
				   print_i_byte();
				   break;
		case 0xC6:
		           if (regTable[i_mod]==0)
				   {
				       prxntf("mov "); r_m_( 8); 
					   prxntf(", "); print_i_byte();
				   }
				   else fatalError=135;
				   break;
		default: fatalError=137;
	}
	return 0;
}

int print11case()  
{
int    rr;

	if (operandOveride) rr=16; else rr=32;

	if (i_opcode==0xC7)
	{
	    if (regTable[i_mod]>0)
		{
		    fatalError=139;
		    return -1;
		}
		prxntf("mov "); r_m_(rr); prxntf(", "); 
		ref=print_i_dword();
		class=1024;
		return 0;
	}
	else		/* is should be 0x81 otherwise i*am*in*big*trouble */
	{
	    switch(regTable[i_mod])
		{
		    case 0: prxntf("add "); r_m_(rr); prxntf(", "); print_i_dword(); break;
			case 1: prxntf("or ");  r_m_(rr); prxntf(", "); print_i_dword(); break;
			case 2: prxntf("adc "); r_m_(rr); prxntf(", "); print_i_dword(); break;
			case 3: prxntf("sbb "); r_m_(rr); prxntf(", "); print_i_dword(); break;
			case 4: prxntf("and "); r_m_(rr); prxntf(", "); print_i_dword(); break;
			case 5: prxntf("sub "); r_m_(rr); prxntf(", "); print_i_dword(); break;
			case 6: prxntf("xor "); r_m_(rr); prxntf(", "); print_i_dword(); break;
			case 7: prxntf("cmp "); r_m_(rr); prxntf(", "); print_i_dword(); break;
			default:   fatalError=141;
		}
	}
	return 0;
}

int print12case()
{
int    rr;

	if (operandOveride) rr=16; else rr=32;

    switch(i_opcode)
	{
	    case 0xD8: 
		    if (i_mod<0xC0)
			{
		           switch(regTable[i_mod])
				   {
				       case 0: prxntf("fadd ");  prxntf("32real"); r_m_( 0); break;
					   case 1: prxntf("fmul ");  prxntf("32real"); r_m_( 0); break;
					   case 2: prxntf("fcom ");  prxntf("32real"); r_m_( 0); break;
					   case 3: prxntf("fcomp "); prxntf("32real"); r_m_( 0); break;
					   case 4: prxntf("fsub ");  prxntf("32real"); r_m_( 0); break;
					   case 5: prxntf("fsubr "); prxntf("32real"); r_m_( 0); break;
					   case 6: prxntf("fdiv ");  prxntf("32real"); r_m_( 0); break;
					   case 7: prxntf("fdivr "); prxntf("32real"); r_m_( 0); break;
					   default:	fatalError=143;
				   }
			}
			else
			{
			    if (i_mod<0xC8)       prxntf("fadd st(0), st(%1d)",  i_mod-0xC0);
				else if (i_mod <0xD0) prxntf("fmul st(0), st(%1d)",  i_mod-0xC8);
				else if (i_mod==0xD1) prxntf("fcom");
				else if (i_mod <0xD8) prxntf("fcom st(0), st(%1d)",  i_mod-0xD0);
				else if (i_mod==0xD9) prxntf("fcomp");
				else if (i_mod <0xE0) prxntf("fcomp st(0), st(%1d)", i_mod-0xD8);
				else if (i_mod <0xE8) prxntf("fsub st(0), st(%1d)",  i_mod-0xE0);
				else if (i_mod <0xF0) prxntf("fsubr st(0), st(%1d)", i_mod-0xE8);
				else if (i_mod <0xF8) prxntf("fdiv st(0), st(%1d)",  i_mod-0xF0);
				else                  prxntf("fdivr st(0), st(%1d)", i_mod-0xF8);
			}
			break;
	    case 0xD9: 
		    if (i_mod<0xC0)
			{
		           switch(regTable[i_mod])
				   {
				       case 0: prxntf("fld ");   prxntf("32real"); r_m_( 0); break;
					   case 2: prxntf("fst ");   prxntf("32real"); r_m_( 0); break;
					   case 3: prxntf("fstp ");  prxntf("32real"); r_m_( 0); break;
					   case 4: prxntf("fldenv ");prxntf("14/28byte");r_m_( 0);break;
					   case 5: prxntf("fldcw "); prxntf("2byte");  r_m_( 0); break;
					   case 6: prxntf("fnstenv ");prxntf("14/28byte");r_m_( 0);break;
					   case 7: prxntf("fnstcw ");prxntf("2byte");  r_m_( 0); break;
					   default:	fatalError=145;
				   }
			}
			else
			{
			    if (i_mod<0xC8)       prxntf("fld st(%1d)",  i_mod-0xC0);
				else if (i_mod==0xC9) prxntf("fxch");
				else if (i_mod <0xD0) prxntf("fxch st(%1d)",  i_mod-0xC8);
				else
				{
				    switch(i_mod)
					{
					    case 0xD0: prxntf("fnop");      break;		
						case 0xE0: prxntf("fchs");		break;
						case 0xE1: prxntf("fabs");		break;
						case 0xE4: prxntf("ftst");		break;
						case 0xE5: prxntf("fxam");		break;	
						case 0xE8: prxntf("fld1");		break;
						case 0xE9: prxntf("fldl2t");	break;
						case 0xEA: prxntf("fldl2e");	break;
						case 0xEB: prxntf("fldpi");		break;
						case 0xEC: prxntf("fldlg2");	break;
						case 0xED: prxntf("fldln2");	break;
						case 0xEE: prxntf("fldz");		break;
						case 0xF0: prxntf("f2xm1");		break;
						case 0xF1: prxntf("fyl2x");		break;
						case 0xF2: prxntf("fptan");		break;
						case 0xF3: prxntf("fpatan");	break;
						case 0xF4: prxntf("fxtract");	break;
						case 0xF5: prxntf("fprem1");	break;
						case 0xF6: prxntf("fdecstp");	break;
						case 0xF7: prxntf("fincstp");	break;
						case 0xF8: prxntf("fprem");		break;
						case 0xF9: prxntf("fyl2xp1");	break;
						case 0xFA: prxntf("fsqrt");		break;
						case 0xFB: prxntf("fsincos");	break;
						case 0xFC: prxntf("frndint");	break;
						case 0xFD: prxntf("fscale");	break;
						case 0xFE: prxntf("fsin");		break;
						case 0xFF: prxntf("fcos");		break;
						default:   fatalError=202;
					}
				}
			}
			break;
		case 0xDA: 
			if (i_mod<0xC0)
			{
			       switch(regTable[i_mod])
				   {
				       case 0: prxntf("fiadd ");  r_m_(rr); break;
					   case 1: prxntf("fimul ");  r_m_(rr); break;
					   case 2: prxntf("ficom ");  r_m_(rr); break;
					   case 3: prxntf("ficomp "); r_m_(rr); break;
					   case 4: prxntf("fisub ");  r_m_(rr); break;
					   case 5: prxntf("fisubr "); r_m_(rr); break;
					   case 6: prxntf("fidiv ");  r_m_(rr); break;
					   case 7: prxntf("fidivr "); r_m_(rr); break;
					   default:	fatalError=204;
				   }
			}
			else
			{
			    if (i_mod<0xC8)       prxntf("fcmovb st(0), st(%1d)", i_mod-0xC0);
				else if (i_mod <0xD0) prxntf("fcmove st(0), st(%1d)", i_mod-0xC8);
				else if (i_mod <0xD8) prxntf("fcmovbe st(0), st(%1d)",i_mod-0xD0);
				else if (i_mod <0xE0) prxntf("fcmovu st(0), st(%1d)", i_mod-0xD8);
				else if (i_mod==0xE9) prxntf("fucompp");
			}
			break;
		case 0xDB: 
			if (i_mod<0xC0)
			{
			       switch(regTable[i_mod])
				   {
				       case 0: prxntf("fild ");  r_m_(rr); break;
					   case 2: prxntf("fist ");  r_m_(rr); break;
					   case 3: prxntf("fistp "); r_m_(rr); break;
					   case 5: prxntf("fld ");  prxntf("80real"); r_m_( 0); break;
					   case 7: prxntf("fstp "); prxntf("80real"); r_m_( 0); break;
					   default:	fatalError=206;
				   }
			}
			else
			{
			    if (i_mod<0xC8)       prxntf("fcmovnb st(0), st(%1d)", i_mod-0xC0);
				else if (i_mod <0xD0) prxntf("fcmovne st(0), st(%1d)", i_mod-0xC8);
				else if (i_mod <0xD8) prxntf("fcmovnbe st(0), st(%1d)",i_mod-0xD0);
				else if (i_mod <0xE0) prxntf("fcmovnu st(0), st(%1d)", i_mod-0xD8);
				else if (i_mod==0xE2) prxntf("fnclex");
				else if (i_mod==0xE3) prxntf("fninit");
				else if (i_mod <0xE8) fatalError=208;
				else if (i_mod <0xF0) prxntf("fucomi st(0), st(%1d)", i_mod-0xE8);
				else if (i_mod <0xF8) prxntf("fcomi st(0), st(%1d)", i_mod-0xF0);
			}
			break;
		case 0xDC: 
			if (i_mod<0xC0)
			{
			       switch(regTable[i_mod])
				   {
				       case 0: prxntf("fadd "); prxntf("64real"); r_m_( 0); break;
					   case 1: prxntf("fmul "); prxntf("64real"); r_m_( 0); break;
					   case 2: prxntf("fcom "); prxntf("64real"); r_m_( 0); break;
					   case 3: prxntf("fcomp ");prxntf("64real"); r_m_( 0); break;
					   case 4: prxntf("fsub "); prxntf("64real"); r_m_( 0); break;
					   case 5: prxntf("fsubr ");prxntf("64real"); r_m_( 0); break;
					   case 6: prxntf("fdiv "); prxntf("64real"); r_m_( 0); break;
					   case 7: prxntf("fdivr ");prxntf("64real"); r_m_( 0); break;
					   default:	fatalError=210;
				   }
			}
			else
			{
			    if (i_mod<0xC8)       prxntf("fadd st(0), st(%1d)", i_mod-0xC0);
				else if (i_mod <0xD0) prxntf("fmul st(0), st(%1d)", i_mod-0xC8);
				else if (i_mod <0xE0) fatalError=212;
				else if (i_mod <0xE8) prxntf("fsubr st(0), st(%1d)",i_mod-0xE0);
				else if (i_mod <0xF0) prxntf("fsub st(0), st(%1d)", i_mod-0xD8);
				else if (i_mod <0xF8) prxntf("fdivr st(0), st(%1d)", i_mod-0xF0);
				else                  prxntf("fdiv st(0), st(%1d)", i_mod-0xF8);
			}
			break;
		case 0xDD: 
			if (i_mod<0xC0)
			{
			       switch(regTable[i_mod])
				   {
				       case 0: prxntf("fld ");  prxntf("64real");   r_m_( 0);break;
					   case 2: prxntf("fst ");  prxntf("64real");   r_m_( 0);break;
					   case 3: prxntf("fstp "); prxntf("64real");   r_m_( 0);break;
					   case 4: prxntf("frstor");prxntf("94/108byte");r_m_( 0);break;
					   case 6: prxntf("fnsave ");prxntf("94/108byte");r_m_( 0);break;
					   case 7: prxntf("fnstsw ");prxntf("2byte"); r_m_( 0); break;
					   default:	fatalError=214;
				   }
			}
			else
			{
			    if (i_mod<0xC8)       prxntf("ffree st(%1d)", i_mod-0xC0);
				else if (i_mod <0xD0) fatalError=216;
				else if (i_mod <0xD8) prxntf("fst st(%1d)",   i_mod-0xD0);
				else if (i_mod <0xE0) prxntf("fstp st(%1d)",  i_mod-0xD8);
				else if (i_mod==0xE1) prxntf("fucom");
				else if (i_mod <0xE8) prxntf("fucom st(%1d)", i_mod-0xE0);
				else if (i_mod==0xE9) prxntf("fucomp");
				else if (i_mod <0xF0) prxntf("fucomp st(%1d)",i_mod-0xE8);
				else fatalError=218;
			}
			break;
		case 0xDE: 
			if (i_mod<0xC0)
			{
			       switch(regTable[i_mod])
				   {
				       case 0: prxntf("fiadd ");  prxntf("16int");r_m_( 0); break;
					   case 1: prxntf("fimul ");  prxntf("16int");r_m_( 0); break;
					   case 2: prxntf("ficom ");  prxntf("16int");r_m_( 0); break;
					   case 3: prxntf("ficomp "); prxntf("16int");r_m_( 0); break;
					   case 4: prxntf("fisub ");  prxntf("16int");r_m_( 0); break;
					   case 5: prxntf("fisubr "); prxntf("16int");r_m_( 0); break;
					   case 6: prxntf("fidiv ");  prxntf("16int");r_m_( 0); break;
					   case 7: prxntf("fidivr "); prxntf("16int");r_m_( 0); break;
					   default:	fatalError=220;
				   }
			}
			else
			{
			     if(i_mod==0xC1)       prxntf("faddp");
				 else if (i_mod <0xC8) prxntf("faddp st(%1d), st(0)", i_mod-0xC0);
				 else if (i_mod==0xC9) prxntf("fmulp");
				 else if (i_mod <0xD0) prxntf("fmulp st(%1d), st(0)", i_mod-0xC8);
				 else if (i_mod==0xD9) prxntf("fcompp");
				 else if (i_mod <0xE0) fatalError=222;
				 else if (i_mod==0xE1) prxntf("fsubrp");
				 else if (i_mod <0xE8) prxntf("fsubrp st(%1d), st(0)", i_mod-0xE0);
				 else if (i_mod==0xE9) prxntf("fsubp");
				 else if (i_mod <0xF0) prxntf("fsubp st(%1d), st(0)", i_mod-0xE8);
				 else if (i_mod==0xF1) prxntf("fdivrp");
				 else if (i_mod <0xF8) prxntf("fdivrp st(%1d), st(0)", i_mod-0xF0);
				 else if (i_mod==0xF9) prxntf("fdivp");
				 else                  prxntf("fdivp st(%1d), st(0)", i_mod-0xF8);
			}
			break;
		case 0xDF: 
			if (i_mod<0xC0)
			{
			       switch(regTable[i_mod])
				   {
				       case 0: prxntf("fild ");  prxntf("16int");r_m_( 0); break;
					   case 2: prxntf("fist ");  prxntf("16int");r_m_( 0); break;
					   case 3: prxntf("fistp "); prxntf("16int");r_m_( 0); break;
					   case 4: prxntf("fbld ");  prxntf("80bcd");r_m_( 0); break;
					   case 5: prxntf("fild ");  prxntf("64int");r_m_( 0); break;
					   case 6: prxntf("fbstp "); prxntf("80bcd");r_m_( 0); break;
					   case 7: prxntf("fistp "); prxntf("64int");r_m_( 0); break;
					   default:	                 fatalError=224;
				   }
			}
			else
			{
			     if(i_mod <0xDF)       fatalError=226;
				 else if (i_mod==0xE0) prxntf("fnstsw ax");
				 else if (i_mod <0xE8) fatalError=228;
				 else if (i_mod <0xF0) prxntf("fucomip st(0), st(%1d)", i_mod-0xE8);
				 else if (i_mod <0xF8) prxntf("fcomip st(0), st(%1d)", i_mod-0xF0);
				 else                  fatalError=230;
			}
			break;
        default:                       fatalError=232;
    }
	return 0;
} /* print12case() */
 

int print13case()
{
int    rr;

	if (operandOveride) rr=16; else rr=32;

	switch(regTable[i_mod])
	{							 
	    case 0: prxntf("inc ");            r_m_(rr); break;
	    case 1: prxntf("dec ");            r_m_(rr); break;
	    case 2: prxntf("call ");    
		        if (nextMode)
				{
				     ref = r_m_(rr);
				    class=13;
					if (i_mod>=0xD0)
					{
					    reg=rmTable[i_mod];
					    if (temppos[reg]+128>cur_position) 
						ref=tempref[reg]; temppos[reg]=cur_position;
					}
		        }
				else
				    if (!printName(cur_position)) r_m_(rr);
				break;
	    case 3: prxntf("call ");     ref = m16_32(); class=17; 
		        break;
	    case 4: prxntf("jmp ");      
				if (nextMode)
				{
				    ref = r_m_(32); 
					if (gotJmpRef) 
					{   class=128+5; gotJmpRef=0;  } 
					else class=5;
					// it is OK to mark anchor...because it will not be erased easily??
					lastAnchor=cur_position+i_col-1;
					if (nextMode)
					*(unsigned char *)((int)lpMap+a_loc_save+delta+i_col-1) |= 0x80;
					//leaveFlag=cur_position+i_col;
				}
				else 
					if (!printName(cur_position)) r_m_(rr);
				break;
	    case 5: prxntf("jmp ");      ref = m16_32();   class = 9; 
		        break;
	    case 6: prxntf("push ");     ref =  r_m_(rr);
		        class = 513;
		// well I really don't know it is reasonably safe to do this.
		// I think when we push some (possible) address references into stack
		// there is strong reason to do so. that's why i am doing this. i guess...
		        break;
	    default: fatalError=234;
	}  
	return 0;
}

int print14case()
{
int    rr;

	if (operandOveride) rr=16; else rr=32;

    if (i_opcode==0xF6)
	{
	    switch(regTable[i_mod])
		{
		    case 0: prxntf("test "); r_m_( 8); prxntf(", "); print_i_byte(); break;
			case 2:	prxntf("not ");  r_m_( 8); break;
			case 3:	prxntf("neg ");  r_m_( 8); break;
			case 4:	prxntf("mul ");  r_m_( 8); break;
			case 5:	prxntf("imul "); r_m_( 8); break;
			case 6:	prxntf("div ");  r_m_( 8); break;
			case 7:	prxntf("idiv "); r_m_( 8); break;
			default: fatalError=303;
		}
	}
	else if (i_opcode==0xF7)
	{
	    switch(regTable[i_mod])
		{
		    case 0:	prxntf("test "); r_m_(rr); prxntf(", "); print_i_dword(); break;
			case 2:	prxntf("not ");  r_m_(rr); break;
			case 3:	prxntf("neg ");  r_m_(rr); break;
			case 4:	prxntf("mul ");  r_m_(rr); break;
			case 5:	prxntf("imul "); r_m_(rr); break;
			case 6:	prxntf("div ");  r_m_(rr); break;
			case 7:	prxntf("idiv "); r_m_(rr); break;
			default: fatalError=00305;
		}
	}
	else fatalError=307;
	return 0;
}

int print15case()
{
int    rr;

	if (operandOveride) rr=16; else rr=32;

    if (i_opcode==0xD9)
	{
	    if (regTable[i_mod]==6)
		{
		    prxntf("fstenv 14/28byte"); r_m_(rr);
		}
		else if (regTable[i_mod]==7)
		{
		    prxntf("fstcw 2byte");      r_m_(rr);
		}
		else fatalError=309;
	}
	else if (i_opcode==0xDB)
	{
	    if (i_mod==0xE2)      prxntf("fclex ");
		else if (i_mod==0xE3) prxntf("finit ");
		else fatalError=311;
	}
	else if (i_opcode==0xDD)
	{
	    if (regTable[i_mod]==6)
		{
		    prxntf("fsave 94/108byte"); r_m_(rr);
		}
		else if (regTable[i_mod]==7)
		{
		    prxntf("fstsw 2byte");      r_m_(rr);
		}
		else fatalError=313;
	}
	else if (i_opcode==0xDF)
	{
	    if (i_mod==0xE0) prxntf("fstsw ax ");
		else fatalError=315;
	}
	else if (i_opcode==0x9B) prxntf("wait");
	else fatalError=317;
	return 0;
}

int print16case()
{
int    rr;

	if (operandOveride) rr=16; else rr=32;

    if (prefixStack[i_psp-1]==0xF2)
	{
	    switch(i_opcode)
		{
		    case 0xA6: prxntf("repne cmpsb"); break;
			case 0xA7: if (operandOveride) prxntf("repne cmpsw");
				       else                prxntf("repne cmpsd");     break;
			case 0xAE: prxntf("repne scasb"); break;
			case 0xAF: if (operandOveride) prxntf("repne scasw");
				       else                prxntf("repne scasd");     break;
			default: fatalError=319;
		}
	}
	else if (prefixStack[i_psp-1]==0xF3)
	{
	    switch(i_opcode)
		{
		    case 0x6C: prxntf("rep ins byte"); 
			           r_m_( 8);prxntf(", port[dx]"); 
			           break;
			case 0x6D: if (operandOveride) prxntf("rep ins word");
				       else                prxntf("rep ins dword");
					   r_m_(rr);prxntf(", port[dx]"); 
					   break; 
			case 0x6E: prxntf("rep outs port[dx], byte");  
			           r_m_( 8); 
			           break;
			case 0x6F: if (operandOveride) prxntf("rep outs port[dx], word");
			           else prxntf("rep outs port[dx], dword"); 
			           r_m_(rr); 
					   break;
			case 0xA4: prxntf("rep movsb");                           
			           break;
			case 0xA5: if (operandOveride) prxntf("rep movsw");
				       else                prxntf("rep movsd");       
					   break;
			case 0xA6: prxntf("repe cmpsb");                          
			           break;
			case 0xA7: if (operandOveride) prxntf("repe cmpsw");
				       else                prxntf("repe cmpsd");      
					   break;
			case 0xAA: prxntf("rep stosb");                           
			           break;
			case 0xAB: if (operandOveride) prxntf("rep stosw");
				       else                prxntf("rep stosd");       
					   break;
			case 0xAC: prxntf("rep lods al");                         
			           break;
			case 0xAD: if (operandOveride) prxntf("rep lods ax");
				       else                prxntf("rep lods eax");    
					   break;
			case 0xAE: prxntf("repe scasb");                          
			           break;
			case 0xAF: if (operandOveride) prxntf("repe scasw");
				       else                prxntf("repe scasd");      
					   break; 
			default: fatalError=321;
		}
	}
	else fatalError=323;
	return 0;
}

/* *************************************************************** */
/* *************************************************************** */
/*         2 byte opcode printing starts here!                     */
/* *************************************************************** */
/* *************************************************************** */
int print20case()
{
    switch(i_opcode)
	{
	    case 0x06:  prxntf("clts");       break;
		case 0x08:  prxntf("invd");       break;
		case 0x09:  prxntf("wbinvd");     break; 
		case 0x0B:  prxntf("ud2");        break;   
		case 0x30:  prxntf("wrmsr");	  break;
		case 0x31:  prxntf("rdtsc");	  break;
		case 0x32:  prxntf("rdmsr");	  break;
		case 0x33:  prxntf("rdpmc");	  break;
		case 0x77:  prxntf("emms");       break;   
		case 0xA0:  prxntf("push fs"); break;   
		case 0xA1:  prxntf("pop fs");     break;  
		case 0xA2:  prxntf("cpuid");      break;   
		case 0xA8:  prxntf("push gs");    break;   
		case 0xA9:  prxntf("pop gs");     break;   
		case 0xAA:  prxntf("rsm");	      break;   
		case 0xC8:  prxntf("bswap eax");  break;   
		case 0xC9:  prxntf("bswap ecx");  break;   
		case 0xCA:  prxntf("bswap edx");  break;   
		case 0xCB:  prxntf("bswap ebx");  break;   
		case 0xCC:  prxntf("bswap esp");  break;   
		case 0xCD:  prxntf("bswap ebp");  break;   
		case 0xCE:  prxntf("bswap esi");  break;   
		case 0xCF:  prxntf("bswap edi");  break;   
		default:    fatalError=325;
	}
	return 0;
}

int print21case()
{
    switch(i_opcode)
	{
		case 0x80:  prxntf("jo ");	break;
		case 0x81:  prxntf("jno ");	break;
		case 0x82:  prxntf("jb ");	break;
		case 0x83:  prxntf("jae ");	break;
		case 0x84:  prxntf("je ");	break;
		case 0x85:  prxntf("jne ");	break;
		case 0x86:  prxntf("jbe ");	break;
		case 0x87:  prxntf("ja ");	break;
		case 0x88:  prxntf("js ");	break;
		case 0x89:  prxntf("jns ");	break;
		case 0x8A:  prxntf("jpe ");	break;
		case 0x8B:  prxntf("jpo ");	break;
		case 0x8C:  prxntf("jl ");	break;
		case 0x8D:  prxntf("jge ");	break;
		case 0x8E:  prxntf("jle ");	break;
		case 0x8F:  prxntf("jg ");	break;
		default:    fatalError=327;
	}	
	ref = print_rel32();  class =  4; 
	return 0;
}

int print22case()
{
int    rr;

	if (operandOveride) rr=16; else rr=32;

    switch(i_opcode)
	{
		case 0x02: prxntf("lar ");       r___(rr);prxntf(", ");r_m_(rr);break;    
		case 0x03: prxntf("lsl ");       r___(rr);prxntf(", ");r_m_(rr);break;    
		case 0x20: prxntf("mov "); r___(rr);prxntf(", cr%1d", rmTable[i_mod]);
		                                                                break;    
		case 0x21: prxntf("mov "); r___(rr);prxntf(", dr%1d", rmTable[i_mod]); 
		                                                                break;   
		case 0x22: prxntf("mov cr%1d, ",rmTable[i_mod]);       r___(rr);break;    
		case 0x23: prxntf("mov dr%1d, ",rmTable[i_mod]);       r___(rr);break;    
		case 0x40: prxntf("cmovo ");     r___(rr);prxntf(", ");r_m_(rr);break;    
		case 0x41: prxntf("cmovno ");    r___(rr);prxntf(", ");r_m_(rr);break;    
		case 0x42: prxntf("cmovb ");     r___(rr);prxntf(", ");r_m_(rr);break;    
		case 0x43: prxntf("cmovae ");    r___(rr);prxntf(", ");r_m_(rr);break;    
		case 0x44: prxntf("cmove ");     r___(rr);prxntf(", ");r_m_(rr);break;    
		case 0x45: prxntf("cmovne ");    r___(rr);prxntf(", ");r_m_(rr);break;    
		case 0x46: prxntf("cmovbe ");    r___(rr);prxntf(", ");r_m_(rr);break;    
		case 0x47: prxntf("cmova ");     r___(rr);prxntf(", ");r_m_(rr);break;    
		case 0x48: prxntf("cmovs ");     r___(rr);prxntf(", ");r_m_(rr);break;    
		case 0x49: prxntf("cmovns ");    r___(rr);prxntf(", ");r_m_(rr);break;    
		case 0x4A: prxntf("cmovpe ");    r___(rr);prxntf(", ");r_m_(rr);break;    
		case 0x4B: prxntf("cmovpo ");    r___(rr);prxntf(", ");r_m_(rr);break;    
		case 0x4C: prxntf("cmovl ");     r___(rr);prxntf(", ");r_m_(rr);break;    
		case 0x4D: prxntf("cmovge ");    r___(rr);prxntf(", ");r_m_(rr);break;    
		case 0x4E: prxntf("cmovle ");    r___(rr);prxntf(", ");r_m_(rr);break;    
		case 0x4F: prxntf("cmovg ");     r___(rr);prxntf(", ");r_m_(rr);break;    
		case 0x60: prxntf("punpcklbw "); mm____();prxntf(", ");r_m_(64);break;    
		case 0x61: prxntf("punpcklwd "); mm____();prxntf(", ");r_m_(64);break;    
		case 0x62: prxntf("punpckldq "); mm____();prxntf(", ");r_m_(64);break;    
		case 0x63: prxntf("packsswb ");  mm____();prxntf(", ");r_m_(64);break;    
		case 0x64: prxntf("pcmpgtb ");   mm____();prxntf(", ");r_m_(64);break;    
		case 0x65: prxntf("pcmpgtw ");   mm____();prxntf(", ");r_m_(64);break;    
		case 0x66: prxntf("pcmpgtd ");   mm____();prxntf(", ");r_m_(64);break;    
		case 0x67: prxntf("packuswb ");  mm____();prxntf(", ");r_m_(64);break;    
		case 0x68: prxntf("punpckhbw "); mm____();prxntf(", ");r_m_(64);break;    
		case 0x69: prxntf("punpckhwd "); mm____();prxntf(", ");r_m_(64);break;    
		case 0x6A: prxntf("punpckhdq "); mm____();prxntf(", ");r_m_(64);break;    
		case 0x6B: prxntf("packssdw ");  mm____();prxntf(", ");r_m_(64);break;    
		case 0x6E: prxntf("movd ");      mm____();prxntf(", ");r_m_(rr);break;    
		case 0x6F: prxntf("movq ");      mm____();prxntf(", ");r_m_(64);break;    
		case 0x74: prxntf("pcmpeqb ");   mm____();prxntf(", ");r_m_(64);break;    
		case 0x75: prxntf("pcmpeqw ");   mm____();prxntf(", ");r_m_(64);break;    
		case 0x76: prxntf("pcmpeqd ");   mm____();prxntf(", ");r_m_(64);break;    
		case 0x7E: prxntf("movd ");      r_m_(rr);prxntf(", ");mm____();break;    
		case 0x7F: prxntf("movq ");      r_m_(64);prxntf(", ");mm____();break;    
		case 0x90: prxntf("seto ");      r_m_( 8);                      break; 
		case 0x91: prxntf("setno ");     r_m_( 8);                      break; 
		case 0x92: prxntf("setb ");      r_m_( 8);                      break; 
		case 0x93: prxntf("setae ");     r_m_( 8);                      break; 
		case 0x94: prxntf("sete ");      r_m_( 8);                      break; 
		case 0x95: prxntf("setne ");     r_m_( 8);                      break; 
		case 0x96: prxntf("setbe ");     r_m_( 8);                      break; 
		case 0x97: prxntf("seta ");      r_m_( 8);                      break; 
		case 0x98: prxntf("sets ");      r_m_( 8);                      break; 
		case 0x99: prxntf("setns ");     r_m_( 8);                      break; 
		case 0x9A: prxntf("setpe ");     r_m_( 8);                      break; 
		case 0x9B: prxntf("setpo ");     r_m_( 8);                      break; 
	    case 0x9C: prxntf("setl ");      r_m_( 8);                      break; 
        case 0x9D: prxntf("setge ");     r_m_( 8);                     	break; 
        case 0x9E: prxntf("setle ");     r_m_( 8);                     	break; 
		case 0x9F: prxntf("setg ");      r_m_( 8);                     	break; 
		case 0xA3: prxntf("bt ");        r_m_(rr);prxntf(", ");r___(rr);break;    
		case 0xA5: prxntf("shld ");      r_m_(rr);prxntf(", ");r___(rr);
		                                          prxntf(", cl");       break;
		case 0xAB: prxntf("bts ");       r_m_(rr);prxntf(", ");r___(rr);break;    
		case 0xAD: prxntf("shrd ");      r_m_(rr);prxntf(", ");r___(rr);      
		                                          prxntf(", cl");       break;
		case 0xAF: prxntf("imul ");      r___(rr);prxntf(", ");r_m_(rr);break;    
		case 0xB0: prxntf("cmpxchg ");   r_m_( 8);prxntf(", ");r___( 8);break;    
		case 0xB1: prxntf("cmpxchg ");   r_m_(rr);prxntf(", ");r___(rr);break;    
		case 0xB2: prxntf("lss ");       r___(rr);prxntf(", ");m16_32();break;   
		case 0xB3: prxntf("btr ");       r_m_(rr);prxntf(", ");r___(rr);break;    
		case 0xB4: prxntf("lfs ");       r___(rr);prxntf(", ");m16_32();break;   
		case 0xB5: prxntf("lgs ");       r___(rr);prxntf(", ");m16_32();break;   
		case 0xB6: prxntf("movzx ");     r___(rr);prxntf(", ");r_m_( 8);break;    
		case 0xB7: prxntf("movzx ");     r___(rr);prxntf(", ");r_m_(16);break;    
		case 0xBB: prxntf("btc ");       r_m_(rr);prxntf(", ");r___(rr);break;    
		case 0xBC: prxntf("bsf ");       r___(rr);prxntf(", ");r_m_(rr);break;    
		case 0xBD: prxntf("bsr ");	     r___(rr);prxntf(", ");r_m_(rr);break;    
		case 0xBE: prxntf("movsx ");     r___(rr);prxntf(", ");r_m_( 8);break;    
		case 0xBF: prxntf("movsx ");     r___(rr);prxntf(", ");r_m_(16);break;    
		case 0xC0: prxntf("xadd ");      r_m_( 8);prxntf(", ");r___( 8);break;    
		case 0xC1: prxntf("xadd ");      r_m_(rr);prxntf(", ");r___(rr);break;    
		case 0xD1: prxntf("psrlw ");     mm____();prxntf(", ");r_m_(64);break;   
		case 0xD2: prxntf("psrld ");     mm____();prxntf(", ");r_m_(64);break;   
		case 0xD3: prxntf("psrlq ");     mm____();prxntf(", ");r_m_(64);break;   
		case 0xD5: prxntf("pmullw ");    mm____();prxntf(", ");r_m_(64);break;   
		case 0xD8: prxntf("psubusb ");   mm____();prxntf(", ");r_m_(64);break;   
		case 0xD9: prxntf("psubusw ");   mm____();prxntf(", ");r_m_(64);break;   
		case 0xDB: prxntf("pand ");      mm____();prxntf(", ");r_m_(64);break;   
		case 0xDC: prxntf("paddusb ");   mm____();prxntf(", ");r_m_(64);break;   
		case 0xDD: prxntf("paddusw ");   mm____();prxntf(", ");r_m_(64);break;   
		case 0xDF: prxntf("pandn ");     mm____();prxntf(", ");r_m_(64);break;   
		case 0xE1: prxntf("psraw ");     mm____();prxntf(", ");r_m_(64);break;   
		case 0xE2: prxntf("psrad ");     mm____();prxntf(", ");r_m_(64);break;   
		case 0xE5: prxntf("pmulhw ");    mm____();prxntf(", ");r_m_(64);break;   
		case 0xE8: prxntf("psubsb ");    mm____();prxntf(", ");r_m_(64);break;   
		case 0xE9: prxntf("psubsw ");    mm____();prxntf(", ");r_m_(64);break;   
		case 0xEB: prxntf("por ");       mm____();prxntf(", ");r_m_(64);break;   
		case 0xEC: prxntf("paddsb ");    mm____();prxntf(", ");r_m_(64);break;   
		case 0xED: prxntf("paddsw ");    mm____();prxntf(", ");r_m_(64);break;   
		case 0xEF: prxntf("pxor ");      mm____();prxntf(", ");r_m_(64);break;   
		case 0xF1: prxntf("psllw ");     mm____();prxntf(", ");r_m_(64);break;   
		case 0xF2: prxntf("pslld ");     mm____();prxntf(", ");r_m_(64);break;   
		case 0xF3: prxntf("psllq ");     mm____();prxntf(", ");r_m_(64);break;   
		case 0xF5: prxntf("pmaddwd ");   mm____();prxntf(", ");r_m_(64);break;   
		case 0xF8: prxntf("psubb ");     mm____();prxntf(", ");r_m_(64);break;   
		case 0xF9: prxntf("psubw ");     mm____();prxntf(", ");r_m_(64);break;   
		case 0xFA: prxntf("psubd ");     mm____();prxntf(", ");r_m_(64);break;   
		case 0xFC: prxntf("paddb ");     mm____();prxntf(", ");r_m_(64);break;   
		case 0xFD: prxntf("paddw ");     mm____();prxntf(", ");r_m_(64);break;   
		case 0xFE: prxntf("paddd ");     mm____();prxntf(", ");r_m_(64);break;
		default: fatalError=329;
	}
	return 0;
}

int print23case()
{
int    rr;

	if (operandOveride) rr=16; else rr=32;

    if (i_opcode==0xA4) 
	{
	    prxntf("shld "); r_m_(rr);
		prxntf(", ");    r___(rr);
		prxntf(", ");    print_i_byte();
	}
	else
	{
		prxntf("shrd "); r_m_(rr);
		prxntf(", ");    r___(rr);
		prxntf(", ");    print_i_byte();
	}
	return 0;
}

int print24case()
{
int    rr;

	if (operandOveride) rr=16; else rr=32;

    if (i_opcode==0x00)
	{	
	    switch(regTable[i_mod])
		{
		    case 0: prxntf("sldt "); r_m_(rr); break;           
		    case 1: prxntf("str ");  r_m_(16); break;
		    case 2: prxntf("lldt "); r_m_(16); break;
		    case 3: prxntf("ltr ");  r_m_(16); break;
			case 4: prxntf("verr "); r_m_(16); break;
		    case 5: prxntf("verw "); r_m_(16); break;
			default: fatalError=331;
		}
	}
	else if (i_opcode==0x01)
	{
	    switch(regTable[i_mod])
		{
		    case 0: prxntf("sgdt ");   m_____(); break;
		    case 1: prxntf("sidt ");   m_____(); break;
		    case 2: prxntf("lgdt ");   m16_32(); break;
		    case 3: prxntf("lidt ");   m16_32(); break;
		    case 4: prxntf("smsw ");   r_m_(rr); break;
		    case 6: prxntf("lmsw ");   r_m_(16); break;
		    case 7: prxntf("invlpg "); m_____(); break;
			default: fatalError=333;
		}
	}
	else if (i_opcode==0xC7 && regTable[i_mod]==1)
	{
	    prxntf("comxchg8b 64bit");
		m_____();
	}
	else fatalError=335;
	return 0;
}

int print25case()
{
int    k;
int    rr;

	if (operandOveride) rr=16; else rr=32;

    k = regTable[i_mod];
    if (i_opcode==0x71)
	{
	    if (k==2) 
		{
		    prxntf("psrlw "); mm____(); prxntf(", "); print_i_byte();
		}
		else if (k==4)
		{
		    prxntf("psraw "); mm____(); prxntf(", "); print_i_byte();
		}
		else if (k==6)
		{
		    prxntf("psllw "); mm____(); prxntf(", "); print_i_byte();
		}
		else fatalError=337;
	}
	else if (i_opcode==0x72)
	{
	    if (k==2)
		{
		    prxntf("psrld "); mm____(); prxntf(", "); print_i_byte();
		}
		else if (k==4)
		{
		    prxntf("psrad "); mm____(); prxntf(", "); print_i_byte();
		}
		else if (k==6)
		{
		    prxntf("pslld "); mm____(); prxntf(", "); print_i_byte();
		}
		else fatalError=339;
	}
	else if (i_opcode==0x73)
	{
	    if (k==2)
	    {
		    prxntf("psrlq "); mm____(); prxntf(", "); print_i_byte();
	    }
	    else if (k==6)
	    {
		    prxntf("psllq "); mm____(); prxntf(", "); print_i_byte();
	    }
	    else fatalError=341;
	}
	else if (i_opcode==0xBA)
	{
	    if (k==4)
		{
		    prxntf("bt ");    r_m_(rr); prxntf(", "); print_i_byte32();
		}
		else if (k==5)
		{
		    prxntf("bts ");   r_m_(rr); prxntf(", "); print_i_byte32();
		}
		else if (k==6)
		{
		    prxntf("btr ");   r_m_(rr); prxntf(", "); print_i_byte32();
		}
		else if (k==7)
		{
		    prxntf("btc ");   r_m_(rr); prxntf(", "); print_i_byte32();
		}
		else fatalError=343;
	}
	else fatalError=345;
	return 0;
}